=== modified file 'AUTHORS'
--- AUTHORS	2009-03-07 09:12:49 +0000
+++ AUTHORS	2011-01-26 02:48:39 +0000
@@ -1,5 +1,5 @@
 Suren A. Chilingaryan <csa@dside.dyndns.org>
 
-KATRIN code:
-    Sebastian Voecking
-
+KATRIN code by Sebastian Voecking
+Support for iPhone and iPad by Toni Pirhonen 
+Download Manager by Aki Rimpelainen

=== modified file 'ToDo'
--- ToDo	2010-09-14 16:13:08 +0000
+++ ToDo	2011-01-26 02:48:39 +0000
@@ -3,7 +3,18 @@
  - We are currently just skipping databases which are failed to connect to the
  data source (request.pph/GetSources/catch block). In case if we are caching the
  data this prevents administrator from getting information about the problems.
- 
+ - We can't really at the moment use non [\w\d_] symbols in gids if md5 
+ postfixes are switched off. Otherwise, this symbols are stripped from the 
+ postfixes (for the sake of table names) and then the check for cached tables
+ is failing (it reconstructs gid basing on the table names). Some, other things
+ may fail as well.
+ For the check, we can try to ignore the inappropriate symbols (only if md5 is
+ switched off). So, the stripping should be performed by caching code.
+ - If we change use_subsecond flag without dropping the cache, the ADEI will
+ report channel inconsistency (not clarifying the issue). Since, we will get
+ two extra columns in the caching table. The proper error message should be
+ reported in this case.
+
 
 Easy ToDo
 =========
@@ -41,6 +52,10 @@
     ! The detector name should appear on the plot after ASEC: We can implement it
     with configurable callback to display information (assign).
     * Operations on time series: add, Substract, and multiply by constast
+    * no vsegda nugno sokhranyat rezultati; delat nebolshie kommentarii; chto bi 
+    vozvrashatsya pozdnee; sravnivat raznie sobitiya; no nikakikh protokolov ne 
+    ostaetsya; vspomni hbook-I; ves analiz ostavalsya; dage mogno bilo povtgorit 
+    posledovatelnost deistvij.
     
  - USA
     * Datetime picker produces current time in local timezone. Should be 

=== modified file 'admin/logview.php'
--- admin/logview.php	2008-06-30 19:22:34 +0000
+++ admin/logview.php	2011-01-26 02:48:39 +0000
@@ -60,7 +60,7 @@
 </script>
 
 <br/><a href="javascript:NewCal(null,'mmmddyyyy',false,24, selectDate)">
-    <img src="../images/cal.gif"/>
+    <img src="../images/cal.png"/>
 </a>
 <?
 

=== added file 'classes/email.php'
--- classes/email.php	1970-01-01 00:00:00 +0000
+++ classes/email.php	2011-01-26 02:48:39 +0000
@@ -0,0 +1,88 @@
+<?php
+class EMAIL{
+    function __construct() {
+        global $ADEI_ROOTDIR;
+        require_once($ADEI_ROOTDIR .'/includes/PHPMailer-Lite_v5.1/class.phpmailer-lite.php');
+    }
+    
+    function createPNG($props){
+        try {
+            $req = new DATARequest();
+            $fullpath = $ADEI_ROOTDIR . "tmp/tmpimg/";
+            //$fullpath .= $pic;
+            $picname;
+            foreach($props as $key => $value)
+            {
+                $req->SetProp($key,$value);
+                if ($key=='db_server' || $key=='db_name' || $key == 'window')
+                {
+                    $picname .= $value ."-";
+                }
+            }
+            $picname .= rand(1,200);
+            $picname .= ".png";
+            $fullpath .= $picname;
+
+            $draw = $req->CreatePlotter();
+            $draw->Create();
+            $draw->Save($fullpath);
+            return $fullpath;
+        }
+        catch (ADEIException $ex) {
+            $ex->logInfo(NULL, $draw);
+            return "FAILED";
+        }
+    }
+    
+    function listSensors($opts){
+        $req = new DATARequest($opts);
+        $reader = $req->CreateReader();
+        $groups = $reader->GetGroups();
+        $grouplist = $reader->GetGroupList();
+        $mask = new MASK($opts);
+        $i=0;
+        foreach($grouplist as $group => $details){
+            $itemlist[$det['gid']] = $reader->GetItemList($groups[$i],$mask);
+            $i++;
+        }
+        foreach($itemlist as $gid => $items) {
+            if (!is_numeric($gid)) {
+                foreach($items as $key => $item ) {
+                    $details['groups'][$gid][$key] = array("id" =>"{$item['id']}", "name" => "{$item['name']}");
+                }
+            }
+        }
+        return $details;
+    }
+    
+    function createFolder(){
+        $dir = $ADEI_ROOTDIR .'tmp/tmpimg';
+        if (!@is_dir($dir)) {
+            if (@mkdir($dir, 0777, true)){
+                @chmod($dir, 0777);
+                return "Success";
+            }
+            else return "Failure";
+        }
+        else return "Success";
+    }
+    
+    function sendMail($props){
+        $mail = new PHPMailerLite(); // defaults to using php "Sendmail" (or Qmail, depending on availability)
+        $mail->IsMail(); // telling the class to use native PHP mail()
+        try {
+            $mail->SetFrom('adei@adei.com', 'Adei User');
+            $mail->AddAddress($props['email'], 'User');
+            $mail->Subject = 'Adei Graph';
+            $mail->MsgHTML($props['message']);
+            $mail->AddAttachment($props['attachement']); // attachment
+            $mail->Send();
+            return $props['message'];
+        } catch (phpmailerException $e) {
+            return 'phpmailerException';//$e->errorMessage(); //Pretty error messages from PHPMailer
+        } catch (Exception $e) {
+            return 'exception';//$e->getMessage();//Boring error messages from anything else!
+        }
+    }
+}
+?>
\ No newline at end of file

=== added file 'iadei.css'
--- iadei.css	1970-01-01 00:00:00 +0000
+++ iadei.css	2011-01-26 02:48:39 +0000
@@ -0,0 +1,871 @@
+html, body {
+	-webkit-text-size-adjust:none;
+	-webkit-touch-callout:none;
+	font-family:Helvetica, Arial, Verdana, sans-serif;
+    overflow:		hidden;
+        margin: 		0px; 
+    padding: 		0px;
+    
+/*    
+    This will broke resizing of graph in IE6 (IE7 - OK), but absense of
+    it brokes legend popups everythere. Moving to '.all' looks to solve
+    all problems.
+
+    width:		100%;
+*/
+}
+
+.all {
+    margin: 		0px; 
+    padding: 		0px;
+}
+.settingspage {
+	width: 100%;
+	height: 100%;
+	overflow: auto;
+}
+.settingscontent{
+	width: 100%;
+	height: 100%;
+	overflow: auto;
+	padding-top: 15px;
+}
+
+
+.ilist > li{
+	display: block;
+	margin-right: 15px;
+   	padding: 8px 12px 8px 10px;
+    border: 1px solid #E0E0E0;
+   	text-decoration: none;
+   	color: inherit;
+   	list-style:none;
+}
+.ilist > li:first-child{
+	display: block;
+	margin-top: 10px;
+	margin-bottom: 0px;
+	margin-right: 15px;
+   	padding: 8px 12px 8px 10px;
+    border: 1px solid #E0E0E0;
+   	text-decoration: none;
+   	color: inherit;
+   	list-style:none;
+}
+
+table, tr, td, div, body {
+    margin:		0;
+    padding:		0;
+    border:		0;
+}
+
+td {
+    vertical-align: 	top;
+}
+
+
+.settingsheading {
+	border: 0;
+	margin: 0;
+	text-align: center;
+	height: 30px;
+	padding-bottom:18px;
+}
+.headingtable{
+	border: 5;
+	margin: 0;
+	padding: 0;		
+}
+#shadow{
+	position: absolute; top:0;left:0; width:100%; height:100%; z-index:500; background:black; opacity:0.7; visibility:hidden;
+}
+
+#imgdiv{
+	position: absolute; top:0;left:0; width:100%; height:100%; z-index:500; background:black; visibility:hidden;
+}
+#controls{
+	position: absolute; top:0;left:0; width:100%; height:100%; z-index:500;  visibility:visible;
+
+}
+#emailform{
+	position: absolute; top:0;left:0; width:100%; height:100%; z-index:500;  background: white; visibility:hidden;
+}
+#sensorlist{
+	position: absolute; top:0;left:0; width:100%; height:100%; z-index:500;  background: white; visibility:hidden;
+}
+
+#show_controls_div{
+   background-image: url(images/showgraphcontrols.png);
+	width: 30px;
+	height: 30px;
+	float: right;
+	position: fixed;
+	right: 0px;
+	bottom: 0px;
+	z-index: 1;
+	/*for IE*/
+	filter:alpha(opacity=30);
+	//others
+	opacity:0.3;	
+	z-index:500;
+}
+
+.btn{
+  -moz-border-radius:5px;
+  -webkit-border-radius:5px;
+  -moz-box-shadow:0px 0px 2px rgba(0,0,0,0.4);
+  -webkit-box-shadow:0px 0px 2px rgba(0,0,0,0.4);
+  color:rgba(0,0,0,0.9);
+  text-shadow:1px 1px 0px rgba(255,255,255,0.8);
+  border:1px solid rgba(0,0,0,0.5);
+  
+  background:-webkit-gradient(linear,0% 0%,0% 100%,from(rgba(255,255,255,1)),to(rgba(185,185,185,1)));
+  background:-moz-linear-gradient(top,rgba(255,255,255,1),rgba(185,185,185,1));
+  height: 25px;
+  z-index: 700;
+  min-width: 50px;
+  max-width: 80px;
+  opacity:1;
+  filter:alpha(opacity=100);
+		
+}
+
+.iheader{
+   width: 100%;
+   height: 45px;    
+   padding:    5px;
+   -webkit-box-sizing: border-box;
+   border-bottom: 1px solid #2d3642;
+   background: url(images/headerbar.png) #6d84a2 repeat-x;
+}
+
+.ADEIhead{
+  margin-top: 10px;
+  font-size: 20px;
+  font-weight: bold;
+  text-shadow: rgba(0, 0, 0, 0.4) 0px -1px 0;
+  text-align: center;
+  text-overflow: ellipsis;
+  white-space: nowrap;
+  color: #fff;
+}
+.iheader > table {
+  position: absolute;
+  left: 10px;
+  height: 45px;
+  overflow: hidden;
+  margin-top: -5px;
+}
+.iheader > p {
+  position: absolute;
+  left: 45%;
+  height: 50px;
+  width: 50px;
+  margin: 1px 0 0 -75px;
+  overflow: hidden;
+}
+.rightside{
+  position: absolute;
+  left: 20%;
+  height: 45px;
+  width 100%;
+  padding-bottom: 5px;
+}
+
+.settingsbtn{
+  background-image: url(images/settings32.png); 
+  background-color:Transparent; 
+  width: 32px; 
+  height:32px;
+  border:hidden;
+  -webkit-tap-highlight-color: rgba(0,0,0,0);
+}
+.iheader > button {
+  -moz-border-radius:5px;
+  -webkit-border-radius:5px;
+  -moz-box-shadow:0px 0px 2px rgba(0,0,0,0.4);
+  -webkit-box-shadow:0px 0px 2px rgba(0,0,0,0.4);
+  margin: auto;
+  color:rgba(0,0,0,0.9);
+  text-shadow:1px 1px 0px rgba(255,255,255,0.8);
+  border:1px solid rgba(0,0,0,0.5);
+  
+  background:-webkit-gradient(linear,0% 0%,0% 100%,from(rgba(255,255,255,1)),to(rgba(185,185,185,1)));
+  background:-moz-linear-gradient(top,rgba(255,255,255,1),rgba(185,185,185,1));
+  height: 30px;
+  padding-left: 5px;
+  padding-right: 5px;
+  
+  min-width: 80px;
+  visibility : hidden;
+}
+.iheader > button:hover {
+  background:rgba(240,240,240,1);
+}
+
+.iheader > button:active, button:focus {
+  background:-webkit-gradient(linear,0% 100%,0% 0%,from(rgba(255,255,255,1)),to(rgba(185,185,185,1)));
+  background:-moz-linear-gradient(bottom,rgba(255,255,255,1),rgba(185,185,185,1));
+}
+
+.iheader > button:disabled {
+  color:rgba(0,0,0,0.4);
+  text-shadow:1px 1px 0px rgba(255,255,255,0.5);
+  background:rgba(220,220,220,1);
+}
+.rightbtn {
+ float: right; 
+ 
+margin-right:50px;
+}
+.moduleSelector {
+ float: right; 
+margin-top:10px;
+margin-right:5px;
+}
+.leftbtn {
+  float: left;
+}
+
+
+
+/*
+.statusbar {
+    height: 20px;
+    font-size: 		15px;
+    background: #FFEEF1;
+    border: 1px solid gray;
+    position: absolute;
+    bottom: 0px;
+    left: 0px;
+    right: 0px;
+
+    z-index: 1;
+}
+*/
+
+.statusbar {
+    height: 1px;
+    position: absolute;
+    bottom: 0px;
+    left: 0px;
+    right: 0px;    
+    margin: 0px;
+    padding: 0px;
+    z-index: 1;
+}
+/* 
+    This is needed for IE6, otherwise the statusbar have invalid width 
+*/
+.statusbar div {
+    width: 100%;
+}
+
+/*
+.sidebar {
+    margin-top:	10px;
+}
+*/
+
+#main_sidebar div+div {
+    margin-top:	10px;
+}
+
+
+.sidebar .holder {
+    border:	1px solid black;
+    padding: 	0px;
+    margin:	0px;
+}
+
+.sidebar .switch {
+    padding:	1px;
+    margin:	0px;
+    border:	0px;
+}
+
+.sidebar .switch button {
+  padding: 0px;
+  margin: 0px;
+  display: block;
+  border: 1px solid #C0C0C0;
+  color: #000055;
+  background: #F0F0F0;
+  text-decoration: none;
+  /* min-width: 20px; causin artefacts in IE and Opera */
+  /* width: 25px;*/
+}
+
+.sidebar .switch button:hover {
+  border: 1px #007000 solid;
+  background: #F0E0E0;
+}
+
+.sidebar .switch table td {
+    vertical-align: middle;
+}
+
+
+/*
+Causes problems to IE
+.sidebar .switch div:first-letter, .header .links div:first-letter {
+    text-transform:	uppercase;
+}
+*/
+
+
+#main_sidebar_controls .controls {
+    overflow: auto;
+/*
+    Strangely working as expected only in IE
+    
+    overflow-y: auto;
+    overflow-x: visible;
+
+    height: 300px;
+*/
+/*    height: 421px;*/
+    width: 350px;
+}
+
+.controls, .controls table {
+    width: 100%;
+}
+
+/*
+.controls table td {
+    border: 1px solid black;
+}
+*/
+
+.select_table td+td {
+    text-align: right;
+}
+
+
+.module {
+    /* For detection of min-height property support */
+    min-width: 10px;
+    min-height: 10px;
+    
+    /*border: solid black 1px; debugging*/
+}
+
+.module_link, .module_link_current {
+    text-decoration: 	none;
+}
+
+.module_link {
+    color:		blue;
+}
+
+.module_link_current {
+    color:		#32ad32;
+}
+
+.popup {
+    /*min-width: 300px;	ignored by IE, bug in Opera */
+    min-width: 10px;
+    min-height: 10px;
+}
+
+
+.module_source_link, .module_source_link_current {
+    background: 	#E0E0E0;
+}
+.module_source_link a, .module_source_link_current a {
+    text-decoration: 	none;
+}
+.module_source_link a {
+    color:		blue;
+}
+.module_source_link_current a {
+    color:		#32ad32;
+}
+.module_source_link_current a:before {
+    content: 		"{";
+}
+.module_source_link_current a:after {
+    content: 		"}";
+}
+
+.module_controls_link, .module_controls_link_current {
+    background: 	#E0E0E0;
+    padding-left:	5px;
+    padding-right:	5px;
+    text-align:		center;
+}
+.module_controls_link a, .module_controls_link_current a {
+    text-decoration: 	none;
+}
+.module_controls_link a {
+    color:		blue;
+}
+.module_controls_link_current a {
+    color:		#32ad32;
+}
+.module_controls_link_current a:before {
+    content: 		"{";
+}
+.module_controls_link_current a:after {
+    content: 		"}";
+}
+
+.sidebar .controls table td {
+    padding-right:	5px;
+}
+
+#module_export select, #module_aggregator select, #module_source_source select {
+    width:		200px;
+}
+
+#module_source_time select {
+    width:		150px;
+}
+
+/* causes proble in gecko */
+#source_db_item_tr select {
+    width:		100%;
+}
+
+#source_db_item_tr td {
+    text-align: right;
+}
+
+
+#source_timestart input, #source_timeend input, #source_winstart input, #source_winend input {
+    width:		124px;
+}
+
+#source_timestart img, #source_timeend img, #source_winstart img, #source_winend img {
+    border:		0px;
+    padding:		0px;
+    margin:		0px;
+    width:		16px;
+    height:		16px;
+    vertical-align:	middle;
+}
+
+#source_axes_table td {
+    margin: 0px;
+    padding: 0px;
+}
+
+#source_axes_table .axis_name {
+    font-weight: bold;
+}
+
+.source_yrange input {
+    width:		64px;
+}
+
+#source_yopts input {
+    width:		128px;
+}
+
+.source_apply td {
+    text-align:		center;
+}
+
+.source_apply button {
+    width:		90%;
+    margin-top:		5px;
+    margin-bottom:	5px;
+}
+
+
+.export_apply td {
+    text-align:		center;
+}
+
+.export_apply button {
+    width:		90%;
+    margin-top:		5px;
+    margin-bottom:	5px;
+}
+
+
+.hide_source_control {
+    display:		none;
+}
+
+.hide_source_history {
+    display:		inline;
+}
+
+.hide_experiment_custom {
+    display:		none;
+}
+
+.hide_window_custom {
+    display:		none;
+}
+
+.header .links {
+/*    display: inline;*/
+}
+
+.menu_button {
+    margin-left: 	5px;
+
+    width: 0px;	/* needed by IE6 */
+/*
+    width: 		25px;
+    height:		25px;
+*/    
+    display:		inline;
+    position:		absolute;
+    left:		0px;
+
+/*
+    The positioning of submenus with 'position: absolute' is broken in
+    dhtmlxmenu. The hack below is to handle that 
+    top:		0px;
+    padding-top:	20px;
+*/
+    top:		20px;
+/*
+    please see z-index handling in menu.js, needed only for IE
+*/
+}
+
+.selector {
+    background:		white;
+    border:		1px solid black;
+    margin-right:	1px;
+/*    margin-bottom:	5px;*/
+}
+
+.graph {
+    width:		100%;
+}
+
+.dialog {
+	position: absolute;
+	background-color: #c0c0c0;
+	border-color: #f0f0f0 #606060 #404040 #d0d0d0;
+	border-style: solid;
+	border-width: 2px;
+	
+	margin: 0px; /* 5px */
+	padding: 2px;
+	cursor: pointer;
+	z-index: 500;
+}
+
+.dialog .close {
+    cursor: default;
+    margin: 2px;
+    position: absolute;
+    width: 20px;
+    height: 20px;
+    padding: 5px;
+    background: url(images/close.png) no-repeat;
+}
+
+.dialog .maximize {
+    cursor: default;
+    margin: 2px;
+    left: 24px;
+    position: absolute;
+    width: 20px;
+    height: 20px;
+    padding: 5px;
+    background: url(images/maximize.png) no-repeat;
+}
+
+.dialog .restore {
+    cursor: default;
+    margin: 2px;
+    left: 24px;
+    position: absolute;
+    width: 20px;
+    height: 20px;
+    padding: 5px;
+    background: url(images/restore.png) no-repeat;
+}
+
+
+.dialog .titlebar {
+    /***
+      * IE6 would consider width: 100% (for auto) if we specify height)
+      *
+    height:		21px; 
+    */
+    min-height:		21px;
+    max-height:		21px;
+    background-color: 	#008080;
+    cursor: 		default;
+    margin: 		0px;
+    padding: 		2px 2px 2px .5em;
+    overflow:		hidden;
+}
+
+
+.dialog .titlebar span {
+    color: 		#ffffff;
+    font-family:	"MS Sans Serif", "Arial", "Helvetica", sans-serif;
+    font-size: 		12pt;
+    font-weight: 	bold;
+    text-align: 	left;
+    white-space: 	nowrap;
+    padding:		45px;
+    width:		100%;
+    vertical-align:	center;
+}
+
+.dialog .content {
+    cursor: 		default;
+    background-color:	#ffffff;
+    border-color: 	#404040 #e0e0e0 #f0f0f0 #505050;
+    border-style: 	solid;
+    border-width: 	2px;
+    margin: 		2px 0px 0px 0px;
+    padding: 		.5em;
+    font-size:		medium;	/* required by IE7 */
+/*	overflow: hidden;*/
+	overflow: auto;
+}
+
+.dialog iframe {
+    display:none;/*sorry for IE5*/
+    display/**/:block;/*sorry for IE5*/
+    position:absolute;/*must have*/
+    top:0;/*must have*/
+    left:0;/*must have*/
+    z-index:-1;/*must have*/
+    filter:mask();/*must have*/
+    width: 100%;/*must have for any big value*/
+    height: 100%;/*must have for any big value*/;
+}
+
+#legend .content p {
+  margin: 3px 5px 3px 5px;
+}
+
+#legend .content td, .legend .content th {
+    padding-right: 20px;
+    padding-left: 20px;
+}
+
+
+.navigation, .minipc
+{ 
+  font-family: Arial, Verdana;
+  font-size: 10pt; 
+  font-weight: normal;
+  vertical-align: middle;
+  background: white;
+  text-decoration: none;
+  white-space: nowrap;
+  margin-right: 10px;
+  margin-left: 10px;
+}
+
+.navigation a
+{
+  font-weight: normal;
+  padding: 2px;
+  margin-bottom: 2px;
+  display: block;
+  color: #000055;
+  background: #F0F0F0;
+  font-weight: bold;
+  border: 1px solid #C0C0C0;
+  text-decoration: none;
+}
+
+.navigation a:hover
+{
+  border: 1px #007000 solid; 
+}
+
+
+.linkbutton
+{ 
+    text-align: center;
+}
+
+.linkbutton a
+{
+  border: 3px #F0B0B0 solid; 
+}
+
+.linkbutton a:hover
+{
+  border: 3px #F00000 solid; 
+}
+
+
+
+.highlight {
+  color: #BB0000;
+}
+
+.highlight a {
+  color: #BB0000;
+}
+
+.lowlight {
+  color: #771111;
+}
+
+.lowlight a {
+  color: #771111;
+}
+
+
+/*
+.info {
+  padding: 10px;
+  vertical-align: top;
+  background: #BFFFBF;
+  border: 1px solid #00C000;
+  margin: 10px;
+  font-size:14pt; 
+  line-height: 1.5;
+}
+
+
+.error {
+  padding: 10px;
+  vertical-align: top;
+  background: pink;
+  border: 1px solid #00C000;
+  margin: 10px;
+  font-size:14pt; 
+  line-height: 1.5;
+}
+*/
+
+.info h1, .error h1 {
+  font-family: Arial, Verdana;
+  font-weight:bold;
+  color:#000055; 
+  font-size:16pt; 
+  margin: 3px;
+  margin-bottom: 20px;
+}
+
+.groups {
+  padding: 10px;
+  vertical-align: top;
+/*  background: #E0E0E0;
+  border: 1px solid #C0C0C0;*/
+}
+
+.group {
+  padding: 10px;
+  vertical-align: top;
+  background: #E0E0E0;
+  border: 1px solid #00C000;
+  margin: 10px;
+  width: 45%;
+}
+
+.group form {
+  margin: 0px;
+  padding: 0px;
+}
+
+.group h1 {
+  font-family: Arial, Verdana;
+  font-weight:bold;
+  color:#000055; 
+  font-size:14pt; 
+  margin: 3px;
+  margin-bottom: 5px;
+}
+
+.group .good {
+  color: green;
+  font-weight: bold;
+}
+
+.group .bad {
+  color: red;
+  font-weight: bold;
+}
+
+
+.xml_module, .wiki {
+    overflow: auto;
+}
+
+.xml_module .error {
+   color: red;
+}
+
+.xml_module h1 {
+  text-align: center;
+  font-family: Arial, Verdana;
+  font-weight:bold;
+  color:#000055; 
+  font-size:16pt; 
+  margin: 3px;
+  margin-bottom: 20px;
+}
+
+.xml_module table {
+    width: 100%;
+}
+
+.xml_module td {
+    text-align: center;
+    padding:	1px 4px 1px 4px;
+    border: 1px solid black;
+}
+
+.xml_module th {
+    text-align: center;
+    padding:	1px 4px 1px 4px;
+    background: lightgray;
+    border: 1px solid black;
+   
+}
+
+.wiki {
+    margin: 10px;
+    font-size: 12px;
+}
+
+.wiki .wiki_header {
+/*    text-align: center;*/
+    font-size: 16px; 
+    font-weight:bold; 
+    margin-bottom: 18px; 
+    margin-top: 0px;
+}
+
+.wiki .wiki_header2{
+    font-size: 14px; 
+    font-weight:bold; 
+    margin-bottom: 12px; 
+    margin-top: 0px;
+}
+
+
+/*
+#main_div {
+    background: blue;
+}
+#module_graph {
+    background: green;
+}
+#graph_image_div {
+    background: red;
+}
+*/
+
+
+
+.imgCrop_button_runs {
+	position: absolute;
+	background: url(images/run_button.png);
+	border: green solid 1px;
+	width: 19px;
+	height: 20px;
+	margin: 5px;
+	cursor: pointer;
+	z-index: 5;
+}
\ No newline at end of file

=== removed file 'images/blank.gif'
Binary files images/blank.gif and images/blank.gif differ
=== added file 'images/blank.png'
Binary files images/blank.png and images/blank.png differ
=== removed file 'images/btn_rt1.gif'
Binary files images/btn_rt1.gif and images/btn_rt1.gif differ
=== removed file 'images/btn_rt2.gif'
Binary files images/btn_rt2.gif and images/btn_rt2.gif differ
=== removed file 'images/btn_up1.gif'
Binary files images/btn_up1.gif and images/btn_up1.gif differ
=== removed file 'images/btn_up2.gif'
Binary files images/btn_up2.gif and images/btn_up2.gif differ
=== removed file 'images/cal.gif'
Binary files images/cal.gif and images/cal.gif differ
=== added file 'images/cal.png'
Binary files images/cal.png and images/cal.png differ
=== added file 'images/headerbar.png'
Binary files images/headerbar.png and images/headerbar.png differ
=== added file 'images/settings32.png'
Binary files images/settings32.png and images/settings32.png differ
=== added file 'images/showgraphcontrols.png'
Binary files images/showgraphcontrols.png and images/showgraphcontrols.png differ
=== added directory 'includes/PHPMailer-Lite_v5.1'
=== added file 'includes/PHPMailer-Lite_v5.1/LICENSE'
--- includes/PHPMailer-Lite_v5.1/LICENSE	1970-01-01 00:00:00 +0000
+++ includes/PHPMailer-Lite_v5.1/LICENSE	2011-01-26 02:48:39 +0000
@@ -0,0 +1,504 @@
+		  GNU LESSER GENERAL PUBLIC LICENSE
+		       Version 2.1, February 1999
+
+ Copyright (C) 1991, 1999 Free Software Foundation, Inc.
+     59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ Everyone is permitted to copy and distribute verbatim copies
+ of this license document, but changing it is not allowed.
+
+[This is the first released version of the Lesser GPL.  It also counts
+ as the successor of the GNU Library Public License, version 2, hence
+ the version number 2.1.]
+
+			    Preamble
+
+  The licenses for most software are designed to take away your
+freedom to share and change it.  By contrast, the GNU General Public
+Licenses are intended to guarantee your freedom to share and change
+free software--to make sure the software is free for all its users.
+
+  This license, the Lesser General Public License, applies to some
+specially designated software packages--typically libraries--of the
+Free Software Foundation and other authors who decide to use it.  You
+can use it too, but we suggest you first think carefully about whether
+this license or the ordinary General Public License is the better
+strategy to use in any particular case, based on the explanations below.
+
+  When we speak of free software, we are referring to freedom of use,
+not price.  Our General Public Licenses are designed to make sure that
+you have the freedom to distribute copies of free software (and charge
+for this service if you wish); that you receive source code or can get
+it if you want it; that you can change the software and use pieces of
+it in new free programs; and that you are informed that you can do
+these things.
+
+  To protect your rights, we need to make restrictions that forbid
+distributors to deny you these rights or to ask you to surrender these
+rights.  These restrictions translate to certain responsibilities for
+you if you distribute copies of the library or if you modify it.
+
+  For example, if you distribute copies of the library, whether gratis
+or for a fee, you must give the recipients all the rights that we gave
+you.  You must make sure that they, too, receive or can get the source
+code.  If you link other code with the library, you must provide
+complete object files to the recipients, so that they can relink them
+with the library after making changes to the library and recompiling
+it.  And you must show them these terms so they know their rights.
+
+  We protect your rights with a two-step method: (1) we copyright the
+library, and (2) we offer you this license, which gives you legal
+permission to copy, distribute and/or modify the library.
+
+  To protect each distributor, we want to make it very clear that
+there is no warranty for the free library.  Also, if the library is
+modified by someone else and passed on, the recipients should know
+that what they have is not the original version, so that the original
+author's reputation will not be affected by problems that might be
+introduced by others.
+
+  Finally, software patents pose a constant threat to the existence of
+any free program.  We wish to make sure that a company cannot
+effectively restrict the users of a free program by obtaining a
+restrictive license from a patent holder.  Therefore, we insist that
+any patent license obtained for a version of the library must be
+consistent with the full freedom of use specified in this license.
+
+  Most GNU software, including some libraries, is covered by the
+ordinary GNU General Public License.  This license, the GNU Lesser
+General Public License, applies to certain designated libraries, and
+is quite different from the ordinary General Public License.  We use
+this license for certain libraries in order to permit linking those
+libraries into non-free programs.
+
+  When a program is linked with a library, whether statically or using
+a shared library, the combination of the two is legally speaking a
+combined work, a derivative of the original library.  The ordinary
+General Public License therefore permits such linking only if the
+entire combination fits its criteria of freedom.  The Lesser General
+Public License permits more lax criteria for linking other code with
+the library.
+
+  We call this license the "Lesser" General Public License because it
+does Less to protect the user's freedom than the ordinary General
+Public License.  It also provides other free software developers Less
+of an advantage over competing non-free programs.  These disadvantages
+are the reason we use the ordinary General Public License for many
+libraries.  However, the Lesser license provides advantages in certain
+special circumstances.
+
+  For example, on rare occasions, there may be a special need to
+encourage the widest possible use of a certain library, so that it becomes
+a de-facto standard.  To achieve this, non-free programs must be
+allowed to use the library.  A more frequent case is that a free
+library does the same job as widely used non-free libraries.  In this
+case, there is little to gain by limiting the free library to free
+software only, so we use the Lesser General Public License.
+
+  In other cases, permission to use a particular library in non-free
+programs enables a greater number of people to use a large body of
+free software.  For example, permission to use the GNU C Library in
+non-free programs enables many more people to use the whole GNU
+operating system, as well as its variant, the GNU/Linux operating
+system.
+
+  Although the Lesser General Public License is Less protective of the
+users' freedom, it does ensure that the user of a program that is
+linked with the Library has the freedom and the wherewithal to run
+that program using a modified version of the Library.
+
+  The precise terms and conditions for copying, distribution and
+modification follow.  Pay close attention to the difference between a
+"work based on the library" and a "work that uses the library".  The
+former contains code derived from the library, whereas the latter must
+be combined with the library in order to run.
+
+		  GNU LESSER GENERAL PUBLIC LICENSE
+   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
+
+  0. This License Agreement applies to any software library or other
+program which contains a notice placed by the copyright holder or
+other authorized party saying it may be distributed under the terms of
+this Lesser General Public License (also called "this License").
+Each licensee is addressed as "you".
+
+  A "library" means a collection of software functions and/or data
+prepared so as to be conveniently linked with application programs
+(which use some of those functions and data) to form executables.
+
+  The "Library", below, refers to any such software library or work
+which has been distributed under these terms.  A "work based on the
+Library" means either the Library or any derivative work under
+copyright law: that is to say, a work containing the Library or a
+portion of it, either verbatim or with modifications and/or translated
+straightforwardly into another language.  (Hereinafter, translation is
+included without limitation in the term "modification".)
+
+  "Source code" for a work means the preferred form of the work for
+making modifications to it.  For a library, complete source code means
+all the source code for all modules it contains, plus any associated
+interface definition files, plus the scripts used to control compilation
+and installation of the library.
+
+  Activities other than copying, distribution and modification are not
+covered by this License; they are outside its scope.  The act of
+running a program using the Library is not restricted, and output from
+such a program is covered only if its contents constitute a work based
+on the Library (independent of the use of the Library in a tool for
+writing it).  Whether that is true depends on what the Library does
+and what the program that uses the Library does.
+  
+  1. You may copy and distribute verbatim copies of the Library's
+complete source code as you receive it, in any medium, provided that
+you conspicuously and appropriately publish on each copy an
+appropriate copyright notice and disclaimer of warranty; keep intact
+all the notices that refer to this License and to the absence of any
+warranty; and distribute a copy of this License along with the
+Library.
+
+  You may charge a fee for the physical act of transferring a copy,
+and you may at your option offer warranty protection in exchange for a
+fee.
+
+  2. You may modify your copy or copies of the Library or any portion
+of it, thus forming a work based on the Library, and copy and
+distribute such modifications or work under the terms of Section 1
+above, provided that you also meet all of these conditions:
+
+    a) The modified work must itself be a software library.
+
+    b) You must cause the files modified to carry prominent notices
+    stating that you changed the files and the date of any change.
+
+    c) You must cause the whole of the work to be licensed at no
+    charge to all third parties under the terms of this License.
+
+    d) If a facility in the modified Library refers to a function or a
+    table of data to be supplied by an application program that uses
+    the facility, other than as an argument passed when the facility
+    is invoked, then you must make a good faith effort to ensure that,
+    in the event an application does not supply such function or
+    table, the facility still operates, and performs whatever part of
+    its purpose remains meaningful.
+
+    (For example, a function in a library to compute square roots has
+    a purpose that is entirely well-defined independent of the
+    application.  Therefore, Subsection 2d requires that any
+    application-supplied function or table used by this function must
+    be optional: if the application does not supply it, the square
+    root function must still compute square roots.)
+
+These requirements apply to the modified work as a whole.  If
+identifiable sections of that work are not derived from the Library,
+and can be reasonably considered independent and separate works in
+themselves, then this License, and its terms, do not apply to those
+sections when you distribute them as separate works.  But when you
+distribute the same sections as part of a whole which is a work based
+on the Library, the distribution of the whole must be on the terms of
+this License, whose permissions for other licensees extend to the
+entire whole, and thus to each and every part regardless of who wrote
+it.
+
+Thus, it is not the intent of this section to claim rights or contest
+your rights to work written entirely by you; rather, the intent is to
+exercise the right to control the distribution of derivative or
+collective works based on the Library.
+
+In addition, mere aggregation of another work not based on the Library
+with the Library (or with a work based on the Library) on a volume of
+a storage or distribution medium does not bring the other work under
+the scope of this License.
+
+  3. You may opt to apply the terms of the ordinary GNU General Public
+License instead of this License to a given copy of the Library.  To do
+this, you must alter all the notices that refer to this License, so
+that they refer to the ordinary GNU General Public License, version 2,
+instead of to this License.  (If a newer version than version 2 of the
+ordinary GNU General Public License has appeared, then you can specify
+that version instead if you wish.)  Do not make any other change in
+these notices.
+
+  Once this change is made in a given copy, it is irreversible for
+that copy, so the ordinary GNU General Public License applies to all
+subsequent copies and derivative works made from that copy.
+
+  This option is useful when you wish to copy part of the code of
+the Library into a program that is not a library.
+
+  4. You may copy and distribute the Library (or a portion or
+derivative of it, under Section 2) in object code or executable form
+under the terms of Sections 1 and 2 above provided that you accompany
+it with the complete corresponding machine-readable source code, which
+must be distributed under the terms of Sections 1 and 2 above on a
+medium customarily used for software interchange.
+
+  If distribution of object code is made by offering access to copy
+from a designated place, then offering equivalent access to copy the
+source code from the same place satisfies the requirement to
+distribute the source code, even though third parties are not
+compelled to copy the source along with the object code.
+
+  5. A program that contains no derivative of any portion of the
+Library, but is designed to work with the Library by being compiled or
+linked with it, is called a "work that uses the Library".  Such a
+work, in isolation, is not a derivative work of the Library, and
+therefore falls outside the scope of this License.
+
+  However, linking a "work that uses the Library" with the Library
+creates an executable that is a derivative of the Library (because it
+contains portions of the Library), rather than a "work that uses the
+library".  The executable is therefore covered by this License.
+Section 6 states terms for distribution of such executables.
+
+  When a "work that uses the Library" uses material from a header file
+that is part of the Library, the object code for the work may be a
+derivative work of the Library even though the source code is not.
+Whether this is true is especially significant if the work can be
+linked without the Library, or if the work is itself a library.  The
+threshold for this to be true is not precisely defined by law.
+
+  If such an object file uses only numerical parameters, data
+structure layouts and accessors, and small macros and small inline
+functions (ten lines or less in length), then the use of the object
+file is unrestricted, regardless of whether it is legally a derivative
+work.  (Executables containing this object code plus portions of the
+Library will still fall under Section 6.)
+
+  Otherwise, if the work is a derivative of the Library, you may
+distribute the object code for the work under the terms of Section 6.
+Any executables containing that work also fall under Section 6,
+whether or not they are linked directly with the Library itself.
+
+  6. As an exception to the Sections above, you may also combine or
+link a "work that uses the Library" with the Library to produce a
+work containing portions of the Library, and distribute that work
+under terms of your choice, provided that the terms permit
+modification of the work for the customer's own use and reverse
+engineering for debugging such modifications.
+
+  You must give prominent notice with each copy of the work that the
+Library is used in it and that the Library and its use are covered by
+this License.  You must supply a copy of this License.  If the work
+during execution displays copyright notices, you must include the
+copyright notice for the Library among them, as well as a reference
+directing the user to the copy of this License.  Also, you must do one
+of these things:
+
+    a) Accompany the work with the complete corresponding
+    machine-readable source code for the Library including whatever
+    changes were used in the work (which must be distributed under
+    Sections 1 and 2 above); and, if the work is an executable linked
+    with the Library, with the complete machine-readable "work that
+    uses the Library", as object code and/or source code, so that the
+    user can modify the Library and then relink to produce a modified
+    executable containing the modified Library.  (It is understood
+    that the user who changes the contents of definitions files in the
+    Library will not necessarily be able to recompile the application
+    to use the modified definitions.)
+
+    b) Use a suitable shared library mechanism for linking with the
+    Library.  A suitable mechanism is one that (1) uses at run time a
+    copy of the library already present on the user's computer system,
+    rather than copying library functions into the executable, and (2)
+    will operate properly with a modified version of the library, if
+    the user installs one, as long as the modified version is
+    interface-compatible with the version that the work was made with.
+
+    c) Accompany the work with a written offer, valid for at
+    least three years, to give the same user the materials
+    specified in Subsection 6a, above, for a charge no more
+    than the cost of performing this distribution.
+
+    d) If distribution of the work is made by offering access to copy
+    from a designated place, offer equivalent access to copy the above
+    specified materials from the same place.
+
+    e) Verify that the user has already received a copy of these
+    materials or that you have already sent this user a copy.
+
+  For an executable, the required form of the "work that uses the
+Library" must include any data and utility programs needed for
+reproducing the executable from it.  However, as a special exception,
+the materials to be distributed need not include anything that is
+normally distributed (in either source or binary form) with the major
+components (compiler, kernel, and so on) of the operating system on
+which the executable runs, unless that component itself accompanies
+the executable.
+
+  It may happen that this requirement contradicts the license
+restrictions of other proprietary libraries that do not normally
+accompany the operating system.  Such a contradiction means you cannot
+use both them and the Library together in an executable that you
+distribute.
+
+  7. You may place library facilities that are a work based on the
+Library side-by-side in a single library together with other library
+facilities not covered by this License, and distribute such a combined
+library, provided that the separate distribution of the work based on
+the Library and of the other library facilities is otherwise
+permitted, and provided that you do these two things:
+
+    a) Accompany the combined library with a copy of the same work
+    based on the Library, uncombined with any other library
+    facilities.  This must be distributed under the terms of the
+    Sections above.
+
+    b) Give prominent notice with the combined library of the fact
+    that part of it is a work based on the Library, and explaining
+    where to find the accompanying uncombined form of the same work.
+
+  8. You may not copy, modify, sublicense, link with, or distribute
+the Library except as expressly provided under this License.  Any
+attempt otherwise to copy, modify, sublicense, link with, or
+distribute the Library is void, and will automatically terminate your
+rights under this License.  However, parties who have received copies,
+or rights, from you under this License will not have their licenses
+terminated so long as such parties remain in full compliance.
+
+  9. You are not required to accept this License, since you have not
+signed it.  However, nothing else grants you permission to modify or
+distribute the Library or its derivative works.  These actions are
+prohibited by law if you do not accept this License.  Therefore, by
+modifying or distributing the Library (or any work based on the
+Library), you indicate your acceptance of this License to do so, and
+all its terms and conditions for copying, distributing or modifying
+the Library or works based on it.
+
+  10. Each time you redistribute the Library (or any work based on the
+Library), the recipient automatically receives a license from the
+original licensor to copy, distribute, link with or modify the Library
+subject to these terms and conditions.  You may not impose any further
+restrictions on the recipients' exercise of the rights granted herein.
+You are not responsible for enforcing compliance by third parties with
+this License.
+
+  11. If, as a consequence of a court judgment or allegation of patent
+infringement or for any other reason (not limited to patent issues),
+conditions are imposed on you (whether by court order, agreement or
+otherwise) that contradict the conditions of this License, they do not
+excuse you from the conditions of this License.  If you cannot
+distribute so as to satisfy simultaneously your obligations under this
+License and any other pertinent obligations, then as a consequence you
+may not distribute the Library at all.  For example, if a patent
+license would not permit royalty-free redistribution of the Library by
+all those who receive copies directly or indirectly through you, then
+the only way you could satisfy both it and this License would be to
+refrain entirely from distribution of the Library.
+
+If any portion of this section is held invalid or unenforceable under any
+particular circumstance, the balance of the section is intended to apply,
+and the section as a whole is intended to apply in other circumstances.
+
+It is not the purpose of this section to induce you to infringe any
+patents or other property right claims or to contest validity of any
+such claims; this section has the sole purpose of protecting the
+integrity of the free software distribution system which is
+implemented by public license practices.  Many people have made
+generous contributions to the wide range of software distributed
+through that system in reliance on consistent application of that
+system; it is up to the author/donor to decide if he or she is willing
+to distribute software through any other system and a licensee cannot
+impose that choice.
+
+This section is intended to make thoroughly clear what is believed to
+be a consequence of the rest of this License.
+
+  12. If the distribution and/or use of the Library is restricted in
+certain countries either by patents or by copyrighted interfaces, the
+original copyright holder who places the Library under this License may add
+an explicit geographical distribution limitation excluding those countries,
+so that distribution is permitted only in or among countries not thus
+excluded.  In such case, this License incorporates the limitation as if
+written in the body of this License.
+
+  13. The Free Software Foundation may publish revised and/or new
+versions of the Lesser General Public License from time to time.
+Such new versions will be similar in spirit to the present version,
+but may differ in detail to address new problems or concerns.
+
+Each version is given a distinguishing version number.  If the Library
+specifies a version number of this License which applies to it and
+"any later version", you have the option of following the terms and
+conditions either of that version or of any later version published by
+the Free Software Foundation.  If the Library does not specify a
+license version number, you may choose any version ever published by
+the Free Software Foundation.
+
+  14. If you wish to incorporate parts of the Library into other free
+programs whose distribution conditions are incompatible with these,
+write to the author to ask for permission.  For software which is
+copyrighted by the Free Software Foundation, write to the Free
+Software Foundation; we sometimes make exceptions for this.  Our
+decision will be guided by the two goals of preserving the free status
+of all derivatives of our free software and of promoting the sharing
+and reuse of software generally.
+
+			    NO WARRANTY
+
+  15. BECAUSE THE LIBRARY IS LICENSED FREE OF CHARGE, THERE IS NO
+WARRANTY FOR THE LIBRARY, TO THE EXTENT PERMITTED BY APPLICABLE LAW.
+EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR
+OTHER PARTIES PROVIDE THE LIBRARY "AS IS" WITHOUT WARRANTY OF ANY
+KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE
+IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE
+LIBRARY IS WITH YOU.  SHOULD THE LIBRARY PROVE DEFECTIVE, YOU ASSUME
+THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
+
+  16. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
+WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY
+AND/OR REDISTRIBUTE THE LIBRARY AS PERMITTED ABOVE, BE LIABLE TO YOU
+FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR
+CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE
+LIBRARY (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING
+RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A
+FAILURE OF THE LIBRARY TO OPERATE WITH ANY OTHER SOFTWARE), EVEN IF
+SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
+DAMAGES.
+
+		     END OF TERMS AND CONDITIONS
+
+           How to Apply These Terms to Your New Libraries
+
+  If you develop a new library, and you want it to be of the greatest
+possible use to the public, we recommend making it free software that
+everyone can redistribute and change.  You can do so by permitting
+redistribution under these terms (or, alternatively, under the terms of the
+ordinary General Public License).
+
+  To apply these terms, attach the following notices to the library.  It is
+safest to attach them to the start of each source file to most effectively
+convey the exclusion of warranty; and each file should have at least the
+"copyright" line and a pointer to where the full notice is found.
+
+    <one line to give the library's name and a brief idea of what it does.>
+    Copyright (C) <year>  <name of author>
+
+    This library is free software; you can redistribute it and/or
+    modify it under the terms of the GNU Lesser General Public
+    License as published by the Free Software Foundation; either
+    version 2.1 of the License, or (at your option) any later version.
+
+    This library is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+    Lesser General Public License for more details.
+
+    You should have received a copy of the GNU Lesser General Public
+    License along with this library; if not, write to the Free Software
+    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+Also add information on how to contact you by electronic and paper mail.
+
+You should also get your employer (if you work as a programmer) or your
+school, if any, to sign a "copyright disclaimer" for the library, if
+necessary.  Here is a sample; alter the names:
+
+  Yoyodyne, Inc., hereby disclaims all copyright interest in the
+  library `Frob' (a library for tweaking knobs) written by James Random Hacker.
+
+  <signature of Ty Coon>, 1 April 1990
+  Ty Coon, President of Vice
+
+That's all there is to it!
+
+

=== added file 'includes/PHPMailer-Lite_v5.1/README'
--- includes/PHPMailer-Lite_v5.1/README	1970-01-01 00:00:00 +0000
+++ includes/PHPMailer-Lite_v5.1/README	2011-01-26 02:48:39 +0000
@@ -0,0 +1,107 @@
+/*******************************************************************
+* The http://phpmailer.codeworxtech.com/ website now carries a few *
+* advertisements through the Google Adsense network. Please visit  *
+* the advertiser sites and help us offset some of our costs.       *
+* Thanks ....                                                      *
+********************************************************************/
+
+PHPMailer-Lite
+Full Featured Email Transfer Class for PHP
+==========================================
+
+Version 5.1 (October xx, 2009)
+
+Notable differences between PHPMailer and PHPMailer Lite:
+  - PHPMailer Lite does not include support for SMTP
+  - PHPMailer Lite supports Sendmail (or Qmail) by default
+  - PHPMailer Lite requires one single file (if you need language support,
+    use the language files from PHPMailer - the only difference in language
+    files is PHPMailer Lite does not include any SMTP messages)
+
+We also have created a new test script (see /test) that you can use
+right out of the box. Copy the /test folder directly to your server (in
+the same structure ... with class.phpmailer-lite.php in the folder above it.
+Then launch the test script with:
+http://www.yourdomain.com/phpmailer/test/index.php
+from this one script, you can test your server settings for mail(), or sendmail
+(or qmail). This will email you a sample email (using contents.html for
+the email body) and two attachments. One of the attachments is used as an inline
+image to demonstrate how PHPMailer will automatically detect if attachments are
+the same source as inline graphics and only include one version. Once you click
+the Submit button, the results will be displayed including send status. We will
+also display a version of the script that you can cut and paste to include in
+your projects. Enjoy!
+
+Enjoy!
+
+This software is licenced under the LGPL.  Please read LICENSE for information on the
+software availability and distribution.
+
+Class Features:
+- Send emails with multiple TOs, CCs, BCCs and REPLY-TOs
+- Multipart/alternative emails for mail clients that do not read HTML email
+- Support for 8bit, base64, binary, and quoted-printable encoding
+- Uses the same methods as the very popular AspEmail active server (COM) component
+- Word wrap, and more!
+
+Why you might need it:
+
+Many PHP developers utilize email in their code.  The only PHP function
+that supports this is the mail() function.  However, it does not expose
+any of the popular features that many email clients use nowadays like
+HTML-based emails and attachments. There are two proprietary
+development tools out there that have all the functionality built into
+easy to use classes: AspEmail(tm) and AspMail.  Both of these
+programs are COM components only available on Windows.  They are also a
+little pricey for smaller projects.
+
+Since I do Linux development I�ve missed these tools for my PHP coding.
+So I built a version myself that implements the same methods (object
+calls) that the Windows-based components do. It is open source and the
+LGPL license allows you to place the class in your proprietary PHP
+projects.
+
+Installation:
+
+Copy class.phpmailer-lite.php into your php.ini include_path. 
+
+That's it.  You should now be ready to use PHPMailer!
+
+A Simple Example:
+
+<?php
+require("class.phpmailer-lite.php");
+
+$mail = new PHPMailerLite();
+
+$mail->SetFrom('you@yourdomain.com', 'Your Name');
+
+$mail->AddAddress("josh@example.net", "Josh Adams");
+$mail->AddAddress("ellen@example.com");                  // name is optional
+
+$mail->WordWrap = 50;                                 // set word wrap to 50 characters
+$mail->AddAttachment("/var/tmp/file.tar.gz");         // add attachments
+$mail->AddAttachment("/tmp/image.jpg", "new.jpg");    // optional name
+$mail->IsHTML(true);                                  // set email format to HTML
+
+$mail->Subject = "Here is the subject";
+$mail->Body    = "This is the HTML message body <b>in bold!</b>";
+$mail->AltBody = "This is the body in plain text for non-HTML mail clients";
+
+if(!$mail->Send())
+{
+   echo "Message could not be sent. <p>";
+   echo "Mailer Error: " . $mail->ErrorInfo;
+   exit;
+}
+
+echo "Message has been sent";
+?>
+
+CHANGELOG
+
+See ChangeLog.txt
+
+Download: http://sourceforge.net/project/showfiles.php?group_id=26031
+
+Andy Prevost

=== added file 'includes/PHPMailer-Lite_v5.1/aboutus.html'
--- includes/PHPMailer-Lite_v5.1/aboutus.html	1970-01-01 00:00:00 +0000
+++ includes/PHPMailer-Lite_v5.1/aboutus.html	2011-01-26 02:48:39 +0000
@@ -0,0 +1,169 @@
+<html>
+<head>
+<style>
+body, p, li, td {
+  font-family: Arial, Helvetica, sans-serif;
+  font-size: 12px;
+}
+ul {
+  margin:0 0px 0 15px;
+  padding:0;
+}
+div.width {
+  width: 760px;
+  text-align: left;
+}
+</style>
+<script>
+<!--
+var popsite="http://phpmailer.codeworxtech.com"
+var withfeatures="width=960,height=760,scrollbars=1,resizable=1,toolbar=1,location=1,menubar=1,status=1,directories=0"
+var once_per_session=0
+function get_cookie(Name) {
+  var search = Name + "="
+  var returnvalue = "";
+  if (document.cookie.length > 0) {
+    offset = document.cookie.indexOf(search)
+    if (offset != -1) { // if cookie exists
+      offset += search.length
+      // set index of beginning of value
+      end = document.cookie.indexOf(";", offset);
+      // set index of end of cookie value
+      if (end == -1)
+         end = document.cookie.length;
+      returnvalue=unescape(document.cookie.substring(offset, end))
+      }
+   }
+  return returnvalue;
+}
+function loadornot(){
+  if (get_cookie('popsite')=='') {
+    loadpopsite()
+    document.cookie="popsite=yes"
+  }
+}
+function loadpopsite(){
+  win2=window.open(popsite,"",withfeatures)
+  win2.blur()
+  window.focus()
+}
+if (once_per_session==0) {
+  loadpopsite()
+} else {
+  loadornot()
+}
+-->
+</script>
+</head>
+<body>
+<center>
+<div class="width">
+<hr>
+The http://phpmailer.codeworxtech.com/ website now carries a few
+advertisements through the Google Adsense network to help offset
+some of our costs.<br />
+Thanks ....<br />
+<hr>
+<p>PHPMailer is the world's leading email transport class and downloaded an
+average of more than 32,000 each month. In March 2009, PHPMailer was downloaded
+more than 31,000 times -- that's an average of 1,000 downloads daily. Our thanks
+to our new users and loyal users. We understand you have many choices available
+to select from and we thank you for select our fast and stable tool for your
+website and projects.</p>
+<p>Credits:<br>
+PHPMailer's original founder is Brent Matzelle. The current team is:<br>
+Project Administrator: Andy Prevost (codeworxtech),
+<a href="mailto:codeworxtech@users.sourceforge.net">
+codeworxtech@users.sourceforge.net</a><br>
+Author: Andy Prevost (codeworxtech) codeworxtech@users.sourceforge.net<br>
+Author: Marcus Bointon (coolbru) <a href="mailto:coolbru@users.sourceforge.net">
+coolbru@users.sourceforge.net</a></p>
+<p>PHPMailer is used in many projects ranging from Open Source to commercial
+packages. Our LGPL licensing terms are very flexible and allow for including
+PHPMailer to enhance projects of all types. If you discover PHPMailer being used
+in a project, please let us know about it.</p>
+<p><strong>WHY USE OUR TOOLS &amp; WHAT&#39;S IN IT FOR YOU?</strong></p>
+<p>A valid question. We're developers too. We've been writing software, primarily for the internet, for more than 15 years. Along the way, there are two major things that had tremendous impact of our company: PHP and Open Source. PHP is without doubt the most popular platform for the internet. There has been more progress in this area of technology because of Open Source software than in any other IT segment. We have used many open source tools, some as learning tools, some as components in projects we were working on. To us, it's not about popularity ... we're committed to robust, stable, and efficient tools you can use to get your projects in your user's hands quickly. So the shorter answer: what's in it for you? rapid development and rapid deployment without fuss and with straight forward open source licensing.</p>
+<p>Now, here's our team:</p>
+<table width="100%" cellpadding="5" style="border-collapse: collapse" border="1">
+  <tr>
+    <th><b>About Andy Prevost, AKA "codeworxtech".</b></th>
+    <th><b>About Marcus Bointon, AKA "coolbru".</b></th>
+  </tr>
+  <tr>
+    <td width="50%" valign="top">
+      <p><a href="http://www.codeworxtech.com">www.codeworxtech.com</a> for more information.<br>
+    Web design, web applications, forms: <a href="http://www.worxstudio.com">WorxStudio.com</a><br />
+      </p>
+      <p>Our company, <strong>Worx International Inc.</strong>, is the publisher of several Open Source applications and developer tools as well as several commercial PHP applications. The Open Source applications are ttCMS and DCP Portal. The Open Source developer tools include QuickComponents (QuickSkin and QuickCache) and now PHPMailer.
+      We have staff and offices in the United States, Caribbean, the Middle
+      East, and our primary development center in Canada. Our company is represented by
+      agents and resellers globally.</p>
+      <p><strong>Worx International Inc.</strong> is at the forefront of developing PHP applications. Our staff are all Zend Certified university educated and experts at object oriented programming. While <strong>Worx International Inc.</strong> can handle any project from trouble shooting programs written by others all the way to finished mission-critical applications, we specialize in taking projects from inception all the way through to implementation - on budget, and on time. If you need help with your projects, we&#39;re the team to get it done right at a reasonable price.</p>
+      <p>Over the years, there have been a number of tools that have been constant favorites in all of our projects. We have become the project administrators for most of these tools.</p>
+      <p>Our developer tools are all Open Source. Here&#39;s a brief description:</p>
+      <ul>
+        <li><span style="background-color: #FFFF00"><strong>PHPMailer</strong></span>. Originally authored by Brent Matzelle, PHPMailer is the leading "email transfer class" for PHP. PHPMailer is downloaded more than
+    26000 times each and every month by developers looking for a fast, stable, simple email solution. We used it ourselves for years as our favorite tool. It&#39;s always been small (the entire footprint is
+    less than 100 Kb), stable, and as complete a solution as you can find.
+    Other tools are nowhere near as simple. Our thanks to Brent Matzelle for this superb tool - our commitment is to keep it lean, keep it focused, and compliant with standards. Visit the PHPMailer website at
+        <a href="http://phpmailer.codeworxtech.com/">http://phpmailer.codeworxtech.com/</a>. <br />
+        Please note: <strong>all of our focus is now on the PHPMailer for PHP5.</strong><br />
+        <span style="background-color: #FFFF00">PS. While you are at it, please visit our sponsor&#39;s sites, click on their ads.
+        It helps offset some of our costs.</span><br />
+        Want to help? We're looking for progressive developers to join our team of volunteer professionals working on PHPMailer. Our entire focus is on PHPMailer
+    for PHP5. If you are interested, let us know.<br />
+        <br />
+        </li>
+        <li><strong><span style="background-color: #FFFF00">QuickCache</span></strong>. Originally authored by Jean Pierre Deckers as jpCache, QuickCache is an HTTP OpCode caching strategy that works on your entire site with only one line of code at the top of your script. The cached pages can be stored as files or as database objects. The benefits are absolutely astounding: bandwidth savings of up to 80% and screen display times increased by 8 - 10x. Visit the QuickCache website at
+        <a href="http://quickcache.codeworxtech.com/">http://quickcache.codeworxtech.com/</a>.<br />
+        <br />
+        </li>
+        <li><strong><span style="background-color: #FFFF00">QuickSkin</span></strong>. Originally authored by Philipp v. Criegern and named "SmartTemplate". The project was taken over by Manuel 'EndelWar' Dalla Lana and now by "codeworxtech". QuickSkin is one of the truly outstanding templating engines available, but has always been confused with Smarty Templating Engine. QuickSkin is even more relevant today than when it was launched. It&#39;s a small footprint with big impact on your projects. It features a built in caching technology, token based substitution, and works on the concept of one single HTML file as the template. The HTML template file can contain variable information making it one small powerful tool for your developer tool kit. Visit the QuickSkin website at
+        <a href="http://quickskin.codeworxtech.com/">http://quickskin.codeworxtech.com/</a>.<br />
+        <br />
+        </li>
+      </ul>
+      <p>We're committed to PHP and to the Open Source community.</p>
+      <p>Opportunities with <strong>Worx International Inc.</strong>:</p>
+      <ul>
+      <li><span style="background-color: #FFFF00">Resellers/Agents</span>: We're always interested in talking with companies that
+      want to represent
+      <strong>Worx International Inc.</strong> in their markets. We also have private label programs for our commercial products (in certain circumstances).</li>
+      <li>Programmers/Developers: We are usually fully staffed, however, if you would like to be considered for a career with
+      <strong>Worx International Inc.</strong>, we would be pleased to hear from you.<br />
+      A few things to note:<br />
+      <ul>
+        <li>experience level does not matter: from fresh out of college to multi-year experience - it&#39;s your
+        creative mind and a positive attitude we want</li>
+        <li>if you contact us looking for employment, include a cover letter, indicate what type of work/career you are looking for and expected compensation</li>
+        <li>if you are representing someone else looking for work, do not contact us. We have an exclusive relationship with a recruiting partner already and not interested in altering the arrangement. We will not hire your candidate under any circumstances unless they wish to approach us individually.</li>
+        <li>any contact that ignores any of these points will be discarded</li>
+      </ul></li>
+      <li>Affiliates/Partnerships: We are interested in partnering with other firms who are leaders in their field. We clearly understand that successful companies are built on successful relationships in all industries world-wide. We currently have innovative relationships throughout the world that are mutually beneficial. Drop us a line and let&#39;s talk.</li>
+      </ul>
+      Regards,<br />
+      Andy Prevost (aka, codeworxtech)<br />
+      <a href="mailto:codeworxtech@users.sourceforge.net">codeworxtech@users.sourceforge.net</a><br />
+      <br />
+      We now also offer website design. hosting, and remote forms processing. Visit <a href="http://www.worxstudio.com/" target="_blank">WorxStudio.com</a> for more information.<br />
+    </td>
+    <td width="50%" valign="top">
+    <p>Marcus is the technical director of <a href="http://www.synchromedia.co.uk/">Synchromedia Limited</a>, a UK-based company providing online business services. Synchromedia's main services are:</p>
+        <h2>Smartmessages.net</h2>
+      <p><a href="https://www.smartmessages.net/"><img src="http://www.synchromedia.co.uk/uploads/images/smlogo.gif" width="292" height="48" alt="Smartmessages.net logo" /><br />Smartmessages.net</a> is Synchromedia's large-scale mailing list management system, providing email delivery services for a wide range of businesses, from sole traders to corporates.
+      We pride ourselves on personal service, and realise that every one of your subscribers is a precious asset to be handled with care.
+      We provide fast, reliable, high-volume delivery (some of our customers have lists of more than 1,000,000 subscribers) with fine-grained tracking while ensuring you stay fully compliant with UK, EC and US data protection laws. Smartmessages of course uses PHPMailer at its heart!</p>
+    <h2>info@hand</h2>
+      <p><a href="http://www.synchromedia.co.uk/what-we-do/info-at-hand-crm/"><img src="http://www.synchromedia.co.uk/uploads/images/infoathand-large.png" width="250" height="40" alt="info@hand logo" /></a><br />Synchromedia is the official UK distributor of <a href="http://www.thelongreach.com/">info@hand</a>, a class-leading open-source web-based CRM system. We provide licenses, hosting, planning, support and training for this very fully-featured system at very competitive prices. info@hand also uses PHPMailer!</p>
+    <h2>How can we help you?</h2>
+      <p>In addition to our headline services, we also provide consulting, development, hosting and sysadmin services, so if you just need a simple web hosting package, we can do that too. Not surprisingly, we know rather a lot about email, so you can talk to us about that too.</p>
+      <p>Please <a href="http://www.synchromedia.co.uk/about-us/contact-us/">contact us</a> if you'd like to know more.</p>
+      <p>Marcus is a regular attendee at <a href="http://www.phplondon.org/">PHP London</a>, and occasionally speaks on email at technical conferences.</p>
+  </td>
+  </tr>
+</table>
+</div>
+</center>
+</body>
+</html>
\ No newline at end of file

=== added file 'includes/PHPMailer-Lite_v5.1/changelog.txt'
--- includes/PHPMailer-Lite_v5.1/changelog.txt	1970-01-01 00:00:00 +0000
+++ includes/PHPMailer-Lite_v5.1/changelog.txt	2011-01-26 02:48:39 +0000
@@ -0,0 +1,71 @@
+ChangeLog
+
+NOTE: THIS VERSION OF PHPMAILER LITE IS DESIGNED FOR PHP5/PHP6.
+      IT WILL NOT WORK WITH PHP4.
+
+*** VERY IMPORTANT ***********************************************************
+
+Notable differences between PHPMailer and PHPMailer Lite:
+  - PHPMailer Lite does not include support for SMTP
+  - PHPMailer Lite supports Sendmail (or Qmail) by default
+  - PHPMailer Lite requires one single file (if you need language support,
+    use the language files from PHPMailer - the only difference in language
+    files is PHPMailer Lite does not include any SMTP messages)
+
+New features introduced in PHPMailer Lite:
+  - Auto identity by default 
+    To assist in getting your email messages into the regular inbox and not
+    identified as SPAM, all you need to do is use the:
+    $mail->SetFrom('you@yourdomain.com', 'Your Name');
+    - PHPMailer Lite will automatically insert the Return-path, and Reply-To
+  - You can override the auto identity by using:
+    $mail->Sender = 'other1@yourdomain.com';
+    $mail->AddReplyTo('other2@yourdomain.com', 'Other Name');
+  - Sends one single email to each To; by default (Sendmail, Qmail, mail() )
+    - you can override this with:
+      $mail->SingleTo = false; // true is set by default
+  - Added DKIM digital signing. Tested with Yahoo, AOL, Gmail. (Tested, and
+    fails with Hotmail ... Microsoft use their own SenderID or modified SPF)
+    - to use DKIM digital signing, add these two properties:
+		$mail->DKIM_domain   = 'yourdomain.com';
+		$mail->DKIM_identity = 'you@yourdomain.com'; // optional
+		$mail->DKIM_private  = file_get_contents(/path/to/private/key/' . '.htkeyprivate');
+    everything else is managed automatically
+    (see below for instructions on creating the files needed by PHPMailer's
+    DKIM support.
+	- added callback function support
+		- callback function parameters include:
+			result, to, cc, bcc, subject and body
+		* see the test/test_callback.php file for usage.
+  - Simplified use. All you need to do is instantiate the class, and add 
+    who the email is from. Then simply build your message as you normally 
+    would. See the example, test.php
+
+******************************************************************************
+
+Version 5.1 (Sept xx, 2009) PHPMailer Lite
+* fixed filename issue with AddStringAttachment (thanks to Tony)
+* fixed "SingleTo" property, now works with Senmail, Qmail, and SMTP in
+  addition to PHP mail()
+* added DKIM digital signing functionality
+  New properties:
+  - DKIM_domain (sets the domain name)
+  - DKIM_private (holds DKIM private key)
+  - DKIM_passphrase (holds your DKIM passphrase)
+  - DKIM_selector (holds the DKIM "selector")
+  - DKIM_identity (holds the identifying email address)
+  Note: please see 
+* added callback function support
+  - callback function parameters include:
+    result, to, cc, bcc, subject and body
+* added "auto" identity functionality
+  - can automatically add:
+    - Return-path (if Sender not set)
+    - Reply-To (if ReplyTo not set)
+  - can be disabled:
+    - $mail->SetFrom('yourname@yourdomain.com','First Last',false);
+    - or by adding the $mail->Sender and/or $mail->ReplyTo properties
+  Note: "auto" identity added to help with emails ending up in spam
+  or junk boxes because of missing headers
+
+* This is the first version of PHPMailer Lite, and is based on PHPMailer v5.1 *
\ No newline at end of file

=== added file 'includes/PHPMailer-Lite_v5.1/class.phpmailer-lite.php'
--- includes/PHPMailer-Lite_v5.1/class.phpmailer-lite.php	1970-01-01 00:00:00 +0000
+++ includes/PHPMailer-Lite_v5.1/class.phpmailer-lite.php	2011-01-26 02:48:39 +0000
@@ -0,0 +1,2075 @@
+<?php
+/*~ class.phpmailer-lite.php
+.---------------------------------------------------------------------------.
+|  Software: PHPMailer Lite - PHP email class                               |
+|   Version: 5.1                                                            |
+|   Contact: via sourceforge.net support pages (also www.codeworxtech.com)  |
+|      Info: http://phpmailer.sourceforge.net                               |
+|   Support: http://sourceforge.net/projects/phpmailer/                     |
+| ------------------------------------------------------------------------- |
+|     Admin: Andy Prevost (project admininistrator)                         |
+|   Authors: Andy Prevost (codeworxtech) codeworxtech@users.sourceforge.net |
+|          : Marcus Bointon (coolbru) coolbru@users.sourceforge.net         |
+|   Founder: Brent R. Matzelle (original founder)                           |
+| Copyright (c) 2004-2009, Andy Prevost. All Rights Reserved.               |
+| Copyright (c) 2001-2003, Brent R. Matzelle                                |
+| ------------------------------------------------------------------------- |
+|   License: Distributed under the Lesser General Public License (LGPL)     |
+|            http://www.gnu.org/copyleft/lesser.html                        |
+| This program is distributed in the hope that it will be useful - WITHOUT  |
+| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or     |
+| FITNESS FOR A PARTICULAR PURPOSE.                                         |
+| ------------------------------------------------------------------------- |
+| We offer a number of paid services (www.codeworxtech.com):                |
+| - Web Hosting on highly optimized fast and secure servers                 |
+| - Technology Consulting                                                   |
+| - Oursourcing (highly qualified programmers and graphic designers)        |
+'---------------------------------------------------------------------------'
+*/
+
+/**
+ * PHPMailer Lite - PHP email transport class
+ * NOTE: Requires PHP version 5 or later
+ * @package PHPMailer Lite
+ * @author Andy Prevost
+ * @author Marcus Bointon
+ * @copyright 2004 - 2009 Andy Prevost
+ * @version $Id: class.phpmailer-lite.php 447 2009-09-12 13:21:38Z codeworxtech $
+ * @license http://www.gnu.org/copyleft/lesser.html GNU Lesser General Public License
+ */
+
+if (version_compare(PHP_VERSION, '5.0.0', '<') ) exit("Sorry, this version of PHPMailer will only run on PHP version 5 or greater!\n");
+
+class PHPMailerLite {
+
+  /////////////////////////////////////////////////
+  // PROPERTIES, PUBLIC
+  /////////////////////////////////////////////////
+
+  /**
+   * Email priority (1 = High, 3 = Normal, 5 = low).
+   * @var int
+   */
+  public $Priority          = 3;
+
+  /**
+   * Sets the CharSet of the message.
+   * @var string
+   */
+  public $CharSet           = 'iso-8859-1';
+
+  /**
+   * Sets the Content-type of the message.
+   * @var string
+   */
+  public $ContentType       = 'text/plain';
+
+  /**
+   * Sets the Encoding of the message. Options for this are
+   *  "8bit", "7bit", "binary", "base64", and "quoted-printable".
+   * @var string
+   */
+  public $Encoding          = '8bit';
+
+  /**
+   * Holds the most recent mailer error message.
+   * @var string
+   */
+  public $ErrorInfo         = '';
+
+  /**
+   * Sets the From email address for the message.
+   * @var string
+   */
+  public $From              = 'root@localhost';
+
+  /**
+   * Sets the From name of the message.
+   * @var string
+   */
+  public $FromName          = 'Root User';
+
+  /**
+   * Sets the Sender email (Return-Path) of the message.  If not empty,
+   * will be sent via -f to sendmail
+   * @var string
+   */
+  public $Sender            = '';
+
+  /**
+   * Sets the Subject of the message.
+   * @var string
+   */
+  public $Subject           = '';
+
+  /**
+   * Sets the Body of the message.  This can be either an HTML or text body.
+   * If HTML then run IsHTML(true).
+   * @var string
+   */
+  public $Body              = '';
+
+  /**
+   * Sets the text-only body of the message.  This automatically sets the
+   * email to multipart/alternative.  This body can be read by mail
+   * clients that do not have HTML email capability such as mutt. Clients
+   * that can read HTML will view the normal Body.
+   * @var string
+   */
+  public $AltBody           = '';
+
+  /**
+   * Sets word wrapping on the body of the message to a given number of
+   * characters.
+   * @var int
+   */
+  public $WordWrap          = 0;
+
+  /**
+   * Method to send mail: ("mail", or "sendmail").
+   * @var string
+   */
+  public $Mailer            = 'sendmail';
+
+  /**
+   * Sets the path of the sendmail program.
+   * @var string
+   */
+  public $Sendmail          = '/usr/sbin/sendmail';
+
+  /**
+   * Sets the email address that a reading confirmation will be sent.
+   * @var string
+   */
+  public $ConfirmReadingTo  = '';
+
+  /**
+   * Sets the hostname to use in Message-Id and Received headers
+   * and as default HELO string. If empty, the value returned
+   * by SERVER_NAME is used or 'localhost.localdomain'.
+   * @var string
+   */
+  public $Hostname          = '';
+
+  /**
+   * Sets the message ID to be used in the Message-Id header.
+   * If empty, a unique id will be generated.
+   * @var string
+   */
+  public $MessageID         = '';
+
+  /**
+   * Provides the ability to have the TO field process individual
+   * emails, instead of sending to entire TO addresses
+   * @var bool
+   */
+  public $SingleTo      = true;
+
+  /**
+   * If SingleTo is true, this provides the array to hold the email addresses
+   * @var bool
+   */
+  public $SingleToArray = array();
+
+  /**
+   * Provides the ability to change the line ending
+   * @var string
+   */
+  public $LE              = "\n";
+
+  /**
+   * Used with DKIM DNS Resource Record
+   * @var string
+   */
+  public $DKIM_selector   = 'phpmailer';
+
+  /**
+   * Used with DKIM DNS Resource Record
+   * optional, in format of email address 'you@yourdomain.com'
+   * @var string
+   */
+  public $DKIM_identity   = '';
+
+  /**
+   * Used with DKIM DNS Resource Record
+   * required, in format of base domain 'yourdomain.com'
+   * @var string
+   */
+  public $DKIM_domain     = '';
+
+  /**
+   * Used with DKIM Digital Signing process
+   * optional
+   * @var string
+   */
+  public $DKIM_passphrase = '';
+
+  /**
+   * Used with DKIM DNS Resource Record
+   * required, private key (read from /.htprivkey)
+   * @var string
+   */
+  public $DKIM_private    = '';
+
+  /**
+   * Callback Action function name
+   * the function that handles the result of the send email action. Parameters:
+   *   bool    $result        result of the send action
+   *   string  $to            email address of the recipient
+   *   string  $cc            cc email addresses
+   *   string  $bcc           bcc email addresses
+   *   string  $subject       the subject
+   *   string  $body          the email body
+   * @var string
+   */
+  public $action_function = ''; //'callbackAction';
+
+  /**
+   * Sets the PHPMailer Version number
+   * @var string
+   */
+  public $Version         = 'Lite 5.1';
+
+  /////////////////////////////////////////////////
+  // PROPERTIES, PRIVATE AND PROTECTED
+  /////////////////////////////////////////////////
+
+  private   $to             = array();
+  private   $cc             = array();
+  private   $bcc            = array();
+  private   $ReplyTo        = array();
+  private   $all_recipients = array();
+  private   $attachment     = array();
+  private   $CustomHeader   = array();
+  private   $message_type   = '';
+  private   $boundary       = array();
+  protected $language       = array();
+  private   $error_count    = 0;
+  private   $sign_cert_file = "";
+  private   $sign_key_file  = "";
+  private   $sign_key_pass  = "";
+  private   $exceptions     = false;
+
+  /////////////////////////////////////////////////
+  // CONSTANTS
+  /////////////////////////////////////////////////
+
+  const STOP_MESSAGE = 0; // message only, continue processing
+  const STOP_CONTINUE = 1; // message?, likely ok to continue processing
+  const STOP_CRITICAL = 2; // message, plus full stop, critical error reached
+
+  /////////////////////////////////////////////////
+  // METHODS, VARIABLES
+  /////////////////////////////////////////////////
+
+  /**
+   * Constructor
+   * @param boolean $exceptions Should we throw external exceptions?
+   */
+  public function __construct($exceptions = false) {
+    $this->exceptions = ($exceptions == true);
+  }
+
+  /**
+   * Sets message type to HTML.
+   * @param bool $ishtml
+   * @return void
+   */
+  public function IsHTML($ishtml = true) {
+    if ($ishtml) {
+      $this->ContentType = 'text/html';
+    } else {
+      $this->ContentType = 'text/plain';
+    }
+  }
+
+  /**
+   * Sets Mailer to send message using PHP mail() function.
+   * @return void
+   */
+  public function IsMail() {
+    $this->Mailer = 'mail';
+  }
+
+  /**
+   * Sets Mailer to send message using the $Sendmail program.
+   * @return void
+   */
+  public function IsSendmail() {
+    if (!stristr(ini_get('sendmail_path'), 'sendmail')) {
+      $this->Sendmail = '/var/qmail/bin/sendmail';
+    }
+    $this->Mailer = 'sendmail';
+  }
+
+  /**
+   * Sets Mailer to send message using the qmail MTA.
+   * @return void
+   */
+  public function IsQmail() {
+    if (stristr(ini_get('sendmail_path'), 'qmail')) {
+      $this->Sendmail = '/var/qmail/bin/sendmail';
+    }
+    $this->Mailer = 'sendmail';
+  }
+
+  /////////////////////////////////////////////////
+  // METHODS, RECIPIENTS
+  /////////////////////////////////////////////////
+
+  /**
+   * Adds a "To" address.
+   * @param string $address
+   * @param string $name
+   * @return boolean true on success, false if address already used
+   */
+  public function AddAddress($address, $name = '') {
+    return $this->AddAnAddress('to', $address, $name);
+  }
+
+  /**
+   * Adds a "Cc" address.
+   * Note: this function works with the SMTP mailer on win32, not with the "mail" mailer.
+   * @param string $address
+   * @param string $name
+   * @return boolean true on success, false if address already used
+   */
+  public function AddCC($address, $name = '') {
+    return $this->AddAnAddress('cc', $address, $name);
+  }
+
+  /**
+   * Adds a "Bcc" address.
+   * Note: this function works with the SMTP mailer on win32, not with the "mail" mailer.
+   * @param string $address
+   * @param string $name
+   * @return boolean true on success, false if address already used
+   */
+  public function AddBCC($address, $name = '') {
+    return $this->AddAnAddress('bcc', $address, $name);
+  }
+
+  /**
+   * Adds a "Reply-to" address.
+   * @param string $address
+   * @param string $name
+   * @return boolean
+   */
+  public function AddReplyTo($address, $name = '') {
+    return $this->AddAnAddress('ReplyTo', $address, $name);
+  }
+
+  /**
+   * Adds an address to one of the recipient arrays
+   * Addresses that have been added already return false, but do not throw exceptions
+   * @param string $kind One of 'to', 'cc', 'bcc', 'ReplyTo'
+   * @param string $address The email address to send to
+   * @param string $name
+   * @return boolean true on success, false if address already used or invalid in some way
+   * @access private
+   */
+  private function AddAnAddress($kind, $address, $name = '') {
+    if (!preg_match('/^(to|cc|bcc|ReplyTo)$/', $kind)) {
+      echo 'Invalid recipient array: ' . kind;
+      return false;
+    }
+    $address = trim($address);
+    $name = trim(preg_replace('/[\r\n]+/', '', $name)); //Strip breaks and trim
+    if (!self::ValidateAddress($address)) {
+      $this->SetError($this->Lang('invalid_address').': '. $address);
+      if ($this->exceptions) {
+        throw new phpmailerException($this->Lang('invalid_address').': '.$address);
+      }
+      echo $this->Lang('invalid_address').': '.$address;
+      return false;
+    }
+  if ($kind != 'ReplyTo') {
+    if (!isset($this->all_recipients[strtolower($address)])) {
+      array_push($this->$kind, array($address, $name));
+      $this->all_recipients[strtolower($address)] = true;
+      return true;
+    }
+  } else {
+    if (!array_key_exists(strtolower($address), $this->ReplyTo)) {
+      $this->ReplyTo[strtolower($address)] = array($address, $name);
+      return true;
+    }
+  }
+  return false;
+}
+
+/**
+ * Set the From and FromName properties
+ * @param string $address
+ * @param string $name
+ * @return boolean
+ */
+  public function SetFrom($address, $name = '',$auto=1) {
+    $address = trim($address);
+    $name = trim(preg_replace('/[\r\n]+/', '', $name)); //Strip breaks and trim
+    if (!self::ValidateAddress($address)) {
+      $this->SetError($this->Lang('invalid_address').': '. $address);
+      if ($this->exceptions) {
+        throw new phpmailerException($this->Lang('invalid_address').': '.$address);
+      }
+      echo $this->Lang('invalid_address').': '.$address;
+      return false;
+    }
+    $this->From = $address;
+    $this->FromName = $name;
+    if ($auto) {
+      if (empty($this->ReplyTo)) {
+        $this->AddAnAddress('ReplyTo', $address, $name);
+      }
+      if (empty($this->Sender)) {
+        $this->Sender = $address;
+      }
+    }
+  return true;
+  }
+
+  /**
+   * Check that a string looks roughly like an email address should
+   * Static so it can be used without instantiation
+   * Tries to use PHP built-in validator in the filter extension (from PHP 5.2), falls back to a reasonably competent regex validator
+   * Conforms approximately to RFC2822
+   * @link http://www.hexillion.com/samples/#Regex Original pattern found here
+   * @param string $address The email address to check
+   * @return boolean
+   * @static
+   * @access public
+   */
+  public static function ValidateAddress($address) {
+    if (function_exists('filter_var')) { //Introduced in PHP 5.2
+      if(filter_var($address, FILTER_VALIDATE_EMAIL) === FALSE) {
+        return false;
+      } else {
+        return true;
+      }
+    } else {
+      return preg_match('/^(?:[\w\!\#\$\%\&\'\*\+\-\/\=\?\^\`\{\|\}\~]+\.)*[\w\!\#\$\%\&\'\*\+\-\/\=\?\^\`\{\|\}\~]+@(?:(?:(?:[a-zA-Z0-9_](?:[a-zA-Z0-9_\-](?!\.)){0,61}[a-zA-Z0-9_-]?\.)+[a-zA-Z0-9_](?:[a-zA-Z0-9_\-](?!$)){0,61}[a-zA-Z0-9_]?)|(?:\[(?:(?:[01]?\d{1,2}|2[0-4]\d|25[0-5])\.){3}(?:[01]?\d{1,2}|2[0-4]\d|25[0-5])\]))$/', $address);
+    }
+  }
+
+  /////////////////////////////////////////////////
+  // METHODS, MAIL SENDING
+  /////////////////////////////////////////////////
+
+  /**
+   * Creates message and assigns Mailer. If the message is
+   * not sent successfully then it returns false.  Use the ErrorInfo
+   * variable to view description of the error.
+   * @return bool
+   */
+  public function Send() {
+    try {
+      if ((count($this->to) + count($this->cc) + count($this->bcc)) < 1) {
+        throw new phpmailerException($this->Lang('provide_address'), self::STOP_CRITICAL);
+      }
+
+      // Set whether the message is multipart/alternative
+      if(!empty($this->AltBody)) {
+        $this->ContentType = 'multipart/alternative';
+      }
+
+      $this->error_count = 0; // reset errors
+      $this->SetMessageType();
+      $header = $this->CreateHeader();
+      $body = $this->CreateBody();
+
+      if (empty($this->Body)) {
+        throw new phpmailerException($this->Lang('empty_message'), self::STOP_CRITICAL);
+      }
+
+      // digitally sign with DKIM if enabled
+      if ($this->DKIM_domain && $this->DKIM_private) {
+        $header_dkim = $this->DKIM_Add($header,$this->Subject,$body);
+        $header = str_replace("\r\n","\n",$header_dkim) . $header;
+      }
+
+      // Choose the mailer and send through it
+      switch($this->Mailer) {
+        case 'sendmail':
+          $sendAction = $this->SendmailSend($header, $body);
+          return $sendAction;
+        default:
+          $sendAction = $this->MailSend($header, $body);
+          return $sendAction;
+      }
+
+    } catch (phpmailerException $e) {
+      $this->SetError($e->getMessage());
+      if ($this->exceptions) {
+        throw $e;
+      }
+      echo $e->getMessage()."\n";
+      return false;
+    }
+  }
+
+  /**
+   * Sends mail using the $Sendmail program.
+   * @param string $header The message headers
+   * @param string $body The message body
+   * @access protected
+   * @return bool
+   */
+  protected function SendmailSend($header, $body) {
+    if ($this->Sender != '') {
+      $sendmail = sprintf("%s -oi -f %s -t", escapeshellcmd($this->Sendmail), escapeshellarg($this->Sender));
+    } else {
+      $sendmail = sprintf("%s -oi -t", escapeshellcmd($this->Sendmail));
+    }
+    if ($this->SingleTo === true) {
+      foreach ($this->SingleToArray as $key => $val) {
+        if(!@$mail = popen($sendmail, 'w')) {
+          throw new phpmailerException($this->Lang('execute') . $this->Sendmail, self::STOP_CRITICAL);
+        }
+        fputs($mail, "To: " . $val . "\n");
+        fputs($mail, $header);
+        fputs($mail, $body);
+        $result = pclose($mail);
+        // implement call back function if it exists
+        $isSent = ($result == 0) ? 1 : 0;
+        $this->doCallback($isSent,$val,$this->cc,$this->bcc,$this->Subject,$body);
+        if($result != 0) {
+          throw new phpmailerException($this->Lang('execute') . $this->Sendmail, self::STOP_CRITICAL);
+        }
+      }
+    } else {
+      if(!@$mail = popen($sendmail, 'w')) {
+        throw new phpmailerException($this->Lang('execute') . $this->Sendmail, self::STOP_CRITICAL);
+      }
+      fputs($mail, $header);
+      fputs($mail, $body);
+      $result = pclose($mail);
+      // implement call back function if it exists
+      $isSent = ($result == 0) ? 1 : 0;
+      $this->doCallback($isSent,$this->to,$this->cc,$this->bcc,$this->Subject,$body);
+      if($result != 0) {
+        throw new phpmailerException($this->Lang('execute') . $this->Sendmail, self::STOP_CRITICAL);
+      }
+    }
+    return true;
+  }
+
+  /**
+   * Sends mail using the PHP mail() function.
+   * @param string $header The message headers
+   * @param string $body The message body
+   * @access protected
+   * @return bool
+   */
+  protected function MailSend($header, $body) {
+    $toArr = array();
+    foreach($this->to as $t) {
+      $toArr[] = $this->AddrFormat($t);
+    }
+    $to = implode(', ', $toArr);
+
+    $params = sprintf("-oi -f %s", $this->Sender);
+    if ($this->Sender != '' && strlen(ini_get('safe_mode'))< 1) {
+      $old_from = ini_get('sendmail_from');
+      ini_set('sendmail_from', $this->Sender);
+      if ($this->SingleTo === true && count($toArr) > 1) {
+        foreach ($toArr as $key => $val) {
+          $rt = @mail($val, $this->EncodeHeader($this->SecureHeader($this->Subject)), $body, $header, $params);
+          // implement call back function if it exists
+          $isSent = ($rt == 1) ? 1 : 0;
+          $this->doCallback($isSent,$val,$this->cc,$this->bcc,$this->Subject,$body);
+        }
+      } else {
+        $rt = @mail($to, $this->EncodeHeader($this->SecureHeader($this->Subject)), $body, $header, $params);
+        // implement call back function if it exists
+        $isSent = ($rt == 1) ? 1 : 0;
+        $this->doCallback($isSent,$to,$this->cc,$this->bcc,$this->Subject,$body);
+      }
+    } else {
+      if ($this->SingleTo === true && count($toArr) > 1) {
+        foreach ($toArr as $key => $val) {
+          $rt = @mail($val, $this->EncodeHeader($this->SecureHeader($this->Subject)), $body, $header, $params);
+          // implement call back function if it exists
+          $isSent = ($rt == 1) ? 1 : 0;
+          $this->doCallback($isSent,$val,$this->cc,$this->bcc,$this->Subject,$body);
+        }
+      } else {
+        $rt = @mail($to, $this->EncodeHeader($this->SecureHeader($this->Subject)), $body, $header);
+        // implement call back function if it exists
+        $isSent = ($rt == 1) ? 1 : 0;
+        $this->doCallback($isSent,$to,$this->cc,$this->bcc,$this->Subject,$body);
+      }
+    }
+    if (isset($old_from)) {
+      ini_set('sendmail_from', $old_from);
+    }
+    if(!$rt) {
+      throw new phpmailerException($this->Lang('instantiate'), self::STOP_CRITICAL);
+    }
+    return true;
+  }
+
+  /**
+  * Sets the language for all class error messages.
+  * Returns false if it cannot load the language file.  The default language is English.
+  * @param string $langcode ISO 639-1 2-character language code (e.g. Portuguese: "br")
+  * @param string $lang_path Path to the language file directory
+  * @access public
+  */
+  function SetLanguage($langcode = 'en', $lang_path = 'language/') {
+    //Define full set of translatable strings
+    $PHPMAILER_LANG = array(
+      'provide_address' => 'You must provide at least one recipient email address.',
+      'mailer_not_supported' => ' mailer is not supported.',
+      'execute' => 'Could not execute: ',
+      'instantiate' => 'Could not instantiate mail function.',
+      'from_failed' => 'The following From address failed: ',
+      'file_access' => 'Could not access file: ',
+      'file_open' => 'File Error: Could not open file: ',
+      'encoding' => 'Unknown encoding: ',
+      'signing' => 'Signing Error: ',
+      'empty_message' => 'Message body empty',
+      'invalid_address' => 'Invalid address',
+      'variable_set' => 'Cannot set or reset variable: '
+    );
+    //Overwrite language-specific strings. This way we'll never have missing translations - no more "language string failed to load"!
+    $l = true;
+    if ($langcode != 'en') { //There is no English translation file
+      $l = @include $lang_path.'phpmailer.lang-'.$langcode.'.php';
+    }
+    $this->language = $PHPMAILER_LANG;
+    return ($l == true); //Returns false if language not found
+  }
+
+  /**
+  * Return the current array of language strings
+  * @return array
+  */
+  public function GetTranslations() {
+    return $this->language;
+  }
+
+  /////////////////////////////////////////////////
+  // METHODS, MESSAGE CREATION
+  /////////////////////////////////////////////////
+
+  /**
+   * Creates recipient headers.
+   * @access public
+   * @return string
+   */
+  public function AddrAppend($type, $addr) {
+    $addr_str = $type . ': ';
+    $addresses = array();
+    foreach ($addr as $a) {
+      $addresses[] = $this->AddrFormat($a);
+    }
+    $addr_str .= implode(', ', $addresses);
+    $addr_str .= $this->LE;
+
+    return $addr_str;
+  }
+
+  /**
+   * Formats an address correctly.
+   * @access public
+   * @return string
+   */
+  public function AddrFormat($addr) {
+    if (empty($addr[1])) {
+      return $this->SecureHeader($addr[0]);
+    } else {
+      return $this->EncodeHeader($this->SecureHeader($addr[1]), 'phrase') . " <" . $this->SecureHeader($addr[0]) . ">";
+    }
+  }
+
+  /**
+   * Wraps message for use with mailers that do not
+   * automatically perform wrapping and for quoted-printable.
+   * Original written by philippe.
+   * @param string $message The message to wrap
+   * @param integer $length The line length to wrap to
+   * @param boolean $qp_mode Whether to run in Quoted-Printable mode
+   * @access public
+   * @return string
+   */
+  public function WrapText($message, $length, $qp_mode = false) {
+    $soft_break = ($qp_mode) ? sprintf(" =%s", $this->LE) : $this->LE;
+    // If utf-8 encoding is used, we will need to make sure we don't
+    // split multibyte characters when we wrap
+    $is_utf8 = (strtolower($this->CharSet) == "utf-8");
+
+    $message = $this->FixEOL($message);
+    if (substr($message, -1) == $this->LE) {
+      $message = substr($message, 0, -1);
+    }
+
+    $line = explode($this->LE, $message);
+    $message = '';
+    for ($i=0 ;$i < count($line); $i++) {
+      $line_part = explode(' ', $line[$i]);
+      $buf = '';
+      for ($e = 0; $e<count($line_part); $e++) {
+        $word = $line_part[$e];
+        if ($qp_mode and (strlen($word) > $length)) {
+          $space_left = $length - strlen($buf) - 1;
+          if ($e != 0) {
+            if ($space_left > 20) {
+              $len = $space_left;
+              if ($is_utf8) {
+                $len = $this->UTF8CharBoundary($word, $len);
+              } elseif (substr($word, $len - 1, 1) == "=") {
+                $len--;
+              } elseif (substr($word, $len - 2, 1) == "=") {
+                $len -= 2;
+              }
+              $part = substr($word, 0, $len);
+              $word = substr($word, $len);
+              $buf .= ' ' . $part;
+              $message .= $buf . sprintf("=%s", $this->LE);
+            } else {
+              $message .= $buf . $soft_break;
+            }
+            $buf = '';
+          }
+          while (strlen($word) > 0) {
+            $len = $length;
+            if ($is_utf8) {
+              $len = $this->UTF8CharBoundary($word, $len);
+            } elseif (substr($word, $len - 1, 1) == "=") {
+              $len--;
+            } elseif (substr($word, $len - 2, 1) == "=") {
+              $len -= 2;
+            }
+            $part = substr($word, 0, $len);
+            $word = substr($word, $len);
+
+            if (strlen($word) > 0) {
+              $message .= $part . sprintf("=%s", $this->LE);
+            } else {
+              $buf = $part;
+            }
+          }
+        } else {
+          $buf_o = $buf;
+          $buf .= ($e == 0) ? $word : (' ' . $word);
+
+          if (strlen($buf) > $length and $buf_o != '') {
+            $message .= $buf_o . $soft_break;
+            $buf = $word;
+          }
+        }
+      }
+      $message .= $buf . $this->LE;
+    }
+
+    return $message;
+  }
+
+  /**
+   * Finds last character boundary prior to maxLength in a utf-8
+   * quoted (printable) encoded string.
+   * Original written by Colin Brown.
+   * @access public
+   * @param string $encodedText utf-8 QP text
+   * @param int    $maxLength   find last character boundary prior to this length
+   * @return int
+   */
+  public function UTF8CharBoundary($encodedText, $maxLength) {
+    $foundSplitPos = false;
+    $lookBack = 3;
+    while (!$foundSplitPos) {
+      $lastChunk = substr($encodedText, $maxLength - $lookBack, $lookBack);
+      $encodedCharPos = strpos($lastChunk, "=");
+      if ($encodedCharPos !== false) {
+        // Found start of encoded character byte within $lookBack block.
+        // Check the encoded byte value (the 2 chars after the '=')
+        $hex = substr($encodedText, $maxLength - $lookBack + $encodedCharPos + 1, 2);
+        $dec = hexdec($hex);
+        if ($dec < 128) { // Single byte character.
+          // If the encoded char was found at pos 0, it will fit
+          // otherwise reduce maxLength to start of the encoded char
+          $maxLength = ($encodedCharPos == 0) ? $maxLength :
+          $maxLength - ($lookBack - $encodedCharPos);
+          $foundSplitPos = true;
+        } elseif ($dec >= 192) { // First byte of a multi byte character
+          // Reduce maxLength to split at start of character
+          $maxLength = $maxLength - ($lookBack - $encodedCharPos);
+          $foundSplitPos = true;
+        } elseif ($dec < 192) { // Middle byte of a multi byte character, look further back
+          $lookBack += 3;
+        }
+      } else {
+        // No encoded character found
+        $foundSplitPos = true;
+      }
+    }
+    return $maxLength;
+  }
+
+  /**
+   * Set the body wrapping.
+   * @access public
+   * @return void
+   */
+  public function SetWordWrap() {
+    if($this->WordWrap < 1) {
+      return;
+    }
+    switch($this->message_type) {
+      case 'alt':
+      case 'alt_attachments':
+        $this->AltBody = $this->WrapText($this->AltBody, $this->WordWrap);
+        break;
+      default:
+        $this->Body = $this->WrapText($this->Body, $this->WordWrap);
+        break;
+    }
+  }
+
+  /**
+   * Assembles message header.
+   * @access public
+   * @return string The assembled header
+   */
+  public function CreateHeader() {
+    $result = '';
+
+    // Set the boundaries
+    $uniq_id = md5(uniqid(time()));
+    $this->boundary[1] = 'b1_' . $uniq_id;
+    $this->boundary[2] = 'b2_' . $uniq_id;
+
+    $result .= $this->HeaderLine('Date', self::RFCDate());
+    if($this->Sender == '') {
+      $result .= $this->HeaderLine('Return-Path', trim($this->From));
+    } else {
+      $result .= $this->HeaderLine('Return-Path', trim($this->Sender));
+    }
+
+    // To be created automatically by mail()
+    if($this->Mailer != 'mail') {
+      if ($this->SingleTo === true) {
+        foreach($this->to as $t) {
+          $this->SingleToArray[] = $this->AddrFormat($t);
+        }
+      } else {
+        if(count($this->to) > 0) {
+          $result .= $this->AddrAppend('To', $this->to);
+        } elseif (count($this->cc) == 0) {
+          $result .= $this->HeaderLine('To', 'undisclosed-recipients:;');
+        }
+      }
+    }
+
+    $from = array();
+    $from[0][0] = trim($this->From);
+    $from[0][1] = $this->FromName;
+    $result .= $this->AddrAppend('From', $from);
+
+    // sendmail and mail() extract Cc from the header before sending
+    if(count($this->cc) > 0) {
+      $result .= $this->AddrAppend('Cc', $this->cc);
+    }
+
+    // sendmail and mail() extract Bcc from the header before sending
+    if(count($this->bcc) > 0) {
+      $result .= $this->AddrAppend('Bcc', $this->bcc);
+    }
+
+    if(count($this->ReplyTo) > 0) {
+      $result .= $this->AddrAppend('Reply-to', $this->ReplyTo);
+    }
+
+    // mail() sets the subject itself
+    if($this->Mailer != 'mail') {
+      $result .= $this->HeaderLine('Subject', $this->EncodeHeader($this->SecureHeader($this->Subject)));
+    }
+
+    if($this->MessageID != '') {
+      $result .= $this->HeaderLine('Message-ID',$this->MessageID);
+    } else {
+      $result .= sprintf("Message-ID: <%s@%s>%s", $uniq_id, $this->ServerHostname(), $this->LE);
+    }
+    $result .= $this->HeaderLine('X-Priority', $this->Priority);
+    $result .= $this->HeaderLine('X-Mailer', 'PHPMailer '.$this->Version.' (phpmailer.codeworxtech.com)');
+
+    if($this->ConfirmReadingTo != '') {
+      $result .= $this->HeaderLine('Disposition-Notification-To', '<' . trim($this->ConfirmReadingTo) . '>');
+    }
+
+    // Add custom headers
+    for($index = 0; $index < count($this->CustomHeader); $index++) {
+      $result .= $this->HeaderLine(trim($this->CustomHeader[$index][0]), $this->EncodeHeader(trim($this->CustomHeader[$index][1])));
+    }
+    if (!$this->sign_key_file) {
+      $result .= $this->HeaderLine('MIME-Version', '1.0');
+      $result .= $this->GetMailMIME();
+    }
+
+    return $result;
+  }
+
+  /**
+   * Returns the message MIME.
+   * @access public
+   * @return string
+   */
+  public function GetMailMIME() {
+    $result = '';
+    switch($this->message_type) {
+      case 'plain':
+        $result .= $this->HeaderLine('Content-Transfer-Encoding', $this->Encoding);
+        $result .= sprintf("Content-Type: %s; charset=\"%s\"", $this->ContentType, $this->CharSet);
+        break;
+      case 'attachments':
+      case 'alt_attachments':
+        if($this->InlineImageExists()){
+          $result .= sprintf("Content-Type: %s;%s\ttype=\"text/html\";%s\tboundary=\"%s\"%s", 'multipart/related', $this->LE, $this->LE, $this->boundary[1], $this->LE);
+        } else {
+          $result .= $this->HeaderLine('Content-Type', 'multipart/mixed;');
+          $result .= $this->TextLine("\tboundary=\"" . $this->boundary[1] . '"');
+        }
+        break;
+      case 'alt':
+        $result .= $this->HeaderLine('Content-Type', 'multipart/alternative;');
+        $result .= $this->TextLine("\tboundary=\"" . $this->boundary[1] . '"');
+        break;
+    }
+
+    if($this->Mailer != 'mail') {
+      $result .= $this->LE.$this->LE;
+    }
+
+    return $result;
+  }
+
+  /**
+   * Assembles the message body.  Returns an empty string on failure.
+   * @access public
+   * @return string The assembled message body
+   */
+  public function CreateBody() {
+    $body = '';
+
+    if ($this->sign_key_file) {
+      $body .= $this->GetMailMIME();
+    }
+
+    $this->SetWordWrap();
+
+    switch($this->message_type) {
+      case 'alt':
+        $body .= $this->GetBoundary($this->boundary[1], '', 'text/plain', '');
+        $body .= $this->EncodeString($this->AltBody, $this->Encoding);
+        $body .= $this->LE.$this->LE;
+        $body .= $this->GetBoundary($this->boundary[1], '', 'text/html', '');
+        $body .= $this->EncodeString($this->Body, $this->Encoding);
+        $body .= $this->LE.$this->LE;
+        $body .= $this->EndBoundary($this->boundary[1]);
+        break;
+      case 'plain':
+        $body .= $this->EncodeString($this->Body, $this->Encoding);
+        break;
+      case 'attachments':
+        $body .= $this->GetBoundary($this->boundary[1], '', '', '');
+        $body .= $this->EncodeString($this->Body, $this->Encoding);
+        $body .= $this->LE;
+        $body .= $this->AttachAll();
+        break;
+      case 'alt_attachments':
+        $body .= sprintf("--%s%s", $this->boundary[1], $this->LE);
+        $body .= sprintf("Content-Type: %s;%s" . "\tboundary=\"%s\"%s", 'multipart/alternative', $this->LE, $this->boundary[2], $this->LE.$this->LE);
+        $body .= $this->GetBoundary($this->boundary[2], '', 'text/plain', '') . $this->LE; // Create text body
+        $body .= $this->EncodeString($this->AltBody, $this->Encoding);
+        $body .= $this->LE.$this->LE;
+        $body .= $this->GetBoundary($this->boundary[2], '', 'text/html', '') . $this->LE; // Create the HTML body
+        $body .= $this->EncodeString($this->Body, $this->Encoding);
+        $body .= $this->LE.$this->LE;
+        $body .= $this->EndBoundary($this->boundary[2]);
+        $body .= $this->AttachAll();
+        break;
+    }
+
+    if ($this->IsError()) {
+      $body = '';
+    } elseif ($this->sign_key_file) {
+      try {
+        $file = tempnam('', 'mail');
+        file_put_contents($file, $body); //TODO check this worked
+        $signed = tempnam("", "signed");
+        if (@openssl_pkcs7_sign($file, $signed, "file://".$this->sign_cert_file, array("file://".$this->sign_key_file, $this->sign_key_pass), NULL)) {
+          @unlink($file);
+          @unlink($signed);
+          $body = file_get_contents($signed);
+        } else {
+          @unlink($file);
+          @unlink($signed);
+          throw new phpmailerException($this->Lang("signing").openssl_error_string());
+        }
+      } catch (phpmailerException $e) {
+        $body = '';
+        if ($this->exceptions) {
+          throw $e;
+        }
+      }
+    }
+
+    return $body;
+  }
+
+  /**
+   * Returns the start of a message boundary.
+   * @access private
+   */
+  private function GetBoundary($boundary, $charSet, $contentType, $encoding) {
+    $result = '';
+    if($charSet == '') {
+      $charSet = $this->CharSet;
+    }
+    if($contentType == '') {
+      $contentType = $this->ContentType;
+    }
+    if($encoding == '') {
+      $encoding = $this->Encoding;
+    }
+    $result .= $this->TextLine('--' . $boundary);
+    $result .= sprintf("Content-Type: %s; charset = \"%s\"", $contentType, $charSet);
+    $result .= $this->LE;
+    $result .= $this->HeaderLine('Content-Transfer-Encoding', $encoding);
+    $result .= $this->LE;
+
+    return $result;
+  }
+
+  /**
+   * Returns the end of a message boundary.
+   * @access private
+   */
+  private function EndBoundary($boundary) {
+    return $this->LE . '--' . $boundary . '--' . $this->LE;
+  }
+
+  /**
+   * Sets the message type.
+   * @access private
+   * @return void
+   */
+  private function SetMessageType() {
+    if(count($this->attachment) < 1 && strlen($this->AltBody) < 1) {
+      $this->message_type = 'plain';
+    } else {
+      if(count($this->attachment) > 0) {
+        $this->message_type = 'attachments';
+      }
+      if(strlen($this->AltBody) > 0 && count($this->attachment) < 1) {
+        $this->message_type = 'alt';
+      }
+      if(strlen($this->AltBody) > 0 && count($this->attachment) > 0) {
+        $this->message_type = 'alt_attachments';
+      }
+    }
+  }
+
+  /**
+   *  Returns a formatted header line.
+   * @access public
+   * @return string
+   */
+  public function HeaderLine($name, $value) {
+    return $name . ': ' . $value . $this->LE;
+  }
+
+  /**
+   * Returns a formatted mail line.
+   * @access public
+   * @return string
+   */
+  public function TextLine($value) {
+    return $value . $this->LE;
+  }
+
+  /////////////////////////////////////////////////
+  // CLASS METHODS, ATTACHMENTS
+  /////////////////////////////////////////////////
+
+  /**
+   * Adds an attachment from a path on the filesystem.
+   * Returns false if the file could not be found
+   * or accessed.
+   * @param string $path Path to the attachment.
+   * @param string $name Overrides the attachment name.
+   * @param string $encoding File encoding (see $Encoding).
+   * @param string $type File extension (MIME) type.
+   * @return bool
+   */
+  public function AddAttachment($path, $name = '', $encoding = 'base64', $type = 'application/octet-stream') {
+    try {
+      if ( !@is_file($path) ) {
+        throw new phpmailerException($this->Lang('file_access') . $path, self::STOP_CONTINUE);
+      }
+      $filename = basename($path);
+      if ( $name == '' ) {
+        $name = $filename;
+      }
+
+      $this->attachment[] = array(
+        0 => $path,
+        1 => $filename,
+        2 => $name,
+        3 => $encoding,
+        4 => $type,
+        5 => false,  // isStringAttachment
+        6 => 'attachment',
+        7 => 0
+      );
+
+    } catch (phpmailerException $e) {
+      $this->SetError($e->getMessage());
+      if ($this->exceptions) {
+        throw $e;
+      }
+      echo $e->getMessage()."\n";
+      if ( $e->getCode() == self::STOP_CRITICAL ) {
+        return false;
+      }
+    }
+    return true;
+  }
+
+  /**
+  * Return the current array of attachments
+  * @return array
+  */
+  public function GetAttachments() {
+    return $this->attachment;
+  }
+
+  /**
+   * Attaches all fs, string, and binary attachments to the message.
+   * Returns an empty string on failure.
+   * @access private
+   * @return string
+   */
+  private function AttachAll() {
+    // Return text of body
+    $mime = array();
+    $cidUniq = array();
+    $incl = array();
+
+    // Add all attachments
+    foreach ($this->attachment as $attachment) {
+      // Check for string attachment
+      $bString = $attachment[5];
+      if ($bString) {
+        $string = $attachment[0];
+      } else {
+        $path = $attachment[0];
+      }
+
+      if (in_array($attachment[0], $incl)) { continue; }
+      $filename    = $attachment[1];
+      $name        = $attachment[2];
+      $encoding    = $attachment[3];
+      $type        = $attachment[4];
+      $disposition = $attachment[6];
+      $cid         = $attachment[7];
+      $incl[]      = $attachment[0];
+      if ( $disposition == 'inline' && isset($cidUniq[$cid]) ) { continue; }
+      $cidUniq[$cid] = true;
+
+      $mime[] = sprintf("--%s%s", $this->boundary[1], $this->LE);
+      $mime[] = sprintf("Content-Type: %s; name=\"%s\"%s", $type, $this->EncodeHeader($this->SecureHeader($name)), $this->LE);
+      $mime[] = sprintf("Content-Transfer-Encoding: %s%s", $encoding, $this->LE);
+
+      if($disposition == 'inline') {
+        $mime[] = sprintf("Content-ID: <%s>%s", $cid, $this->LE);
+      }
+
+      $mime[] = sprintf("Content-Disposition: %s; filename=\"%s\"%s", $disposition, $this->EncodeHeader($this->SecureHeader($name)), $this->LE.$this->LE);
+
+      // Encode as string attachment
+      if($bString) {
+        $mime[] = $this->EncodeString($string, $encoding);
+        if($this->IsError()) {
+          return '';
+        }
+        $mime[] = $this->LE.$this->LE;
+      } else {
+        $mime[] = $this->EncodeFile($path, $encoding);
+        if($this->IsError()) {
+          return '';
+        }
+        $mime[] = $this->LE.$this->LE;
+      }
+    }
+
+    $mime[] = sprintf("--%s--%s", $this->boundary[1], $this->LE);
+
+    return join('', $mime);
+  }
+
+  /**
+   * Encodes attachment in requested format.
+   * Returns an empty string on failure.
+   * @param string $path The full path to the file
+   * @param string $encoding The encoding to use; one of 'base64', '7bit', '8bit', 'binary', 'quoted-printable'
+   * @see EncodeFile()
+   * @access private
+   * @return string
+   */
+  private function EncodeFile($path, $encoding = 'base64') {
+    try {
+      if (!is_readable($path)) {
+        throw new phpmailerException($this->Lang('file_open') . $path, self::STOP_CONTINUE);
+      }
+      if (function_exists('get_magic_quotes')) {
+        function get_magic_quotes() {
+          return false;
+        }
+      }
+      if (PHP_VERSION < 6) {
+        $magic_quotes = get_magic_quotes_runtime();
+        set_magic_quotes_runtime(0);
+      }
+      $file_buffer  = file_get_contents($path);
+      $file_buffer  = $this->EncodeString($file_buffer, $encoding);
+      if (PHP_VERSION < 6) { set_magic_quotes_runtime($magic_quotes); }
+      return $file_buffer;
+    } catch (Exception $e) {
+      $this->SetError($e->getMessage());
+      return '';
+    }
+  }
+
+  /**
+   * Encodes string to requested format.
+   * Returns an empty string on failure.
+   * @param string $str The text to encode
+   * @param string $encoding The encoding to use; one of 'base64', '7bit', '8bit', 'binary', 'quoted-printable'
+   * @access public
+   * @return string
+   */
+  public function EncodeString ($str, $encoding = 'base64') {
+    $encoded = '';
+    switch(strtolower($encoding)) {
+      case 'base64':
+        $encoded = chunk_split(base64_encode($str), 76, $this->LE);
+        break;
+      case '7bit':
+      case '8bit':
+        $encoded = $this->FixEOL($str);
+        //Make sure it ends with a line break
+        if (substr($encoded, -(strlen($this->LE))) != $this->LE)
+          $encoded .= $this->LE;
+        break;
+      case 'binary':
+        $encoded = $str;
+        break;
+      case 'quoted-printable':
+        $encoded = $this->EncodeQP($str);
+        break;
+      default:
+        $this->SetError($this->Lang('encoding') . $encoding);
+        break;
+    }
+    return $encoded;
+  }
+
+  /**
+   * Encode a header string to best (shortest) of Q, B, quoted or none.
+   * @access public
+   * @return string
+   */
+  public function EncodeHeader($str, $position = 'text') {
+    $x = 0;
+
+    switch (strtolower($position)) {
+      case 'phrase':
+        if (!preg_match('/[\200-\377]/', $str)) {
+          // Can't use addslashes as we don't know what value has magic_quotes_sybase
+          $encoded = addcslashes($str, "\0..\37\177\\\"");
+          if (($str == $encoded) && !preg_match('/[^A-Za-z0-9!#$%&\'*+\/=?^_`{|}~ -]/', $str)) {
+            return ($encoded);
+          } else {
+            return ("\"$encoded\"");
+          }
+        }
+        $x = preg_match_all('/[^\040\041\043-\133\135-\176]/', $str, $matches);
+        break;
+      case 'comment':
+        $x = preg_match_all('/[()"]/', $str, $matches);
+        // Fall-through
+      case 'text':
+      default:
+        $x += preg_match_all('/[\000-\010\013\014\016-\037\177-\377]/', $str, $matches);
+        break;
+    }
+
+    if ($x == 0) {
+      return ($str);
+    }
+
+    $maxlen = 75 - 7 - strlen($this->CharSet);
+    // Try to select the encoding which should produce the shortest output
+    if (strlen($str)/3 < $x) {
+      $encoding = 'B';
+      if (function_exists('mb_strlen') && $this->HasMultiBytes($str)) {
+        // Use a custom function which correctly encodes and wraps long
+        // multibyte strings without breaking lines within a character
+        $encoded = $this->Base64EncodeWrapMB($str);
+      } else {
+        $encoded = base64_encode($str);
+        $maxlen -= $maxlen % 4;
+        $encoded = trim(chunk_split($encoded, $maxlen, "\n"));
+      }
+    } else {
+      $encoding = 'Q';
+      $encoded = $this->EncodeQ($str, $position);
+      $encoded = $this->WrapText($encoded, $maxlen, true);
+      $encoded = str_replace('='.$this->LE, "\n", trim($encoded));
+    }
+
+    $encoded = preg_replace('/^(.*)$/m', " =?".$this->CharSet."?$encoding?\\1?=", $encoded);
+    $encoded = trim(str_replace("\n", $this->LE, $encoded));
+
+    return $encoded;
+  }
+
+  /**
+   * Checks if a string contains multibyte characters.
+   * @access public
+   * @param string $str multi-byte text to wrap encode
+   * @return bool
+   */
+  public function HasMultiBytes($str) {
+    if (function_exists('mb_strlen')) {
+      return (strlen($str) > mb_strlen($str, $this->CharSet));
+    } else { // Assume no multibytes (we can't handle without mbstring functions anyway)
+      return false;
+    }
+  }
+
+  /**
+   * Correctly encodes and wraps long multibyte strings for mail headers
+   * without breaking lines within a character.
+   * Adapted from a function by paravoid at http://uk.php.net/manual/en/function.mb-encode-mimeheader.php
+   * @access public
+   * @param string $str multi-byte text to wrap encode
+   * @return string
+   */
+  public function Base64EncodeWrapMB($str) {
+    $start = "=?".$this->CharSet."?B?";
+    $end = "?=";
+    $encoded = "";
+
+    $mb_length = mb_strlen($str, $this->CharSet);
+    // Each line must have length <= 75, including $start and $end
+    $length = 75 - strlen($start) - strlen($end);
+    // Average multi-byte ratio
+    $ratio = $mb_length / strlen($str);
+    // Base64 has a 4:3 ratio
+    $offset = $avgLength = floor($length * $ratio * .75);
+
+    for ($i = 0; $i < $mb_length; $i += $offset) {
+      $lookBack = 0;
+
+      do {
+        $offset = $avgLength - $lookBack;
+        $chunk = mb_substr($str, $i, $offset, $this->CharSet);
+        $chunk = base64_encode($chunk);
+        $lookBack++;
+      }
+      while (strlen($chunk) > $length);
+
+      $encoded .= $chunk . $this->LE;
+    }
+
+    // Chomp the last linefeed
+    $encoded = substr($encoded, 0, -strlen($this->LE));
+    return $encoded;
+  }
+
+  /**
+  * Encode string to quoted-printable.
+  * Only uses standard PHP, slow, but will always work
+  * @access public
+  * @param string $string the text to encode
+  * @param integer $line_max Number of chars allowed on a line before wrapping
+  * @return string
+  */
+  public function EncodeQPphp( $input = '', $line_max = 76, $space_conv = false) {
+    $hex = array('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
+    $lines = preg_split('/(?:\r\n|\r|\n)/', $input);
+    $eol = "\r\n";
+    $escape = '=';
+    $output = '';
+    while( list(, $line) = each($lines) ) {
+      $linlen = strlen($line);
+      $newline = '';
+      for($i = 0; $i < $linlen; $i++) {
+        $c = substr( $line, $i, 1 );
+        $dec = ord( $c );
+        if ( ( $i == 0 ) && ( $dec == 46 ) ) { // convert first point in the line into =2E
+          $c = '=2E';
+        }
+        if ( $dec == 32 ) {
+          if ( $i == ( $linlen - 1 ) ) { // convert space at eol only
+            $c = '=20';
+          } else if ( $space_conv ) {
+            $c = '=20';
+          }
+        } elseif ( ($dec == 61) || ($dec < 32 ) || ($dec > 126) ) { // always encode "\t", which is *not* required
+          $h2 = floor($dec/16);
+          $h1 = floor($dec%16);
+          $c = $escape.$hex[$h2].$hex[$h1];
+        }
+        if ( (strlen($newline) + strlen($c)) >= $line_max ) { // CRLF is not counted
+          $output .= $newline.$escape.$eol; //  soft line break; " =\r\n" is okay
+          $newline = '';
+          // check if newline first character will be point or not
+          if ( $dec == 46 ) {
+            $c = '=2E';
+          }
+        }
+        $newline .= $c;
+      } // end of for
+      $output .= $newline.$eol;
+    } // end of while
+    return $output;
+  }
+
+  /**
+  * Encode string to RFC2045 (6.7) quoted-printable format
+  * Uses a PHP5 stream filter to do the encoding about 64x faster than the old version
+  * Also results in same content as you started with after decoding
+  * @see EncodeQPphp()
+  * @access public
+  * @param string $string the text to encode
+  * @param integer $line_max Number of chars allowed on a line before wrapping
+  * @param boolean $space_conv Dummy param for compatibility with existing EncodeQP function
+  * @return string
+  * @author Marcus Bointon
+  */
+  public function EncodeQP($string, $line_max = 76, $space_conv = false) {
+    if (function_exists('quoted_printable_encode')) { //Use native function if it's available (>= PHP5.3)
+      return quoted_printable_encode($string);
+    }
+    $filters = stream_get_filters();
+    if (!in_array('convert.*', $filters)) { //Got convert stream filter?
+      return $this->EncodeQPphp($string, $line_max, $space_conv); //Fall back to old implementation
+    }
+    $fp = fopen('php://temp/', 'r+');
+    $string = preg_replace('/\r\n?/', $this->LE, $string); //Normalise line breaks
+    $params = array('line-length' => $line_max, 'line-break-chars' => $this->LE);
+    $s = stream_filter_append($fp, 'convert.quoted-printable-encode', STREAM_FILTER_READ, $params);
+    fputs($fp, $string);
+    rewind($fp);
+    $out = stream_get_contents($fp);
+    stream_filter_remove($s);
+    $out = preg_replace('/^\./m', '=2E', $out); //Encode . if it is first char on a line, workaround for bug in Exchange
+    fclose($fp);
+    return $out;
+  }
+
+  /**
+   * Encode string to q encoding.
+   * @link http://tools.ietf.org/html/rfc2047
+   * @param string $str the text to encode
+   * @param string $position Where the text is going to be used, see the RFC for what that means
+   * @access public
+   * @return string
+   */
+  public function EncodeQ ($str, $position = 'text') {
+    // There should not be any EOL in the string
+    $encoded = preg_replace('/[\r\n]*/', '', $str);
+
+    switch (strtolower($position)) {
+      case 'phrase':
+        $encoded = preg_replace("/([^A-Za-z0-9!*+\/ -])/e", "'='.sprintf('%02X', ord('\\1'))", $encoded);
+        break;
+      case 'comment':
+        $encoded = preg_replace("/([\(\)\"])/e", "'='.sprintf('%02X', ord('\\1'))", $encoded);
+      case 'text':
+      default:
+        // Replace every high ascii, control =, ? and _ characters
+        //TODO using /e (equivalent to eval()) is probably not a good idea
+        $encoded = preg_replace('/([\000-\011\013\014\016-\037\075\077\137\177-\377])/e',
+              "'='.sprintf('%02X', ord('\\1'))", $encoded);
+        break;
+    }
+
+    // Replace every spaces to _ (more readable than =20)
+    $encoded = str_replace(' ', '_', $encoded);
+
+    return $encoded;
+  }
+
+  /**
+   * Adds a string or binary attachment (non-filesystem) to the list.
+   * This method can be used to attach ascii or binary data,
+   * such as a BLOB record from a database.
+   * @param string $string String attachment data.
+   * @param string $filename Name of the attachment.
+   * @param string $encoding File encoding (see $Encoding).
+   * @param string $type File extension (MIME) type.
+   * @return void
+   */
+  public function AddStringAttachment($string, $filename, $encoding = 'base64', $type = 'application/octet-stream') {
+    // Append to $attachment array
+    $this->attachment[] = array(
+      0 => $string,
+      1 => $filename,
+      2 => basename($filename),
+      3 => $encoding,
+      4 => $type,
+      5 => true,  // isStringAttachment
+      6 => 'attachment',
+      7 => 0
+    );
+  }
+
+  /**
+   * Adds an embedded attachment.  This can include images, sounds, and
+   * just about any other document.  Make sure to set the $type to an
+   * image type.  For JPEG images use "image/jpeg" and for GIF images
+   * use "image/gif".
+   * @param string $path Path to the attachment.
+   * @param string $cid Content ID of the attachment.  Use this to identify
+   *        the Id for accessing the image in an HTML form.
+   * @param string $name Overrides the attachment name.
+   * @param string $encoding File encoding (see $Encoding).
+   * @param string $type File extension (MIME) type.
+   * @return bool
+   */
+  public function AddEmbeddedImage($path, $cid, $name = '', $encoding = 'base64', $type = 'application/octet-stream') {
+
+    if ( !@is_file($path) ) {
+      $this->SetError($this->Lang('file_access') . $path);
+      return false;
+    }
+
+    $filename = basename($path);
+    if ( $name == '' ) {
+      $name = $filename;
+    }
+
+    // Append to $attachment array
+    $this->attachment[] = array(
+      0 => $path,
+      1 => $filename,
+      2 => $name,
+      3 => $encoding,
+      4 => $type,
+      5 => false,  // isStringAttachment
+      6 => 'inline',
+      7 => $cid
+    );
+
+    return true;
+  }
+
+  /**
+   * Returns true if an inline attachment is present.
+   * @access public
+   * @return bool
+   */
+  public function InlineImageExists() {
+    foreach($this->attachment as $attachment) {
+      if ($attachment[6] == 'inline') {
+        return true;
+      }
+    }
+    return false;
+  }
+
+  /////////////////////////////////////////////////
+  // CLASS METHODS, MESSAGE RESET
+  /////////////////////////////////////////////////
+
+  /**
+   * Clears all recipients assigned in the TO array.  Returns void.
+   * @return void
+   */
+  public function ClearAddresses() {
+    foreach($this->to as $to) {
+      unset($this->all_recipients[strtolower($to[0])]);
+    }
+    $this->to = array();
+  }
+
+  /**
+   * Clears all recipients assigned in the CC array.  Returns void.
+   * @return void
+   */
+  public function ClearCCs() {
+    foreach($this->cc as $cc) {
+      unset($this->all_recipients[strtolower($cc[0])]);
+    }
+    $this->cc = array();
+  }
+
+  /**
+   * Clears all recipients assigned in the BCC array.  Returns void.
+   * @return void
+   */
+  public function ClearBCCs() {
+    foreach($this->bcc as $bcc) {
+      unset($this->all_recipients[strtolower($bcc[0])]);
+    }
+    $this->bcc = array();
+  }
+
+  /**
+   * Clears all recipients assigned in the ReplyTo array.  Returns void.
+   * @return void
+   */
+  public function ClearReplyTos() {
+    $this->ReplyTo = array();
+  }
+
+  /**
+   * Clears all recipients assigned in the TO, CC and BCC
+   * array.  Returns void.
+   * @return void
+   */
+  public function ClearAllRecipients() {
+    $this->to = array();
+    $this->cc = array();
+    $this->bcc = array();
+    $this->all_recipients = array();
+  }
+
+  /**
+   * Clears all previously set filesystem, string, and binary
+   * attachments.  Returns void.
+   * @return void
+   */
+  public function ClearAttachments() {
+    $this->attachment = array();
+  }
+
+  /**
+   * Clears all custom headers.  Returns void.
+   * @return void
+   */
+  public function ClearCustomHeaders() {
+    $this->CustomHeader = array();
+  }
+
+  /////////////////////////////////////////////////
+  // CLASS METHODS, MISCELLANEOUS
+  /////////////////////////////////////////////////
+
+  /**
+   * Adds the error message to the error container.
+   * @access protected
+   * @return void
+   */
+  protected function SetError($msg) {
+    $this->error_count++;
+    $this->ErrorInfo = $msg;
+  }
+
+  /**
+   * Returns the proper RFC 822 formatted date.
+   * @access public
+   * @return string
+   * @static
+   */
+  public static function RFCDate() {
+    $tz = date('Z');
+    $tzs = ($tz < 0) ? '-' : '+';
+    $tz = abs($tz);
+    $tz = (int)($tz/3600)*100 + ($tz%3600)/60;
+    $result = sprintf("%s %s%04d", date('D, j M Y H:i:s'), $tzs, $tz);
+
+    return $result;
+  }
+
+  /**
+   * Returns the server hostname or 'localhost.localdomain' if unknown.
+   * @access private
+   * @return string
+   */
+  private function ServerHostname() {
+    if (!empty($this->Hostname)) {
+      $result = $this->Hostname;
+    } elseif (isset($_SERVER['SERVER_NAME'])) {
+      $result = $_SERVER['SERVER_NAME'];
+    } else {
+      $result = 'localhost.localdomain';
+    }
+
+    return $result;
+  }
+
+  /**
+   * Returns a message in the appropriate language.
+   * @access private
+   * @return string
+   */
+  private function Lang($key) {
+    if(count($this->language) < 1) {
+      $this->SetLanguage('en'); // set the default language
+    }
+
+    if(isset($this->language[$key])) {
+      return $this->language[$key];
+    } else {
+      return 'Language string failed to load: ' . $key;
+    }
+  }
+
+  /**
+   * Returns true if an error occurred.
+   * @access public
+   * @return bool
+   */
+  public function IsError() {
+    return ($this->error_count > 0);
+  }
+
+  /**
+   * Changes every end of line from CR or LF to CRLF.
+   * @access private
+   * @return string
+   */
+  private function FixEOL($str) {
+    $str = str_replace("\r\n", "\n", $str);
+    $str = str_replace("\r", "\n", $str);
+    $str = str_replace("\n", $this->LE, $str);
+    return $str;
+  }
+
+  /**
+   * Adds a custom header.
+   * @access public
+   * @return void
+   */
+  public function AddCustomHeader($custom_header) {
+    $this->CustomHeader[] = explode(':', $custom_header, 2);
+  }
+
+  /**
+   * Evaluates the message and returns modifications for inline images and backgrounds
+   * @access public
+   * @return $message
+   */
+  public function MsgHTML($message, $basedir = '') {
+    preg_match_all("/(src|background)=\"(.*)\"/Ui", $message, $images);
+    if(isset($images[2])) {
+      foreach($images[2] as $i => $url) {
+        // do not change urls for absolute images (thanks to corvuscorax)
+        if (!preg_match('#^[A-z]+://#',$url)) {
+          $filename = basename($url);
+          $directory = dirname($url);
+          ($directory == '.')?$directory='':'';
+          $cid = 'cid:' . md5($filename);
+          $ext = pathinfo($filename, PATHINFO_EXTENSION);
+          $mimeType  = self::_mime_types($ext);
+          if ( strlen($basedir) > 1 && substr($basedir,-1) != '/') { $basedir .= '/'; }
+          if ( strlen($directory) > 1 && substr($directory,-1) != '/') { $directory .= '/'; }
+          if ( $this->AddEmbeddedImage($basedir.$directory.$filename, md5($filename), $filename, 'base64',$mimeType) ) {
+            $message = preg_replace("/".$images[1][$i]."=\"".preg_quote($url, '/')."\"/Ui", $images[1][$i]."=\"".$cid."\"", $message);
+          }
+        }
+      }
+    }
+    $this->IsHTML(true);
+    $this->Body = $message;
+    $textMsg = trim(strip_tags(preg_replace('/<(head|title|style|script)[^>]*>.*?<\/\\1>/s','',$message)));
+    if (!empty($textMsg) && empty($this->AltBody)) {
+      $this->AltBody = html_entity_decode($textMsg);
+    }
+    if (empty($this->AltBody)) {
+      $this->AltBody = 'To view this email message, open it in a program that understands HTML!' . "\n\n";
+    }
+  }
+
+  /**
+   * Gets the MIME type of the embedded or inline image
+   * @param string File extension
+   * @access public
+   * @return string MIME type of ext
+   * @static
+   */
+  public static function _mime_types($ext = '') {
+    $mimes = array(
+      'hqx'   =>  'application/mac-binhex40',
+      'cpt'   =>  'application/mac-compactpro',
+      'doc'   =>  'application/msword',
+      'bin'   =>  'application/macbinary',
+      'dms'   =>  'application/octet-stream',
+      'lha'   =>  'application/octet-stream',
+      'lzh'   =>  'application/octet-stream',
+      'exe'   =>  'application/octet-stream',
+      'class' =>  'application/octet-stream',
+      'psd'   =>  'application/octet-stream',
+      'so'    =>  'application/octet-stream',
+      'sea'   =>  'application/octet-stream',
+      'dll'   =>  'application/octet-stream',
+      'oda'   =>  'application/oda',
+      'pdf'   =>  'application/pdf',
+      'ai'    =>  'application/postscript',
+      'eps'   =>  'application/postscript',
+      'ps'    =>  'application/postscript',
+      'smi'   =>  'application/smil',
+      'smil'  =>  'application/smil',
+      'mif'   =>  'application/vnd.mif',
+      'xls'   =>  'application/vnd.ms-excel',
+      'ppt'   =>  'application/vnd.ms-powerpoint',
+      'wbxml' =>  'application/vnd.wap.wbxml',
+      'wmlc'  =>  'application/vnd.wap.wmlc',
+      'dcr'   =>  'application/x-director',
+      'dir'   =>  'application/x-director',
+      'dxr'   =>  'application/x-director',
+      'dvi'   =>  'application/x-dvi',
+      'gtar'  =>  'application/x-gtar',
+      'php'   =>  'application/x-httpd-php',
+      'php4'  =>  'application/x-httpd-php',
+      'php3'  =>  'application/x-httpd-php',
+      'phtml' =>  'application/x-httpd-php',
+      'phps'  =>  'application/x-httpd-php-source',
+      'js'    =>  'application/x-javascript',
+      'swf'   =>  'application/x-shockwave-flash',
+      'sit'   =>  'application/x-stuffit',
+      'tar'   =>  'application/x-tar',
+      'tgz'   =>  'application/x-tar',
+      'xhtml' =>  'application/xhtml+xml',
+      'xht'   =>  'application/xhtml+xml',
+      'zip'   =>  'application/zip',
+      'mid'   =>  'audio/midi',
+      'midi'  =>  'audio/midi',
+      'mpga'  =>  'audio/mpeg',
+      'mp2'   =>  'audio/mpeg',
+      'mp3'   =>  'audio/mpeg',
+      'aif'   =>  'audio/x-aiff',
+      'aiff'  =>  'audio/x-aiff',
+      'aifc'  =>  'audio/x-aiff',
+      'ram'   =>  'audio/x-pn-realaudio',
+      'rm'    =>  'audio/x-pn-realaudio',
+      'rpm'   =>  'audio/x-pn-realaudio-plugin',
+      'ra'    =>  'audio/x-realaudio',
+      'rv'    =>  'video/vnd.rn-realvideo',
+      'wav'   =>  'audio/x-wav',
+      'bmp'   =>  'image/bmp',
+      'gif'   =>  'image/gif',
+      'jpeg'  =>  'image/jpeg',
+      'jpg'   =>  'image/jpeg',
+      'jpe'   =>  'image/jpeg',
+      'png'   =>  'image/png',
+      'tiff'  =>  'image/tiff',
+      'tif'   =>  'image/tiff',
+      'css'   =>  'text/css',
+      'html'  =>  'text/html',
+      'htm'   =>  'text/html',
+      'shtml' =>  'text/html',
+      'txt'   =>  'text/plain',
+      'text'  =>  'text/plain',
+      'log'   =>  'text/plain',
+      'rtx'   =>  'text/richtext',
+      'rtf'   =>  'text/rtf',
+      'xml'   =>  'text/xml',
+      'xsl'   =>  'text/xml',
+      'mpeg'  =>  'video/mpeg',
+      'mpg'   =>  'video/mpeg',
+      'mpe'   =>  'video/mpeg',
+      'qt'    =>  'video/quicktime',
+      'mov'   =>  'video/quicktime',
+      'avi'   =>  'video/x-msvideo',
+      'movie' =>  'video/x-sgi-movie',
+      'doc'   =>  'application/msword',
+      'word'  =>  'application/msword',
+      'xl'    =>  'application/excel',
+      'eml'   =>  'message/rfc822'
+    );
+    return (!isset($mimes[strtolower($ext)])) ? 'application/octet-stream' : $mimes[strtolower($ext)];
+  }
+
+  /**
+  * Set (or reset) Class Objects (variables)
+  *
+  * Usage Example:
+  * $page->set('X-Priority', '3');
+  *
+  * @access public
+  * @param string $name Parameter Name
+  * @param mixed $value Parameter Value
+  * NOTE: will not work with arrays, there are no arrays to set/reset
+  * @todo Should this not be using __set() magic function?
+  */
+  public function set($name, $value = '') {
+    try {
+      if (isset($this->$name) ) {
+        $this->$name = $value;
+      } else {
+        throw new phpmailerException($this->Lang('variable_set') . $name, self::STOP_CRITICAL);
+      }
+    } catch (Exception $e) {
+      $this->SetError($e->getMessage());
+      if ($e->getCode() == self::STOP_CRITICAL) {
+        return false;
+      }
+    }
+    return true;
+  }
+
+  /**
+   * Strips newlines to prevent header injection.
+   * @access public
+   * @param string $str String
+   * @return string
+   */
+  public function SecureHeader($str) {
+    $str = str_replace("\r", '', $str);
+    $str = str_replace("\n", '', $str);
+    return trim($str);
+  }
+
+  /**
+   * Set the private key file and password to sign the message.
+   *
+   * @access public
+   * @param string $key_filename Parameter File Name
+   * @param string $key_pass Password for private key
+   */
+  public function Sign($cert_filename, $key_filename, $key_pass) {
+    $this->sign_cert_file = $cert_filename;
+    $this->sign_key_file = $key_filename;
+    $this->sign_key_pass = $key_pass;
+  }
+
+  /**
+   * Set the private key file and password to sign the message.
+   *
+   * @access public
+   * @param string $key_filename Parameter File Name
+   * @param string $key_pass Password for private key
+   */
+  public function DKIM_QP($txt) {
+    $tmp="";
+    $line="";
+    for ($i=0;$i<strlen($txt);$i++) {
+      $ord=ord($txt[$i]);
+      if ( ((0x21 <= $ord) && ($ord <= 0x3A)) || $ord == 0x3C || ((0x3E <= $ord) && ($ord <= 0x7E)) ) {
+        $line.=$txt[$i];
+      } else {
+        $line.="=".sprintf("%02X",$ord);
+      }
+    }
+    return $line;
+  }
+
+  /**
+   * Generate DKIM signature
+   *
+   * @access public
+   * @param string $s Header
+   */
+  public function DKIM_Sign($s) {
+    $privKeyStr = file_get_contents($this->DKIM_private);
+    if ($this->DKIM_passphrase!='') {
+      $privKey = openssl_pkey_get_private($privKeyStr,$this->DKIM_passphrase);
+    } else {
+      $privKey = $privKeyStr;
+    }
+    if (openssl_sign($s, $signature, $privKey)) {
+      return base64_encode($signature);
+    }
+  }
+
+  /**
+   * Generate DKIM Canonicalization Header
+   *
+   * @access public
+   * @param string $s Header
+   */
+  public function DKIM_HeaderC($s) {
+    $s=preg_replace("/\r\n\s+/"," ",$s);
+    $lines=explode("\r\n",$s);
+    foreach ($lines as $key=>$line) {
+      list($heading,$value)=explode(":",$line,2);
+      $heading=strtolower($heading);
+      $value=preg_replace("/\s+/"," ",$value) ; // Compress useless spaces
+      $lines[$key]=$heading.":".trim($value) ; // Don't forget to remove WSP around the value
+    }
+    $s=implode("\r\n",$lines);
+    return $s;
+  }
+
+  /**
+   * Generate DKIM Canonicalization Body
+   *
+   * @access public
+   * @param string $body Message Body
+   */
+  public function DKIM_BodyC($body) {
+    if ($body == '') return "\r\n";
+    // stabilize line endings
+    $body=str_replace("\r\n","\n",$body);
+    $body=str_replace("\n","\r\n",$body);
+    // END stabilize line endings
+    while (substr($body,strlen($body)-4,4) == "\r\n\r\n") {
+      $body=substr($body,0,strlen($body)-2);
+    }
+    return $body;
+  }
+
+  /**
+   * Create the DKIM header, body, as new header
+   *
+   * @access public
+   * @param string $headers_line Header lines
+   * @param string $subject Subject
+   * @param string $body Body
+   */
+  public function DKIM_Add($headers_line,$subject,$body) {
+    $DKIMsignatureType    = 'rsa-sha1'; // Signature & hash algorithms
+    $DKIMcanonicalization = 'relaxed/simple'; // Canonicalization of header/body
+    $DKIMquery            = 'dns/txt'; // Query method
+    $DKIMtime             = time() ; // Signature Timestamp = seconds since 00:00:00 - Jan 1, 1970 (UTC time zone)
+    $subject_header       = "Subject: $subject";
+    $headers              = explode("\r\n",$headers_line);
+    foreach($headers as $header) {
+      if (strpos($header,'From:') === 0) {
+        $from_header=$header;
+      } elseif (strpos($header,'To:') === 0) {
+        $to_header=$header;
+      }
+    }
+    $from     = str_replace('|','=7C',$this->DKIM_QP($from_header));
+    $to       = str_replace('|','=7C',$this->DKIM_QP($to_header));
+    $subject  = str_replace('|','=7C',$this->DKIM_QP($subject_header)) ; // Copied header fields (dkim-quoted-printable
+    $body     = $this->DKIM_BodyC($body);
+    $DKIMlen  = strlen($body) ; // Length of body
+    $DKIMb64  = base64_encode(pack("H*", sha1($body))) ; // Base64 of packed binary SHA-1 hash of body
+    $ident    = ($this->DKIM_identity == '')? '' : " i=" . $this->DKIM_identity . ";";
+    $dkimhdrs = "DKIM-Signature: v=1; a=" . $DKIMsignatureType . "; q=" . $DKIMquery . "; l=" . $DKIMlen . "; s=" . $this->DKIM_selector . ";\r\n".
+                "\tt=" . $DKIMtime . "; c=" . $DKIMcanonicalization . ";\r\n".
+                "\th=From:To:Subject;\r\n".
+                "\td=" . $this->DKIM_domain . ";" . $ident . "\r\n".
+                "\tz=$from\r\n".
+                "\t|$to\r\n".
+                "\t|$subject;\r\n".
+                "\tbh=" . $DKIMb64 . ";\r\n".
+                "\tb=";
+    $toSign   = $this->DKIM_HeaderC($from_header . "\r\n" . $to_header . "\r\n" . $subject_header . "\r\n" . $dkimhdrs);
+    $signed   = $this->DKIM_Sign($toSign);
+    return "X-PHPMAILER-DKIM: phpmailer.sourceforge.net\r\n".$dkimhdrs.$signed."\r\n";
+  }
+
+  protected function doCallback($isSent,$to,$cc,$bcc,$subject,$body) {
+    if (!empty($this->action_function) && function_exists($this->action_function)) {
+      $params = array($isSent,$to,$cc,$bcc,$subject,$body);
+      call_user_func_array($this->action_function,$params);
+    }
+  }
+}
+
+class phpmailerException extends Exception {
+  public function errorMessage() {
+    $errorMsg = '<strong>' . $this->getMessage() . "</strong><br />\n";
+    return $errorMsg;
+  }
+}
+?>
\ No newline at end of file

=== added directory 'includes/PHPMailer-Lite_v5.1/docs'
=== added file 'includes/PHPMailer-Lite_v5.1/docs/Callback_function_notes.txt'
--- includes/PHPMailer-Lite_v5.1/docs/Callback_function_notes.txt	1970-01-01 00:00:00 +0000
+++ includes/PHPMailer-Lite_v5.1/docs/Callback_function_notes.txt	2011-01-26 02:48:39 +0000
@@ -0,0 +1,17 @@
+NEW CALLBACK FUNCTION:
+======================
+
+We have had requests for a method to process the results of sending emails 
+through PHPMailer. In this new release, we have implemented a callback
+function that passes the results of each email sent (to, cc, and/or bcc). 
+We have provided an example that echos the results back to the screen. The
+callback function can be used for any purpose. With minor modifications, the
+callback function can be used to create CSV logs, post results to databases,
+etc.
+
+Please review the test.php script for the example.
+
+It's pretty straight forward.
+
+Enjoy!
+Andy

=== added file 'includes/PHPMailer-Lite_v5.1/docs/DomainKeys_notes.txt'
--- includes/PHPMailer-Lite_v5.1/docs/DomainKeys_notes.txt	1970-01-01 00:00:00 +0000
+++ includes/PHPMailer-Lite_v5.1/docs/DomainKeys_notes.txt	2011-01-26 02:48:39 +0000
@@ -0,0 +1,55 @@
+CREATE DKIM KEYS and DNS Resource Record:
+=========================================
+
+To create DomainKeys Identified Mail keys, visit:
+http://dkim.worxware.com/
+... read the information, fill in the form, and download the ZIP file 
+containing the public key, private key, DNS Resource Record and instructions
+to add to your DNS Zone Record, and the PHPMailer code to enable DKIM
+digital signing.
+
+/*** PROTECT YOUR PRIVATE & PUBLIC KEYS ***/
+
+You need to protect your DKIM private and public keys from being viewed or
+accessed. Add protection to your .htaccess file as in this example:
+
+# secure htkeyprivate file
+<Files .htkeyprivate>
+  order allow,deny
+  deny from all
+</Files>
+
+# secure htkeypublic file
+<Files .htkeypublic>
+  order allow,deny
+  deny from all
+</Files>
+
+(the actual .htaccess additions are in the ZIP file sent back to you from 
+http://dkim.worxware.com/ 
+
+A few notes on using DomainKey Identified Mail (DKIM):
+
+You do not need to use PHPMailer to DKIM sign  emails IF:
+- you enable DomainKey support and add the DNS resource record
+- you use your outbound mail server
+
+If you are a third-party emailer that works on behalf of domain owners to
+send their emails from your own server:
+- you absolutely have to DKIM sign outbound emails
+- the domain owner has to add the DNS resource record to match the 
+  private key, public key, selector, identity, and domain that you create
+- use caution with the "selector" ... at least one "selector" will already
+  exist in the DNS Zone Record of the domain at the domain owner's server
+  you need to ensure that the "selector" you use is unique
+Note: since the IP address will not match the domain owner's DNS Zone record
+you can be certain that email providers that validate based on DomainKey will
+check the domain owner's DNS Zone record for your DNS resource record. Before
+sending out emails on behalf of domain owners, ensure they have entered the 
+DNS resource record you provided them.
+
+Enjoy!
+Andy
+
+PS. if you need additional information about DKIM, please see:
+http://www.dkim.org/info/dkim-faq.html

=== added file 'includes/PHPMailer-Lite_v5.1/docs/extending.html'
--- includes/PHPMailer-Lite_v5.1/docs/extending.html	1970-01-01 00:00:00 +0000
+++ includes/PHPMailer-Lite_v5.1/docs/extending.html	2011-01-26 02:48:39 +0000
@@ -0,0 +1,144 @@
+<html>
+<head>
+<title>Examples using phpmailer</title>
+</head>
+
+<body bgcolor="#FFFFFF">
+
+<h2>Examples using phpmailer</h2>
+
+<h3>1. Advanced Example</h3>
+<p>
+
+This demonstrates sending out multiple email messages with binary attachments
+from a MySQL database with multipart/alternative support.<p>
+<table cellpadding="4" border="1" width="80%">
+<tr>
+<td bgcolor="#CCCCCC">
+<pre>
+require("class.phpmailer.php");
+
+$mail = new phpmailer();
+
+$mail->From     = "list@example.com";
+$mail->FromName = "List manager";
+
+@MYSQL_CONNECT("localhost","root","password");
+@mysql_select_db("my_company");
+$query ="SELECT full_name, email,photoFROM employeeWHEREid=$id";
+$result=@MYSQL_QUERY($query);
+
+while ($row = mysql_fetch_array ($result))
+{
+    // HTML body
+    $body  = "Hello &lt;font size=\"4\"&gt;" . $row["full_name"] . "&lt;/font&gt;, &lt;p&gt;";
+    $body .= "&lt;i&gt;Your&lt;/i&gt; personal photograph to this message.&lt;p&gt;";
+    $body .= "Sincerely, &lt;br&gt;";
+    $body .= "phpmailer List manager";
+
+    // Plain text body (for mail clients that cannot read HTML)
+    $text_body  = "Hello " . $row["full_name"] . ", \n\n";
+    $text_body .= "Your personal photograph to this message.\n\n";
+    $text_body .= "Sincerely, \n";
+    $text_body .= "phpmailer List manager";
+
+    $mail->Body    = $body;
+    $mail->AltBody = $text_body;
+    $mail->AddAddress($row["email"], $row["full_name"]);
+    $mail->AddStringAttachment($row["photo"], "YourPhoto.jpg");
+
+    if(!$mail->Send())
+        echo "There has been a mail error sending to " . $row["email"] . "&lt;br&gt;";
+
+    // Clear all addresses and attachments for next loop
+    $mail->ClearAddresses();
+    $mail->ClearAttachments();
+}
+</pre>
+</td>
+</tr>
+</table>
+<p>
+
+<h3>2. Extending phpmailer</h3>
+<p>
+
+Extending classes with inheritance is one of the most
+powerful features of object-oriented
+programming.  It allows you to make changes to the
+original class for your
+own personal use without hacking the original
+classes.  Plus, it is very
+easy to do. I've provided an example:
+
+<p>
+Here's a class that extends the phpmailer class and sets the defaults
+for the particular site:<br>
+PHP include file: <b>mail.inc.php</b>
+<p>
+
+<table cellpadding="4" border="1" width="80%">
+<tr>
+<td bgcolor="#CCCCCC">
+<pre>
+require("class.phpmailer.php");
+
+class my_phpmailer extends phpmailer {
+    // Set default variables for all new objects
+    var $From     = "from@example.com";
+    var $FromName = "Mailer";
+    var $WordWrap = 75;
+
+    // Replace the default error_handler
+    function error_handler($msg) {
+        print("My Site Error");
+        print("Description:");
+        printf("%s", $msg);
+        exit;
+    }
+
+    // Create an additional function
+    function do_something($something) {
+        // Place your new code here
+    }
+}
+</td>
+</tr>
+</table>
+<br>
+
+Now here's a normal PHP page in the site, which will have all the defaults set
+above:<br>
+Normal PHP file: <b>mail_test.php</b>
+<p>
+
+<table cellpadding="4" border="1" width="80%">
+<tr>
+<td bgcolor="#CCCCCC">
+<pre>
+require("mail.inc.php");
+
+// Instantiate your new class
+$mail = new my_phpmailer;
+
+// Now you only need to add the necessary stuff
+$mail->AddAddress("josh@example.com", "Josh Adams");
+$mail->Subject = "Here is the subject";
+$mail->Body    = "This is the message body";
+$mail->AddAttachment("c:/temp/11-10-00.zip", "new_name.zip");  // optional name
+
+if(!$mail->Send())
+{
+   echo "There was an error sending the message";
+   exit;
+}
+
+echo "Message was sent successfully";
+</pre>
+</td>
+</tr>
+</table>
+</p>
+
+</body>
+</html>

=== added file 'includes/PHPMailer-Lite_v5.1/docs/faq.html'
--- includes/PHPMailer-Lite_v5.1/docs/faq.html	1970-01-01 00:00:00 +0000
+++ includes/PHPMailer-Lite_v5.1/docs/faq.html	2011-01-26 02:48:39 +0000
@@ -0,0 +1,63 @@
+﻿<html>
+<head>
+<title>PHPMailer FAQ</title>
+<style>
+body, p {
+  font-family: Arial, Helvetica, sans-serif;
+  font-size: 12px;
+}
+div.width {
+  width: 500px;
+  text-align: left;
+}
+</style>
+</head>
+<body bgcolor="#FFFFFF">
+<center>
+<div class="width">
+<h2>PHPMailer-Lite FAQ</h2>
+<ul>
+
+  <li><b style="background-color: #FFFF00">Q:</b> <b>I am concerned that using include files will take up too much
+  processing time on my computer.  How can I make it run faster?</b><br />
+  <b style="background-color: #FFFF00">A:</b>  PHP by itself is very fast.  Much faster than ASP or JSP running on
+  the same type of server.  This is because it has very little overhead compared
+  to its competitors and it pre-compiles all of
+  its code before it runs each script (in PHP4).  However, all of
+  this compiling and re-compiling can take up a lot of valuable
+  computer resources.  However, there are programs out there that compile
+  PHP code and store it in memory (or on mmaped files) to reduce the
+  processing immensely.  Two of these: <a href="http://apc.communityconnect.com">APC
+  (Alternative PHP Cache)</a> and <a href="http://bwcache.bware.it/index.htm">Afterburner</a>
+  (<a href="http://www.mm4.de/php4win/mod_php4_win32/">Win32 download</a>)
+  are excellent free tools that do just this.  If you have the money
+  you might also try <a href="http://www.zend.com">Zend Cache</a>, it is
+  even faster than the open source varieties.  All of these tools make your
+  scripts run faster while also reducing the load on your server. I have tried
+  them myself and they are quite stable too.<br /><br /></li>
+
+  <li><b style="background-color: #FFFF00">Q:</b> <b>What mailer gives me the best performance?</b><br />
+  <b style="background-color: #FFFF00">A:</b> On a single machine the <b>Sendmail (or Qmail)</b> is fastest overall.
+  Next fastest is mail() to give you the best performance. Both do not have the overhead of SMTP.
+  If you have you have your mail server on a another machine then
+  SMTP is your only option, but you do get the benefit of redundant mail servers.<br />
+  If you are running a mailing list with thousands of names, the fastest mailers in order are: SMTP, sendmail (or Qmail), mail().<br>
+	* note: if you need to use SMTP, get a copy of PHPMailer ... this is 
+	PHPMailer-Lite and does not support SMTP.<br /><br /></li>
+
+  <li><b style="background-color: #FFFF00">Q:</b> <b>When I try to attach a file with on my server I get a
+  "Could not find {file} on filesystem error".  Why is this?</b><br />
+  <b style="background-color: #FFFF00">A:</b> If you are using a Unix machine this is probably because the user
+  running your web server does not have read access to the directory in question.  If you are using Windows,
+  then the problem probably is that you have used single backslashes to denote directories (\).
+  A single backslash has a special meaning to PHP so these are not
+  valid.  Instead use double backslashes ("\\") or a single forward
+  slash ("/").<br /><br /></li>
+
+</ul>
+
+</div>
+</center>
+
+</body>
+</html>

=== added directory 'includes/PHPMailer-Lite_v5.1/examples'
=== added file 'includes/PHPMailer-Lite_v5.1/examples/contents.html'
--- includes/PHPMailer-Lite_v5.1/examples/contents.html	1970-01-01 00:00:00 +0000
+++ includes/PHPMailer-Lite_v5.1/examples/contents.html	2011-01-26 02:48:39 +0000
@@ -0,0 +1,20 @@
+<body style="margin: 10px;">
+<div style="width: 640px; font-family: Arial, Helvetica, sans-serif; font-size: 11px;">
+<div align="center"><img src="images/phpmailer.gif" style="height: 90px; width: 340px"></div><br>
+<br>
+&nbsp;This is a test of PHPMailer.<br>
+<br>
+This particular example uses <strong>HTML</strong>, with a &lt;div&gt; tag and inline<br>
+styles.<br>
+<br>
+Also note the use of the PHPMailer logo above with no specific code to handle
+including it.<br />
+Included are two attachments:<br />
+phpmailer.gif is an attachment and used inline as a graphic (above)<br />
+phpmailer_mini.gif is an attachment<br />
+<br />
+PHPMailer:<br />
+Author: Andy Prevost (codeworxtech@users.sourceforge.net)<br />
+Author: Marcus Bointon (coolbru@users.sourceforge.net)<br />
+</div>
+</body>

=== added directory 'includes/PHPMailer-Lite_v5.1/examples/images'
=== added file 'includes/PHPMailer-Lite_v5.1/examples/images/phpmailer.gif'
Binary files includes/PHPMailer-Lite_v5.1/examples/images/phpmailer.gif and includes/PHPMailer-Lite_v5.1/examples/images/phpmailer.gif differ
=== added file 'includes/PHPMailer-Lite_v5.1/examples/images/phpmailer_mini.gif'
Binary files includes/PHPMailer-Lite_v5.1/examples/images/phpmailer_mini.gif and includes/PHPMailer-Lite_v5.1/examples/images/phpmailer_mini.gif differ
=== added file 'includes/PHPMailer-Lite_v5.1/examples/index.html'
--- includes/PHPMailer-Lite_v5.1/examples/index.html	1970-01-01 00:00:00 +0000
+++ includes/PHPMailer-Lite_v5.1/examples/index.html	2011-01-26 02:48:39 +0000
@@ -0,0 +1,49 @@
+This release of PHPMailer (v5.0.0) sets a new milestone in the development
+cycle of PHPMailer. First, class.phpmailer.php has a small footprint (65.7 Kb),
+while class.smtp.php is even smaller than before (at only 25.0 Kb).<br />
+<br />
+We have maintained all functionality and added Exception handling unique to
+PHP 5/6.<br />
+<br />
+There is only one function that has been removed: that is getFile(). The reason
+for this is that getFile() became a wrapper for the PHP function 'file_get_contents()'
+and nothing more. Rather than burden the class with a function already available
+in PHP, we decided to remove it.<br />
+<br />
+Our new Exception handling provides your own scripts far more power than ever.<br />
+<br />
+We have also enhanced the "packaging" of PHPMailer with an entirely new set of 
+examples. Included are both basic and advanced examples showing how you can take
+advantage of PHP Exception handling to improve your own scripts.<br />
+<br />
+A few things to note about PHPMailer:
+<ul>
+  <li>the use of $mail-&gt;AltBody is completely optional. If not used, PHPMailer
+  will use the HTML text with htmlentities().<br />
+  We also highly recommend using HTML2Text authored by Jon Abernathy. The class description
+  and download can be viewed at: http://www.chuggnutt.com/html2text.php.
+  </li>
+  <li>there is no specific code to define image or attachment types ... that is handled
+  automatically by PHPMailer when it parses the images</li>
+</ul>
+A note to users that want to use SMTP with PHPMailer. The most common problems are:
+<ul>
+  <li>wrong port ... most ISP (Internet Service Providers) will not allow relaying through
+    their servers. If that's the case with your ISP, try using port 26.
+  </li>
+  <li>wrong authentication information (username and/or password) ... don't forget that
+    many servers require the account name to be in the format of the full email address.
+  </li>
+  <li>... if these tips do not get your SMTP settings working, we have a debug mode
+    for helping you determine the problem. Insert this after $mail->IsSMTP();<br />
+    $mail->SMTPDebug  = 2;  // enables SMTP debug information (for testing)<br />
+    note that a setting of 2 will display all errors and messages generated by the SMTP
+    server<br />
+  </li>
+</ul>
+Our examples all use an HTML file in the /examples folder. To see what the email SHOULD
+look like in your HTML compatible email viewer: <a href="contents.html">click here</a><br>
+<br />
+From the PHPMailer team:<br />
+Author: Andy Prevost (codeworxtech) codeworxtech@users.sourceforge.net (and Project Administrator)<br />
+Author: Marcus Bointon (coolbru) coolbru@users.sourceforge.net<br />

=== added file 'includes/PHPMailer-Lite_v5.1/examples/test_db_basic.php'
--- includes/PHPMailer-Lite_v5.1/examples/test_db_basic.php	1970-01-01 00:00:00 +0000
+++ includes/PHPMailer-Lite_v5.1/examples/test_db_basic.php	2011-01-26 02:48:39 +0000
@@ -0,0 +1,48 @@
+<html>
+<head>
+<title>PHPMailer - MySQL Database - SMTP basic test with authentication</title>
+</head>
+<body>
+
+<?php
+
+//error_reporting(E_ALL);
+error_reporting(E_STRICT);
+
+date_default_timezone_set('America/Toronto');
+
+require_once('../class.phpmailer-lite.php');
+
+$mail             = new PHPMailerLite(); // defaults to using php "Sendmail" (or Qmail, depending on availability)
+
+$body                = file_get_contents('contents.html');
+$body                = eregi_replace("[\]",'',$body);
+
+$mail->SetFrom('list@mydomain.com', 'List manager');
+
+$mail->Subject       = "PHPMailer Test Subject via Sendmail";
+
+@MYSQL_CONNECT("localhost","root","password");
+@mysql_select_db("my_company");
+$query  = "SELECT full_name, email, photo FROM employee WHERE id=$id";
+$result = @MYSQL_QUERY($query);
+
+while ($row = mysql_fetch_array ($result)) {
+  $mail->AltBody    = "To view the message, please use an HTML compatible email viewer!"; // optional, comment out and test
+  $mail->MsgHTML($body);
+  $mail->AddAddress($row["email"], $row["full_name"]);
+  $mail->AddStringAttachment($row["photo"], "YourPhoto.jpg");
+
+  if(!$mail->Send()) {
+    echo "Mailer Error (" . str_replace("@", "&#64;", $row["email"]) . ') ' . $mail->ErrorInfo . '<br />';
+  } else {
+    echo "Message sent to :" . $row["full_name"] . ' (' . str_replace("@", "&#64;", $row["email"]) . ')<br />';
+  }
+  // Clear all addresses and attachments for next loop
+  $mail->ClearAddresses();
+  $mail->ClearAttachments();
+}
+?>
+
+</body>
+</html>

=== added file 'includes/PHPMailer-Lite_v5.1/examples/test_mail_advanced.php'
--- includes/PHPMailer-Lite_v5.1/examples/test_mail_advanced.php	1970-01-01 00:00:00 +0000
+++ includes/PHPMailer-Lite_v5.1/examples/test_mail_advanced.php	2011-01-26 02:48:39 +0000
@@ -0,0 +1,32 @@
+<html>
+<head>
+<title>PHPMailer - Mail() advanced test</title>
+</head>
+<body>
+
+<?php
+
+require_once('../class.phpmailer-lite.php');
+
+$mail             = new PHPMailerLite(); // defaults to using php "Sendmail" (or Qmail, depending on availability)
+
+$mail->IsMail(); // telling the class to use native PHP mail()
+
+try {
+  $mail->SetFrom('name@yourdomain.com', 'First Last');
+  $mail->AddAddress('Suren.Chilingaryan@kit.edu', 'John Doe');
+  $mail->Subject = 'PHPMailer Test Subject via mail(), advanced';
+  $mail->AltBody = 'To view the message, please use an HTML compatible email viewer!'; // optional - MsgHTML will create an alternate automatically
+  $mail->MsgHTML(file_get_contents('contents.html'));
+  $mail->AddAttachment('images/phpmailer.gif');      // attachment
+  $mail->AddAttachment('images/phpmailer_mini.gif'); // attachment
+  $mail->Send();
+  echo "Message Sent OK</p>\n";
+} catch (phpmailerException $e) {
+  echo $e->errorMessage(); //Pretty error messages from PHPMailer
+} catch (Exception $e) {
+  echo $e->getMessage(); //Boring error messages from anything else!
+}
+?>
+</body>
+</html>

=== added file 'includes/PHPMailer-Lite_v5.1/examples/test_mail_basic.php'
--- includes/PHPMailer-Lite_v5.1/examples/test_mail_basic.php	1970-01-01 00:00:00 +0000
+++ includes/PHPMailer-Lite_v5.1/examples/test_mail_basic.php	2011-01-26 02:48:39 +0000
@@ -0,0 +1,41 @@
+<html>
+<head>
+<title>PHPMailer - Mail() basic test</title>
+</head>
+<body>
+
+<?php
+
+require_once('../class.phpmailer-lite.php');
+
+$mail             = new PHPMailerLite(); // defaults to using php "Sendmail" (or Qmail, depending on availability)
+
+$mail->IsMail(); // telling the class to use native PHP mail()
+
+$body             = file_get_contents('contents.html');
+$body             = eregi_replace("[\]",'',$body);
+
+$mail->SetFrom('name@yourdomain.com', 'First Last');
+
+$address = "whoto@otherdomain.com";
+$mail->AddAddress($address, "John Doe");
+
+$mail->Subject    = "PHPMailer Test Subject via mail(), basic";
+
+$mail->AltBody    = "To view the message, please use an HTML compatible email viewer!"; // optional, comment out and test
+
+$mail->MsgHTML($body);
+
+$mail->AddAttachment("images/phpmailer.gif");      // attachment
+$mail->AddAttachment("images/phpmailer_mini.gif"); // attachment
+
+if(!$mail->Send()) {
+  echo "Mailer Error: " . $mail->ErrorInfo;
+} else {
+  echo "Message sent!";
+}
+
+?>
+
+</body>
+</html>

=== added file 'includes/PHPMailer-Lite_v5.1/examples/test_sendmail_advanced.php'
--- includes/PHPMailer-Lite_v5.1/examples/test_sendmail_advanced.php	1970-01-01 00:00:00 +0000
+++ includes/PHPMailer-Lite_v5.1/examples/test_sendmail_advanced.php	2011-01-26 02:48:39 +0000
@@ -0,0 +1,32 @@
+<html>
+<head>
+<title>PHPMailer - Sendmail advanced test</title>
+</head>
+<body>
+
+<?php
+
+require_once('../class.phpmailer-lite.php');
+
+$mail = new PHPMailerLite(true); // the true param means it will throw exceptions on errors, which we need to catch
+$mail->IsSendmail(); // telling the class to use SendMail transport
+
+try {
+  $mail->SetFrom('me@you.com', 'Toni Pirhonen');
+  $mail->AddAddress('torrenttiposti@gmail.com', 'Toni Pirhonen');
+  $mail->Subject = 'Testi, jospa oiski näi heleppoo :D';
+  $mail->AltBody = 'To view the message, please use an HTML compatible email viewer!'; // optional - MsgHTML will create an alternate automatically
+  $mail->MsgHTML(file_get_contents('contents.html'));
+  $mail->AddAttachment('images/phpmailer.gif');      // attachment
+  $mail->AddAttachment('images/phpmailer_mini.gif'); // attachment
+  $mail->Send();
+  echo "Message Sent OK</p>\n";
+} catch (phpmailerException $e) {
+  echo $e->errorMessage(); //Pretty error messages from PHPMailer
+} catch (Exception $e) {
+  echo $e->getMessage(); //Boring error messages from anything else!
+}
+?>
+
+</body>
+</html>

=== added file 'includes/PHPMailer-Lite_v5.1/examples/test_sendmail_basic.php'
--- includes/PHPMailer-Lite_v5.1/examples/test_sendmail_basic.php	1970-01-01 00:00:00 +0000
+++ includes/PHPMailer-Lite_v5.1/examples/test_sendmail_basic.php	2011-01-26 02:48:39 +0000
@@ -0,0 +1,39 @@
+<html>
+<head>
+<title>PHPMailer - Sendmail basic test</title>
+</head>
+<body>
+
+<?php
+
+require_once('../class.phpmailer-lite.php');
+
+$mail             = new PHPMailerLite(); // defaults to using php "Sendmail" (or Qmail, depending on availability)
+
+$body             = file_get_contents('contents.html');
+$body             = eregi_replace("[\]",'',$body);
+
+$mail->SetFrom('name@yourdomain.com', 'First Last');
+
+$address = "whoto@otherdomain.com";
+$mail->AddAddress($address, "John Doe");
+
+$mail->Subject    = "PHPMailer Test Subject via Sendmail, basic";
+
+$mail->AltBody    = "To view the message, please use an HTML compatible email viewer!"; // optional, comment out and test
+
+$mail->MsgHTML($body);
+
+$mail->AddAttachment("images/phpmailer.gif");      // attachment
+$mail->AddAttachment("images/phpmailer_mini.gif"); // attachment
+
+if(!$mail->Send()) {
+  echo "Mailer Error: " . $mail->ErrorInfo;
+} else {
+  echo "Message sent!";
+}
+
+?>
+
+</body>
+</html>

=== added directory 'includes/PHPMailer-Lite_v5.1/test'
=== added file 'includes/PHPMailer-Lite_v5.1/test/contents.html'
--- includes/PHPMailer-Lite_v5.1/test/contents.html	1970-01-01 00:00:00 +0000
+++ includes/PHPMailer-Lite_v5.1/test/contents.html	2011-01-26 02:48:39 +0000
@@ -0,0 +1,10 @@
+<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
+<html>
+  <head>
+    <title>Email test</title>
+    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+  </head>
+  <body>
+	<p>Here is a test HTML email</p>
+  </body>
+</html>

=== added file 'includes/PHPMailer-Lite_v5.1/test/phpmailerTest.php'
--- includes/PHPMailer-Lite_v5.1/test/phpmailerTest.php	1970-01-01 00:00:00 +0000
+++ includes/PHPMailer-Lite_v5.1/test/phpmailerTest.php	2011-01-26 02:48:39 +0000
@@ -0,0 +1,670 @@
+<?php
+/**
+* PHPMailer - PHP email transport unit tests
+* Before running these tests you need to install PHPUnit 3.3 or later through pear, like this:
+*   pear install "channel://pear.phpunit.de/PHPUnit"
+* Then run the tests like this:
+*   phpunit phpmailerTest
+* @package PHPMailer
+* @author Andy Prevost
+* @author Marcus Bointon
+* @copyright 2004 - 2009 Andy Prevost
+* @version $Id: phpmailerTest.php 444 2009-05-05 11:22:26Z coolbru $
+* @license http://www.gnu.org/copyleft/lesser.html GNU Lesser General Public License
+*/
+
+require 'PHPUnit/Framework.php';
+
+$INCLUDE_DIR = "../";
+
+require $INCLUDE_DIR . 'class.phpmailer-lite.php';
+error_reporting(E_ALL);
+
+/**
+* PHPMailer - PHP email transport unit test class
+* Performs authentication tests
+*/
+class phpmailerTest extends PHPUnit_Framework_TestCase {
+    /**
+     * Holds the default phpmailer instance.
+     * @private
+     * @type object
+     */
+    var $Mail = false;
+
+    /**
+     * Holds the SMTP mail host.
+     * @public
+     * @type string
+     */
+    var $Host = "";
+
+    /**
+     * Holds the change log.
+     * @private
+     * @type string array
+     */
+    var $ChangeLog = array();
+
+     /**
+     * Holds the note log.
+     * @private
+     * @type string array
+     */
+    var $NoteLog = array();
+
+    /**
+     * Run before each test is started.
+     */
+    function setUp() {
+        global $INCLUDE_DIR;
+
+  @include './testbootstrap.php'; //Overrides go in here
+
+        $this->Mail = new PHPMailer();
+
+        $this->Mail->Priority = 3;
+        $this->Mail->Encoding = "8bit";
+        $this->Mail->CharSet = "iso-8859-1";
+        if (array_key_exists('mail_from', $_REQUEST)) {
+          $this->Mail->From = $_REQUEST['mail_from'];
+      } else {
+          $this->Mail->From = 'unit_test@phpmailer.sf.net';
+      }
+        $this->Mail->FromName = "Unit Tester";
+        $this->Mail->Sender = "";
+        $this->Mail->Subject = "Unit Test";
+        $this->Mail->Body = "";
+        $this->Mail->AltBody = "";
+        $this->Mail->WordWrap = 0;
+        if (array_key_exists('mail_host', $_REQUEST)) {
+          $this->Mail->Host = $_REQUEST['mail_host'];
+      } else {
+          $this->Mail->Host = 'mail.example.com';
+      }
+        $this->Mail->Port = 25;
+        $this->Mail->Helo = "localhost.localdomain";
+        $this->Mail->SMTPAuth = false;
+        $this->Mail->Username = "";
+        $this->Mail->Password = "";
+        $this->Mail->PluginDir = $INCLUDE_DIR;
+    $this->Mail->AddReplyTo("no_reply@phpmailer.sf.net", "Reply Guy");
+        $this->Mail->Sender = "unit_test@phpmailer.sf.net";
+
+        if(strlen($this->Mail->Host) > 0) {
+            $this->Mail->Mailer = "smtp";
+        } else {
+            $this->Mail->Mailer = "mail";
+            $this->Sender = "unit_test@phpmailer.sf.net";
+        }
+
+        if (array_key_exists('mail_to', $_REQUEST)) {
+          $this->SetAddress($_REQUEST['mail_to'], 'Test User', 'to');
+      }
+        if (array_key_exists('mail_cc', $_REQUEST) and strlen($_REQUEST['mail_cc']) > 0) {
+          $this->SetAddress($_REQUEST['mail_cc'], 'Carbon User', 'cc');
+      }
+    }
+
+    /**
+     * Run after each test is completed.
+     */
+    function tearDown() {
+        // Clean global variables
+        $this->Mail = NULL;
+        $this->ChangeLog = array();
+        $this->NoteLog = array();
+    }
+
+
+    /**
+     * Build the body of the message in the appropriate format.
+     * @private
+     * @returns void
+     */
+    function BuildBody() {
+        $this->CheckChanges();
+
+        // Determine line endings for message
+        if($this->Mail->ContentType == "text/html" || strlen($this->Mail->AltBody) > 0)
+        {
+            $eol = "<br/>";
+            $bullet = "<li>";
+            $bullet_start = "<ul>";
+            $bullet_end = "</ul>";
+        }
+        else
+        {
+            $eol = "\n";
+            $bullet = " - ";
+            $bullet_start = "";
+            $bullet_end = "";
+        }
+
+        $ReportBody = "";
+
+        $ReportBody .= "---------------------" . $eol;
+        $ReportBody .= "Unit Test Information" . $eol;
+        $ReportBody .= "---------------------" . $eol;
+        $ReportBody .= "phpmailer version: " . PHPMailer::VERSION . $eol;
+        $ReportBody .= "Content Type: " . $this->Mail->ContentType . $eol;
+
+        if(strlen($this->Mail->Host) > 0)
+            $ReportBody .= "Host: " . $this->Mail->Host . $eol;
+
+        // If attachments then create an attachment list
+        $attachments = $this->Mail->GetAttachments();
+        if(count($attachments) > 0)
+        {
+            $ReportBody .= "Attachments:" . $eol;
+            $ReportBody .= $bullet_start;
+            foreach($attachments as $attachment) {
+                $ReportBody .= $bullet . "Name: " . $attachment[1] . ", ";
+                $ReportBody .= "Encoding: " . $attachment[3] . ", ";
+                $ReportBody .= "Type: " . $attachment[4] . $eol;
+            }
+            $ReportBody .= $bullet_end . $eol;
+        }
+
+        // If there are changes then list them
+        if(count($this->ChangeLog) > 0)
+        {
+            $ReportBody .= "Changes" . $eol;
+            $ReportBody .= "-------" . $eol;
+
+            $ReportBody .= $bullet_start;
+            for($i = 0; $i < count($this->ChangeLog); $i++)
+            {
+                $ReportBody .= $bullet . $this->ChangeLog[$i][0] . " was changed to [" .
+                               $this->ChangeLog[$i][1] . "]" . $eol;
+            }
+            $ReportBody .= $bullet_end . $eol . $eol;
+        }
+
+        // If there are notes then list them
+        if(count($this->NoteLog) > 0)
+        {
+            $ReportBody .= "Notes" . $eol;
+            $ReportBody .= "-----" . $eol;
+
+            $ReportBody .= $bullet_start;
+            for($i = 0; $i < count($this->NoteLog); $i++)
+            {
+                $ReportBody .= $bullet . $this->NoteLog[$i] . $eol;
+            }
+            $ReportBody .= $bullet_end;
+        }
+
+        // Re-attach the original body
+        $this->Mail->Body .= $eol . $eol . $ReportBody;
+    }
+
+    /**
+     * Check which default settings have been changed for the report.
+     * @private
+     * @returns void
+     */
+    function CheckChanges() {
+        if($this->Mail->Priority != 3)
+            $this->AddChange("Priority", $this->Mail->Priority);
+        if($this->Mail->Encoding != "8bit")
+            $this->AddChange("Encoding", $this->Mail->Encoding);
+        if($this->Mail->CharSet != "iso-8859-1")
+            $this->AddChange("CharSet", $this->Mail->CharSet);
+        if($this->Mail->Sender != "")
+            $this->AddChange("Sender", $this->Mail->Sender);
+        if($this->Mail->WordWrap != 0)
+            $this->AddChange("WordWrap", $this->Mail->WordWrap);
+        if($this->Mail->Mailer != "mail")
+            $this->AddChange("Mailer", $this->Mail->Mailer);
+        if($this->Mail->Port != 25)
+            $this->AddChange("Port", $this->Mail->Port);
+        if($this->Mail->Helo != "localhost.localdomain")
+            $this->AddChange("Helo", $this->Mail->Helo);
+        if($this->Mail->SMTPAuth)
+            $this->AddChange("SMTPAuth", "true");
+    }
+
+    /**
+     * Adds a change entry.
+     * @private
+     * @returns void
+     */
+    function AddChange($sName, $sNewValue) {
+        $cur = count($this->ChangeLog);
+        $this->ChangeLog[$cur][0] = $sName;
+        $this->ChangeLog[$cur][1] = $sNewValue;
+    }
+
+    /**
+     * Adds a simple note to the message.
+     * @public
+     * @returns void
+     */
+    function AddNote($sValue) {
+        $this->NoteLog[] = $sValue;
+    }
+
+    /**
+     * Adds all of the addresses
+     * @public
+     * @returns void
+     */
+    function SetAddress($sAddress, $sName = "", $sType = "to") {
+        switch($sType)
+        {
+            case "to":
+                return $this->Mail->AddAddress($sAddress, $sName);
+            case "cc":
+                return $this->Mail->AddCC($sAddress, $sName);
+            case "bcc":
+                return $this->Mail->AddBCC($sAddress, $sName);
+        }
+    }
+
+    /////////////////////////////////////////////////
+    // UNIT TESTS
+    /////////////////////////////////////////////////
+
+    /**
+     * Try a plain message.
+     */
+    function test_WordWrap() {
+
+        $this->Mail->WordWrap = 40;
+        $my_body = "Here is the main body of this message.  It should " .
+                   "be quite a few lines.  It should be wrapped at the " .
+                   "40 characters.  Make sure that it is.";
+        $nBodyLen = strlen($my_body);
+        $my_body .= "\n\nThis is the above body length: " . $nBodyLen;
+
+        $this->Mail->Body = $my_body;
+        $this->Mail->Subject .= ": Wordwrap";
+
+        $this->BuildBody();
+        $this->assertTrue($this->Mail->Send(), $this->Mail->ErrorInfo);
+    }
+
+    /**
+     * Try a plain message.
+     */
+    function test_Low_Priority() {
+
+        $this->Mail->Priority = 5;
+        $this->Mail->Body = "Here is the main body.  There should be " .
+                            "a reply to address in this message.";
+        $this->Mail->Subject .= ": Low Priority";
+        $this->Mail->AddReplyTo("nobody@nobody.com", "Nobody (Unit Test)");
+
+        $this->BuildBody();
+        $this->assertTrue($this->Mail->Send(), $this->Mail->ErrorInfo);
+    }
+
+    /**
+     * Simple plain file attachment test.
+     */
+    function test_Multiple_Plain_FileAttachment() {
+
+        $this->Mail->Body = "Here is the text body";
+        $this->Mail->Subject .= ": Plain + Multiple FileAttachments";
+
+        if(!$this->Mail->AddAttachment("test.png"))
+        {
+            $this->assertTrue(false, $this->Mail->ErrorInfo);
+            return;
+        }
+
+        if(!$this->Mail->AddAttachment(__FILE__, "test.txt"))
+        {
+            $this->assertTrue(false, $this->Mail->ErrorInfo);
+            return;
+        }
+
+        $this->BuildBody();
+        $this->assertTrue($this->Mail->Send(), $this->Mail->ErrorInfo);
+    }
+
+    /**
+     * Simple plain string attachment test.
+     */
+    function test_Plain_StringAttachment() {
+
+        $this->Mail->Body = "Here is the text body";
+        $this->Mail->Subject .= ": Plain + StringAttachment";
+
+        $sAttachment = "These characters are the content of the " .
+                       "string attachment.\nThis might be taken from a ".
+                       "database or some other such thing. ";
+
+        $this->Mail->AddStringAttachment($sAttachment, "string_attach.txt");
+
+        $this->BuildBody();
+        $this->assertTrue($this->Mail->Send(), $this->Mail->ErrorInfo);
+    }
+
+    /**
+     * Plain quoted-printable message.
+     */
+    function test_Quoted_Printable() {
+
+        $this->Mail->Body = "Here is the main body";
+        $this->Mail->Subject .= ": Plain + Quoted-printable";
+        $this->Mail->Encoding = "quoted-printable";
+
+        $this->BuildBody();
+        $this->assertTrue($this->Mail->Send(), $this->Mail->ErrorInfo);
+
+  //Check that a quoted printable encode and decode results in the same as went in
+  $t = substr(file_get_contents(__FILE__), 0, 1024); //Just pick a chunk of this file as test content
+  $this->assertEquals($t, quoted_printable_decode($this->Mail->EncodeQP($t)), 'QP encoding round-trip failed');
+        //$this->assertEquals($t, quoted_printable_decode($this->Mail->EncodeQPphp($t)), 'Native PHP QP encoding round-trip failed'); //TODO the PHP qp encoder is quite broken
+
+    }
+
+    /**
+     * Try a plain message.
+     */
+    function test_Html() {
+
+        $this->Mail->IsHTML(true);
+        $this->Mail->Subject .= ": HTML only";
+
+        $this->Mail->Body = "This is a <b>test message</b> written in HTML. </br>" .
+                            "Go to <a href=\"http://phpmailer.sourceforge.net/\">" .
+                            "http://phpmailer.sourceforge.net/</a> for new versions of " .
+                            "phpmailer.  <p/> Thank you!";
+
+        $this->BuildBody();
+        $this->assertTrue($this->Mail->Send(), $this->Mail->ErrorInfo);
+    }
+
+    /**
+     * Simple HTML and attachment test
+     */
+    function test_HTML_Attachment() {
+
+        $this->Mail->Body = "This is the <b>HTML</b> part of the email.";
+        $this->Mail->Subject .= ": HTML + Attachment";
+        $this->Mail->IsHTML(true);
+
+        if(!$this->Mail->AddAttachment(__FILE__, "test_attach.txt"))
+        {
+            $this->assertTrue(false, $this->Mail->ErrorInfo);
+            return;
+        }
+
+        $this->BuildBody();
+        $this->assertTrue($this->Mail->Send(), $this->Mail->ErrorInfo);
+    }
+
+    /**
+     * An embedded attachment test.
+     */
+    function test_Embedded_Image() {
+
+        $this->Mail->Body = "Embedded Image: <img alt=\"phpmailer\" src=\"cid:my-attach\">" .
+                     "Here is an image!</a>";
+        $this->Mail->Subject .= ": Embedded Image";
+        $this->Mail->IsHTML(true);
+
+        if(!$this->Mail->AddEmbeddedImage("test.png", "my-attach", "test.png",
+                                          "base64", "image/png"))
+        {
+            $this->assertTrue(false, $this->Mail->ErrorInfo);
+            return;
+        }
+
+        $this->BuildBody();
+        $this->assertTrue($this->Mail->Send(), $this->Mail->ErrorInfo);
+  //For code coverage
+  $this->Mail->AddEmbeddedImage('thisfiledoesntexist', 'xyz'); //Non-existent file
+  $this->Mail->AddEmbeddedImage(__FILE__, '123'); //Missing name
+
+    }
+
+    /**
+     * An embedded attachment test.
+     */
+    function test_Multi_Embedded_Image() {
+
+        $this->Mail->Body = "Embedded Image: <img alt=\"phpmailer\" src=\"cid:my-attach\">" .
+                     "Here is an image!</a>";
+        $this->Mail->Subject .= ": Embedded Image + Attachment";
+        $this->Mail->IsHTML(true);
+
+        if(!$this->Mail->AddEmbeddedImage("test.png", "my-attach", "test.png",
+                                          "base64", "image/png"))
+        {
+            $this->assertTrue(false, $this->Mail->ErrorInfo);
+            return;
+        }
+
+        if(!$this->Mail->AddAttachment(__FILE__, "test.txt"))
+        {
+            $this->assertTrue(false, $this->Mail->ErrorInfo);
+            return;
+        }
+
+        $this->BuildBody();
+        $this->assertTrue($this->Mail->Send(), $this->Mail->ErrorInfo);
+    }
+
+    /**
+     * Simple multipart/alternative test.
+     */
+    function test_AltBody() {
+
+        $this->Mail->Body = "This is the <b>HTML</b> part of the email.";
+        $this->Mail->AltBody = "Here is the text body of this message.  " .
+                   "It should be quite a few lines.  It should be wrapped at the " .
+                   "40 characters.  Make sure that it is.";
+        $this->Mail->WordWrap = 40;
+        $this->AddNote("This is a mulipart alternative email");
+        $this->Mail->Subject .= ": AltBody + Word Wrap";
+
+        $this->BuildBody();
+        $this->assertTrue($this->Mail->Send(), $this->Mail->ErrorInfo);
+    }
+
+    /**
+     * Simple HTML and attachment test
+     */
+    function test_AltBody_Attachment() {
+
+        $this->Mail->Body = "This is the <b>HTML</b> part of the email.";
+        $this->Mail->AltBody = "This is the text part of the email.";
+        $this->Mail->Subject .= ": AltBody + Attachment";
+        $this->Mail->IsHTML(true);
+
+        if(!$this->Mail->AddAttachment(__FILE__, "test_attach.txt"))
+        {
+            $this->assertTrue(false, $this->Mail->ErrorInfo);
+            return;
+        }
+
+        $this->BuildBody();
+        $this->assertTrue($this->Mail->Send(), $this->Mail->ErrorInfo);
+        if (is_writable('.')) {
+            file_put_contents('message.txt', $this->Mail->CreateHeader() . $this->Mail->CreateBody());
+        } else {
+            $this->assertTrue(false, 'Could not write local file - check permissions');
+        }
+    }
+
+    function test_MultipleSend() {
+        $this->Mail->Body = "Sending two messages without keepalive";
+        $this->BuildBody();
+        $subject = $this->Mail->Subject;
+
+        $this->Mail->Subject = $subject . ": SMTP 1";
+        $this->assertTrue($this->Mail->Send(), $this->Mail->ErrorInfo);
+
+        $this->Mail->Subject = $subject . ": SMTP 2";
+        $this->assertTrue($this->Mail->Send(), $this->Mail->ErrorInfo);
+    }
+
+    function test_SendmailSend() {
+        $this->Mail->Body = "Sending via sendmail";
+        $this->BuildBody();
+        $subject = $this->Mail->Subject;
+
+        $this->Mail->Subject = $subject . ": sendmail";
+  $this->Mail->IsSendmail();
+        $this->assertTrue($this->Mail->Send(), $this->Mail->ErrorInfo);
+    }
+
+    function test_MailSend() {
+        $this->Mail->Body = "Sending via mail()";
+        $this->BuildBody();
+        $subject = $this->Mail->Subject;
+
+        $this->Mail->Subject = $subject . ": mail()";
+  $this->Mail->IsMail();
+        $this->assertTrue($this->Mail->Send(), $this->Mail->ErrorInfo);
+    }
+
+    function test_SmtpKeepAlive() {
+        $this->Mail->Body = "This was done using the SMTP keep-alive.";
+        $this->BuildBody();
+        $subject = $this->Mail->Subject;
+
+        $this->Mail->SMTPKeepAlive = true;
+        $this->Mail->Subject = $subject . ": SMTP keep-alive 1";
+        $this->assertTrue($this->Mail->Send(), $this->Mail->ErrorInfo);
+
+        $this->Mail->Subject = $subject . ": SMTP keep-alive 2";
+        $this->assertTrue($this->Mail->Send(), $this->Mail->ErrorInfo);
+        $this->Mail->SmtpClose();
+    }
+
+    /**
+     * Tests this denial of service attack:
+     *    http://www.cybsec.com/vuln/PHPMailer-DOS.pdf
+     */
+    function test_DenialOfServiceAttack() {
+        $this->Mail->Body = "This should no longer cause a denial of service.";
+        $this->BuildBody();
+
+        $this->Mail->Subject = str_repeat("A", 998);
+        $this->assertTrue($this->Mail->Send(), $this->Mail->ErrorInfo);
+    }
+
+  function test_Error() {
+    $this->Mail->Subject .= ": This should be sent";
+    $this->BuildBody();
+    $this->Mail->ClearAllRecipients(); // no addresses should cause an error
+    $this->assertTrue($this->Mail->IsError() == false, "Error found");
+    $this->assertTrue($this->Mail->Send() == false, "Send succeeded");
+    $this->assertTrue($this->Mail->IsError(), "No error found");
+    $this->assertEquals('You must provide at least one recipient email address.', $this->Mail->ErrorInfo);
+    $this->Mail->AddAddress($_REQUEST['mail_to']);
+    $this->assertTrue($this->Mail->Send(), "Send failed");
+  }
+
+  function test_Addressing() {
+    $this->assertFalse($this->Mail->AddAddress('a@example..com'), 'Invalid address accepted');
+    $this->assertTrue($this->Mail->AddAddress('a@example.com'), 'Addressing failed');
+    $this->assertFalse($this->Mail->AddAddress('a@example.com'), 'Duplicate addressing failed');
+    $this->assertTrue($this->Mail->AddCC('b@example.com'), 'CC addressing failed');
+    $this->assertFalse($this->Mail->AddCC('b@example.com'), 'CC duplicate addressing failed');
+    $this->assertFalse($this->Mail->AddCC('a@example.com'), 'CC duplicate addressing failed (2)');
+    $this->assertTrue($this->Mail->AddBCC('c@example.com'), 'BCC addressing failed');
+    $this->assertFalse($this->Mail->AddBCC('c@example.com'), 'BCC duplicate addressing failed');
+    $this->assertFalse($this->Mail->AddBCC('a@example.com'), 'BCC duplicate addressing failed (2)');
+    $this->assertTrue($this->Mail->AddReplyTo('a@example.com'), 'Replyto Addressing failed');
+    $this->assertFalse($this->Mail->AddReplyTo('a@example..com'), 'Invalid Replyto address accepted');
+    $this->Mail->ClearAddresses();
+    $this->Mail->ClearCCs();
+    $this->Mail->ClearBCCs();
+    $this->Mail->ClearReplyTos();
+  }
+
+  /**
+  * Test language files for missing and excess translations
+  * All languages are compared with English
+  */
+  function test_Translations() {
+    $this->Mail->SetLanguage('en');
+    $definedStrings = $this->Mail->GetTranslations();
+    foreach (new DirectoryIterator('../language') as $fileInfo) {
+      if($fileInfo->isDot()) continue;
+      $matches = array();
+      //Only look at language files, ignore anything else in there
+      if (preg_match('/^phpmailer\.lang-([a-z_]{2,})\.php$/', $fileInfo->getFilename(), $matches)) {
+        $lang = $matches[1]; //Extract language code
+        $PHPMAILER_LANG = array(); //Language strings get put in here
+        include $fileInfo->getPathname(); //Get language strings
+        $missing = array_diff(array_keys($definedStrings), array_keys($PHPMAILER_LANG));
+        $extra = array_diff(array_keys($PHPMAILER_LANG), array_keys($definedStrings));
+        $this->assertTrue(empty($missing), "Missing translations in $lang: ". implode(', ', $missing));
+        $this->assertTrue(empty($extra), "Extra translations in $lang: ". implode(', ', $extra));
+      }
+    }
+  }
+
+  /**
+  * Encoding tests
+  */
+  function test_Encodings() {
+      $this->Mail->Charset = 'iso-8859-1';
+      $this->assertEquals('=A1Hola!_Se=F1or!', $this->Mail->EncodeQ('Hola! Seor!', 'text'), 'Q Encoding (text) failed');
+      $this->assertEquals('=A1Hola!_Se=F1or!', $this->Mail->EncodeQ('Hola! Seor!', 'comment'), 'Q Encoding (comment) failed');
+      $this->assertEquals('=A1Hola!_Se=F1or!', $this->Mail->EncodeQ('Hola! Seor!', 'phrase'), 'Q Encoding (phrase) failed');
+  }
+
+  /**
+  * Signing tests
+  */
+  function test_Signing() {
+      $this->Mail->Sign('certfile.txt', 'keyfile.txt', 'password'); //TODO this is not really testing signing, but at least helps coverage
+  }
+
+  /**
+  * Miscellaneous calls to improve test coverage and some small tests
+  */
+  function test_Miscellaneous() {
+      $this->assertEquals('application/pdf', PHPMailer::_mime_types('pdf') , 'MIME TYPE lookup failed');
+      $this->Mail->AddCustomHeader('SomeHeader: Some Value');
+      $this->Mail->ClearCustomHeaders();
+      $this->Mail->ClearAttachments();
+      $this->Mail->IsHTML(false);
+      $this->Mail->IsSMTP();
+      $this->Mail->IsMail();
+      $this->Mail->IsSendMail();
+        $this->Mail->IsQmail();
+      $this->Mail->SetLanguage('fr');
+      $this->Mail->Sender = '';
+      $this->Mail->CreateHeader();
+      $this->assertFalse($this->Mail->set('x', 'y'), 'Invalid property set succeeded');
+      $this->assertTrue($this->Mail->set('Timeout', 11), 'Valid property set failed');
+      $this->Mail->getFile(__FILE__);
+  }
+}
+
+/**
+* This is a sample form for setting appropriate test values through a browser
+* These values can also be set using a file called testbootstrap.php (not in svn) in the same folder as this script
+* which is probably more useful if you run these tests a lot
+<html>
+<body>
+<h3>phpmailer Unit Test</h3>
+By entering a SMTP hostname it will automatically perform tests with SMTP.
+
+<form name="phpmailer_unit" action=__FILE__ method="get">
+<input type="hidden" name="submitted" value="1"/>
+From Address: <input type="text" size="50" name="mail_from" value="<?php echo get("mail_from"); ?>"/>
+<br/>
+To Address: <input type="text" size="50" name="mail_to" value="<?php echo get("mail_to"); ?>"/>
+<br/>
+Cc Address: <input type="text" size="50" name="mail_cc" value="<?php echo get("mail_cc"); ?>"/>
+<br/>
+SMTP Hostname: <input type="text" size="50" name="mail_host" value="<?php echo get("mail_host"); ?>"/>
+<p/>
+<input type="submit" value="Run Test"/>
+
+</form>
+</body>
+</html>
+ */
+
+?>
\ No newline at end of file

=== added file 'includes/PHPMailer-Lite_v5.1/test/test.png'
Binary files includes/PHPMailer-Lite_v5.1/test/test.png and includes/PHPMailer-Lite_v5.1/test/test.png differ
=== added file 'includes/PHPMailer-Lite_v5.1/test/test_callback.php'
--- includes/PHPMailer-Lite_v5.1/test/test_callback.php	1970-01-01 00:00:00 +0000
+++ includes/PHPMailer-Lite_v5.1/test/test_callback.php	2011-01-26 02:48:39 +0000
@@ -0,0 +1,84 @@
+<html>
+<head>
+<title>PHPMailer Lite - DKIM and Callback Function test</title>
+</head>
+<body>
+
+<?php
+/* This is a sample callback function for PHPMailer Lite.
+ * This callback function will echo the results of PHPMailer processing.
+ */
+
+/* Callback (action) function
+ *   bool    $result        result of the send action
+ *   string  $to            email address of the recipient
+ *   string  $cc            cc email addresses
+ *   string  $bcc           bcc email addresses
+ *   string  $subject       the subject
+ *   string  $body          the email body
+ * @return boolean
+ */
+function callbackAction ($result, $to, $cc, $bcc, $subject, $body) {
+  /*
+  this callback example echos the results to the screen - implement to
+  post to databases, build CSV log files, etc., with minor changes
+  */
+  $to  = cleanEmails($to,'to');
+  $cc  = cleanEmails($cc[0],'cc');
+  $bcc = cleanEmails($bcc[0],'cc');
+  echo $result . "\tTo: "  . $to['Name'] . "\tTo: "  . $to['Email'] . "\tCc: "  . $cc['Name'] . "\tCc: "  . $cc['Email'] . "\tBcc: "  . $bcc['Name'] . "\tBcc: "  . $bcc['Email'] . "\t"  . $subject . "<br />\n";
+  return true;
+}
+
+$testLite = false;
+
+if ($testLite) {
+  require_once '../class.phpmailer-lite.php';
+  $mail = new PHPMailerLite();
+} else {
+  require_once '../class.phpmailer.php';
+  $mail = new PHPMailer();
+}
+
+try {
+  $mail->IsMail(); // telling the class to use SMTP
+  $mail->SetFrom('you@yourdomain.com', 'Your Name');
+  $mail->AddAddress('another@yourdomain.com', 'John Doe');
+  $mail->Subject = 'PHPMailer Lite Test Subject via Mail()';
+  $mail->AltBody = 'To view the message, please use an HTML compatible email viewer!'; // optional - MsgHTML will create an alternate automatically
+  $mail->MsgHTML(file_get_contents('contents.html'));
+  $mail->AddAttachment('images/phpmailer.gif');      // attachment
+  $mail->AddAttachment('images/phpmailer_mini.gif'); // attachment
+  $mail->action_function = 'callbackAction';
+  $mail->Send();
+  echo "Message Sent OK</p>\n";
+} catch (phpmailerException $e) {
+  echo $e->errorMessage(); //Pretty error messages from PHPMailer
+} catch (Exception $e) {
+  echo $e->getMessage(); //Boring error messages from anything else!
+}
+
+function cleanEmails($str,$type) {
+  if ($type == 'cc') {
+    $addy['Email'] = $str[0];
+    $addy['Name']  = $str[1];
+    return $addy;
+  }
+  if (!strstr($str, ' <')) {
+    $addy['Name']  = '';
+    $addy['Email'] = $addy;
+    return $addy;
+  }
+  $addyArr = explode(' <', $str);
+  if (substr($addyArr[1],-1) == '>') {
+    $addyArr[1] = substr($addyArr[1],0,-1);
+  }
+  $addy['Name']  = $addyArr[0];
+  $addy['Email'] = $addyArr[1];
+  $addy['Email'] = str_replace('@', '&#64;', $addy['Email']);
+  return $addy;
+}
+
+?>
+</body>
+</html>

=== added file 'includes/PHPMailer-Lite_v5.1/test/testemail.php'
--- includes/PHPMailer-Lite_v5.1/test/testemail.php	1970-01-01 00:00:00 +0000
+++ includes/PHPMailer-Lite_v5.1/test/testemail.php	2011-01-26 02:48:39 +0000
@@ -0,0 +1,38 @@
+<?php
+/**
+* Simple example script using PHPMailer with exceptions enabled
+* @package phpmailer
+* @version $Id$
+*/
+
+require '../class.phpmailer-lite.php';
+
+try {
+  $mail = new PHPMailerLite(true); //New instance, with exceptions enabled
+
+  $body             = file_get_contents('contents.html');
+  $body             = preg_replace('/\\\\/','', $body); //Strip backslashes
+
+  $mail->AddReplyTo("name@domain.com","First Last");
+
+  $mail->SetFrom('you@yourdomain.com', 'Your Name');
+
+  $to = "someone@example...com";
+
+  $mail->AddAddress($to);
+
+  $mail->Subject  = "First PHPMailer Message";
+
+  $mail->AltBody    = "To view the message, please use an HTML compatible email viewer!"; // optional, comment out and test
+  $mail->WordWrap   = 80; // set word wrap
+
+  $mail->MsgHTML($body);
+
+  $mail->IsHTML(true); // send as HTML
+
+  $mail->Send();
+  echo 'Message has been sent.';
+} catch (phpmailerException $e) {
+  echo $e->errorMessage();
+}
+?>
\ No newline at end of file

=== added directory 'includes/sw'
=== added file 'includes/sw/index.html'
--- includes/sw/index.html	1970-01-01 00:00:00 +0000
+++ includes/sw/index.html	2011-01-26 02:48:39 +0000
@@ -0,0 +1,100 @@
+<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd"><html>
+<head>
+	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
+	<meta name="viewport" id="iphone-viewport" content="minimum-scale=1.0, maximum-scale=1.0, width=device-width" />
+	<meta name="apple-mobile-web-app-capable" content="yes" />
+
+	<link rel="stylesheet" href="spinningwheel.css" type="text/css" media="all" />
+	<script type="text/javascript" src="spinningwheel-min.js?v=1.4"></script>
+
+	<title>Spinning Wheel for iPhone/iPod touch</title>
+
+<script type="text/javascript">
+function openWeight() {
+	
+	var numbers = { 0: 0, 1: 1, 2: 2, 3: 3, 4: 4, 5: 5, 6: 6, 7: 7, 8: 8, 9: 9 };
+	SpinningWheel.addSlot(numbers, 'right');
+	SpinningWheel.addSlot(numbers, 'right');
+	SpinningWheel.addSlot(numbers, 'right');
+	SpinningWheel.addSlot({ separator: '.' }, 'readonly shrink');
+	SpinningWheel.addSlot(numbers, 'right');
+	SpinningWheel.addSlot({ Kg: 'Kg', Lb: 'Lb', St: 'St' }, 'shrink');
+	
+	SpinningWheel.setCancelAction(cancel);
+	SpinningWheel.setDoneAction(done);
+	
+	SpinningWheel.open();
+}
+
+function openBirthDate() {
+	var now = new Date();
+	var days = { };
+	var years = { };
+	var months = { 1: 'Gen', 2: 'Feb', 3: 'Mar', 4: 'Apr', 5: 'May', 6: 'Jun', 7: 'Jul', 8: 'Aug', 9: 'Sep', 10: 'Oct', 11: 'Nov', 12: 'Dec' };
+	
+	for( var i = 1; i < 32; i += 1 ) {
+		days[i] = i;
+	}
+
+	for( i = now.getFullYear()-100; i < now.getFullYear()+1; i += 1 ) {
+		years[i] = i;
+	}
+
+	SpinningWheel.addSlot(years, 'right', 1999);
+	SpinningWheel.addSlot(months, '', 4);
+	SpinningWheel.addSlot(days, 'right', 12);
+	
+	SpinningWheel.setCancelAction(cancel);
+	SpinningWheel.setDoneAction(done);
+	
+	SpinningWheel.open();
+}
+
+function openOneSlot() {
+	SpinningWheel.addSlot({1: 'Ichi', 2: 'Ni', 3: 'San', 4: 'Shi', 5: 'Go'});
+	
+	SpinningWheel.setCancelAction(cancel);
+	SpinningWheel.setDoneAction(done);
+	
+	SpinningWheel.open();
+}
+
+function done() {
+	var results = SpinningWheel.getSelectedValues();
+	document.getElementById('result').innerHTML = 'values: ' + results.values.join(' ') + '<br />keys: ' + results.keys.join(', ');
+}
+
+function cancel() {
+	document.getElementById('result').innerHTML = 'cancelled!';
+}
+
+
+window.addEventListener('load', function(){ setTimeout(function(){ window.scrollTo(0,0); }, 100); }, true);
+
+</script>
+
+
+<style type="text/css">
+body { text-align:center; font-family:helvetica; }
+button { font-size:16px; }
+#result { margin:10px; background:#aaa; -webkit-border-radius:8px; padding:8px; font-size:18px; }
+</style>
+
+</head>
+
+<body>
+<p>Spinning Wheel slot machine alike widget for iPhone and iPod touch. 
+This demo works only on the simulator and the real devices, it does not work on any other browser.</p>
+<button onclick="openBirthDate()">birth date</button>
+<button onclick="openWeight()">weight</button>
+<button onclick="openOneSlot()">1 slot</button>
+<p id="result">results</p>
+<p><a href="http://cubiq.org/spinning-wheel-on-webkit-for-iphone-ipod-touch/11">Read the related article on cubiq.org</a></p>
+
+<br/><br/><br/><br/><br/><br/><br/><br/><br/><br/><br/><br/><br/><br/>
+<br/><br/><br/><br/><br/><br/><br/><br/><br/><br/><br/><br/><br/><br/>
+
+this text is here for the sole purpose of making the page longer
+</body>
+
+</html>
\ No newline at end of file

=== added file 'includes/sw/spinningwheel-min.js'
--- includes/sw/spinningwheel-min.js	1970-01-01 00:00:00 +0000
+++ includes/sw/spinningwheel-min.js	2011-01-26 02:48:39 +0000
@@ -0,0 +1,1 @@
+var SpinningWheel={cellHeight:44,friction:0.003,slotData:[],handleEvent:function(e){if(e.type=="touchstart"){this.lockScreen(e);if(e.currentTarget.id=="sw-cancel"||e.currentTarget.id=="sw-done"){this.tapDown(e)}else{if(e.currentTarget.id=="sw-frame"){this.scrollStart(e)}}}else{if(e.type=="touchmove"){this.lockScreen(e);if(e.currentTarget.id=="sw-cancel"||e.currentTarget.id=="sw-done"){this.tapCancel(e)}else{if(e.currentTarget.id=="sw-frame"){this.scrollMove(e)}}}else{if(e.type=="touchend"){if(e.currentTarget.id=="sw-cancel"||e.currentTarget.id=="sw-done"){this.tapUp(e)}else{if(e.currentTarget.id=="sw-frame"){this.scrollEnd(e)}}}else{if(e.type=="webkitTransitionEnd"){if(e.target.id=="sw-wrapper"){this.destroy()}else{this.backWithinBoundaries(e)}}else{if(e.type=="orientationchange"){this.onOrientationChange(e)}else{if(e.type=="scroll"){this.onScroll(e)}}}}}}},onOrientationChange:function(e){window.scrollTo(0,0);this.swWrapper.style.top=window.innerHeight+window.pageYOffset+"px";this.calculateSlotsWidth()},onScroll:function(e){this.swWrapper.style.top=window.innerHeight+window.pageYOffset+"px"},lockScreen:function(e){e.preventDefault();e.stopPropagation()},reset:function(){this.slotEl=[];this.activeSlot=null;this.swWrapper=undefined;this.swSlotWrapper=undefined;this.swSlots=undefined;this.swFrame=undefined},calculateSlotsWidth:function(){var div=this.swSlots.getElementsByTagName("div");for(var i=0;i<div.length;i+=1){this.slotEl[i].slotWidth=div[i].offsetWidth}},create:function(){var i,l,out,ul,div;this.reset();div=document.createElement("div");div.id="sw-wrapper";div.style.top=window.innerHeight+window.pageYOffset+"px";div.style.webkitTransitionProperty="-webkit-transform";div.innerHTML='<div id="sw-header"><div id="sw-cancel">Cancel</div><div id="sw-done">Done</div></div><div id="sw-slots-wrapper"><div id="sw-slots"></div></div><div id="sw-frame"></div>';document.body.appendChild(div);this.swWrapper=div;this.swSlotWrapper=document.getElementById("sw-slots-wrapper");this.swSlots=document.getElementById("sw-slots");this.swFrame=document.getElementById("sw-frame");for(l=0;l<this.slotData.length;l+=1){ul=document.createElement("ul");out="";for(i in this.slotData[l].values){out+="<li>"+this.slotData[l].values[i]+"</li>"}ul.innerHTML=out;div=document.createElement("div");div.className=this.slotData[l].style;div.appendChild(ul);this.swSlots.appendChild(div);ul.slotPosition=l;ul.slotYPosition=0;ul.slotWidth=0;ul.slotMaxScroll=this.swSlotWrapper.clientHeight-ul.clientHeight-86;ul.style.webkitTransitionTimingFunction="cubic-bezier(0, 0, 0.2, 1)";this.slotEl.push(ul);if(this.slotData[l].defaultValue){this.scrollToValue(l,this.slotData[l].defaultValue)}}this.calculateSlotsWidth();document.addEventListener("touchstart",this,false);document.addEventListener("touchmove",this,false);window.addEventListener("orientationchange",this,true);window.addEventListener("scroll",this,true);document.getElementById("sw-cancel").addEventListener("touchstart",this,false);document.getElementById("sw-done").addEventListener("touchstart",this,false);this.swFrame.addEventListener("touchstart",this,false)},open:function(){this.create();this.swWrapper.style.webkitTransitionTimingFunction="ease-out";this.swWrapper.style.webkitTransitionDuration="400ms";this.swWrapper.style.webkitTransform="translate3d(0, -260px, 0)"},destroy:function(){this.swWrapper.removeEventListener("webkitTransitionEnd",this,false);this.swFrame.removeEventListener("touchstart",this,false);document.getElementById("sw-cancel").removeEventListener("touchstart",this,false);document.getElementById("sw-done").removeEventListener("touchstart",this,false);document.removeEventListener("touchstart",this,false);document.removeEventListener("touchmove",this,false);window.removeEventListener("orientationchange",this,true);window.removeEventListener("scroll",this,true);this.slotData=[];this.cancelAction=function(){return false};this.cancelDone=function(){return true};this.reset();document.body.removeChild(document.getElementById("sw-wrapper"))},close:function(){this.swWrapper.style.webkitTransitionTimingFunction="ease-in";this.swWrapper.style.webkitTransitionDuration="400ms";this.swWrapper.style.webkitTransform="translate3d(0, 0, 0)";this.swWrapper.addEventListener("webkitTransitionEnd",this,false)},addSlot:function(values,style,defaultValue){if(!style){style=""}style=style.split(" ");for(var i=0;i<style.length;i+=1){style[i]="sw-"+style[i]}style=style.join(" ");var obj={values:values,style:style,defaultValue:defaultValue};this.slotData.push(obj)},getSelectedValues:function(){var index,count,i,l,keys=[],values=[];for(i in this.slotEl){this.slotEl[i].removeEventListener("webkitTransitionEnd",this,false);this.slotEl[i].style.webkitTransitionDuration="0";if(this.slotEl[i].slotYPosition>0){this.setPosition(i,0)}else{if(this.slotEl[i].slotYPosition<this.slotEl[i].slotMaxScroll){this.setPosition(i,this.slotEl[i].slotMaxScroll)}}index=-Math.round(this.slotEl[i].slotYPosition/this.cellHeight);count=0;for(l in this.slotData[i].values){if(count==index){keys.push(l);values.push(this.slotData[i].values[l]);break}count+=1}}return{keys:keys,values:values}},setPosition:function(slot,pos){this.slotEl[slot].slotYPosition=pos;this.slotEl[slot].style.webkitTransform="translate3d(0, "+pos+"px, 0)"},scrollStart:function(e){var xPos=e.targetTouches[0].clientX-this.swSlots.offsetLeft;var slot=0;for(var i=0;i<this.slotEl.length;i+=1){slot+=this.slotEl[i].slotWidth;if(xPos<slot){this.activeSlot=i;break}}if(this.slotData[this.activeSlot].style.match("readonly")){this.swFrame.removeEventListener("touchmove",this,false);this.swFrame.removeEventListener("touchend",this,false);return false}this.slotEl[this.activeSlot].removeEventListener("webkitTransitionEnd",this,false);this.slotEl[this.activeSlot].style.webkitTransitionDuration="0";var theTransform=window.getComputedStyle(this.slotEl[this.activeSlot]).webkitTransform;theTransform=new WebKitCSSMatrix(theTransform).m42;if(theTransform!=this.slotEl[this.activeSlot].slotYPosition){this.setPosition(this.activeSlot,theTransform)}this.startY=e.targetTouches[0].clientY;this.scrollStartY=this.slotEl[this.activeSlot].slotYPosition;this.scrollStartTime=e.timeStamp;this.swFrame.addEventListener("touchmove",this,false);this.swFrame.addEventListener("touchend",this,false);return true},scrollMove:function(e){var topDelta=e.targetTouches[0].clientY-this.startY;if(this.slotEl[this.activeSlot].slotYPosition>0||this.slotEl[this.activeSlot].slotYPosition<this.slotEl[this.activeSlot].slotMaxScroll){topDelta/=2}this.setPosition(this.activeSlot,this.slotEl[this.activeSlot].slotYPosition+topDelta);this.startY=e.targetTouches[0].clientY;if(e.timeStamp-this.scrollStartTime>80){this.scrollStartY=this.slotEl[this.activeSlot].slotYPosition;this.scrollStartTime=e.timeStamp}},scrollEnd:function(e){this.swFrame.removeEventListener("touchmove",this,false);this.swFrame.removeEventListener("touchend",this,false);if(this.slotEl[this.activeSlot].slotYPosition>0||this.slotEl[this.activeSlot].slotYPosition<this.slotEl[this.activeSlot].slotMaxScroll){this.scrollTo(this.activeSlot,this.slotEl[this.activeSlot].slotYPosition>0?0:this.slotEl[this.activeSlot].slotMaxScroll);return false}var scrollDistance=this.slotEl[this.activeSlot].slotYPosition-this.scrollStartY;if(scrollDistance<this.cellHeight/1.5&&scrollDistance>-this.cellHeight/1.5){if(this.slotEl[this.activeSlot].slotYPosition%this.cellHeight){this.scrollTo(this.activeSlot,Math.round(this.slotEl[this.activeSlot].slotYPosition/this.cellHeight)*this.cellHeight,"100ms")}return false}var scrollDuration=e.timeStamp-this.scrollStartTime;var newDuration=(2*scrollDistance/scrollDuration)/this.friction;var newScrollDistance=(this.friction/2)*(newDuration*newDuration);if(newDuration<0){newDuration=-newDuration;newScrollDistance=-newScrollDistance}var newPosition=this.slotEl[this.activeSlot].slotYPosition+newScrollDistance;if(newPosition>0){newPosition/=2;newDuration/=3;if(newPosition>this.swSlotWrapper.clientHeight/4){newPosition=this.swSlotWrapper.clientHeight/4}}else{if(newPosition<this.slotEl[this.activeSlot].slotMaxScroll){newPosition=(newPosition-this.slotEl[this.activeSlot].slotMaxScroll)/2+this.slotEl[this.activeSlot].slotMaxScroll;newDuration/=3;if(newPosition<this.slotEl[this.activeSlot].slotMaxScroll-this.swSlotWrapper.clientHeight/4){newPosition=this.slotEl[this.activeSlot].slotMaxScroll-this.swSlotWrapper.clientHeight/4}}else{newPosition=Math.round(newPosition/this.cellHeight)*this.cellHeight}}this.scrollTo(this.activeSlot,Math.round(newPosition),Math.round(newDuration)+"ms");return true},scrollTo:function(slotNum,dest,runtime){this.slotEl[slotNum].style.webkitTransitionDuration=runtime?runtime:"100ms";this.setPosition(slotNum,dest?dest:0);if(this.slotEl[slotNum].slotYPosition>0||this.slotEl[slotNum].slotYPosition<this.slotEl[slotNum].slotMaxScroll){this.slotEl[slotNum].addEventListener("webkitTransitionEnd",this,false)}},scrollToValue:function(slot,value){var yPos,count,i;this.slotEl[slot].removeEventListener("webkitTransitionEnd",this,false);this.slotEl[slot].style.webkitTransitionDuration="0";count=0;for(i in this.slotData[slot].values){if(i==value){yPos=count*this.cellHeight;this.setPosition(slot,yPos);break}count-=1}},backWithinBoundaries:function(e){e.target.removeEventListener("webkitTransitionEnd",this,false);this.scrollTo(e.target.slotPosition,e.target.slotYPosition>0?0:e.target.slotMaxScroll,"150ms");return false},tapDown:function(e){e.currentTarget.addEventListener("touchmove",this,false);e.currentTarget.addEventListener("touchend",this,false);e.currentTarget.className="sw-pressed"},tapCancel:function(e){e.currentTarget.removeEventListener("touchmove",this,false);e.currentTarget.removeEventListener("touchend",this,false);e.currentTarget.className=""},tapUp:function(e){this.tapCancel(e);if(e.currentTarget.id=="sw-cancel"){this.cancelAction()}else{this.doneAction()}this.close()},setCancelAction:function(action){this.cancelAction=action},setDoneAction:function(action){this.doneAction=action},cancelAction:function(){return false},cancelDone:function(){return true}};
\ No newline at end of file

=== added file 'includes/sw/spinningwheel.css'
--- includes/sw/spinningwheel.css	1970-01-01 00:00:00 +0000
+++ includes/sw/spinningwheel.css	2011-01-26 02:48:39 +0000
@@ -0,0 +1,92 @@
+#sw-wrapper {
+	position:absolute; z-index:1000;
+	left:0;
+	width:100%;
+	font-family:helvetica, sans-serif;
+	background:rgba(0,0,0,0.7);
+	text-align:left;
+}
+
+#sw-header {
+	position:relative;
+	width:100%; height:43px;
+	border-top:1px solid #000; border-bottom:1px solid #000;
+	background:url(sw-header.png) 0 0 repeat-x;
+	opacity: 0.9;
+}
+
+#sw-cancel, #sw-done {
+	position:absolute;
+	top:7px;
+	height:20px; line-height:20px;
+	padding:0 5px; margin:0;
+	border-width:5px;
+	font-size:12px; font-weight:bold;
+	text-shadow:rgba(0,0,0,0.8) 0 -1px 0;
+	color:#fff;
+}
+
+#sw-cancel {
+	left:7px;
+	float:left;
+	-webkit-border-image:url(sw-button-cancel.png) 5;
+}
+
+#sw-done {
+	right:7px;
+	float:right;
+	-webkit-border-image:url(sw-button-done.png) 5;
+}
+
+.sw-pressed { opacity:0.4; }
+
+#sw-slots-wrapper {
+	position:relative; z-index:999;
+	display:block;
+	height:215px;
+	padding:0 11px;
+	overflow:hidden;
+}
+
+#sw-slots {
+	display:table;
+	width:100%;
+	background:#fcfcfc;
+}
+
+#sw-slots div {
+	display:table-cell;
+	height:100%;
+	padding-top:86px;
+	border-left:2px solid #0d0e0f;
+	background-color:#fcfcfc;
+	background-image: url(sw-slot-border.png);
+	background-position: 0 0, 100% 0;
+	background-repeat: repeat-y;
+}
+
+#sw-slots div:first-child { border:0; }
+
+#sw-slots ul {
+	padding:0 0 85px 0; margin:0;
+	list-style:none;
+}
+
+#sw-slots .sw-right { text-align:right; }
+#sw-slots .sw-shrink { width:1%; }
+#sw-slots .sw-readonly { background:#ddd; }
+
+#sw-slots li {
+	padding:0 8px;
+	height:44px;
+	overflow:hidden;
+	font:bold 24px/44px Helvetica,sans-serif;
+}
+
+#sw-frame {
+	position:absolute; z-index:1000;
+	left:0; right:0; bottom:0;
+	height:183px;
+	border-width:16px;
+	-webkit-border-image:url(sw-alpha.png) 16;
+}
\ No newline at end of file

=== added file 'includes/sw/spinningwheel.js'
--- includes/sw/spinningwheel.js	1970-01-01 00:00:00 +0000
+++ includes/sw/spinningwheel.js	2011-01-26 02:48:39 +0000
@@ -0,0 +1,492 @@
+/**
+ * 
+ * Find more about the Spinning Wheel function at
+ * http://cubiq.org/spinning-wheel-on-webkit-for-iphone-ipod-touch/11
+ *
+ * Copyright (c) 2009 Matteo Spinelli, http://cubiq.org/
+ * Released under MIT license
+ * http://cubiq.org/dropbox/mit-license.txt
+ * 
+ * Version 1.4 - Last updated: 2009.07.09
+ * 
+ */
+
+var SpinningWheel = {
+	cellHeight: 44,
+	friction: 0.003,
+	slotData: [],
+
+
+	/**
+	 *
+	 * Event handler
+	 *
+	 */
+
+	handleEvent: function (e) {
+		if (e.type == 'touchstart') {
+			this.lockScreen(e);
+			if (e.currentTarget.id == 'sw-cancel' || e.currentTarget.id == 'sw-done') {
+				this.tapDown(e);
+			} else if (e.currentTarget.id == 'sw-frame') {
+				this.scrollStart(e);
+			}
+		} else if (e.type == 'touchmove') {
+			this.lockScreen(e);
+			
+			if (e.currentTarget.id == 'sw-cancel' || e.currentTarget.id == 'sw-done') {
+				this.tapCancel(e);
+			} else if (e.currentTarget.id == 'sw-frame') {
+				this.scrollMove(e);
+			}
+		} else if (e.type == 'touchend') {
+			if (e.currentTarget.id == 'sw-cancel' || e.currentTarget.id == 'sw-done') {
+				this.tapUp(e);
+			} else if (e.currentTarget.id == 'sw-frame') {
+				this.scrollEnd(e);
+			}
+		} else if (e.type == 'webkitTransitionEnd') {
+			if (e.target.id == 'sw-wrapper') {
+				this.destroy();
+			} else {
+				this.backWithinBoundaries(e);
+			}
+		} else if (e.type == 'orientationchange') {
+			this.onOrientationChange(e);
+		} else if (e.type == 'scroll') {
+			this.onScroll(e);
+		}
+	},
+
+
+	/**
+	 *
+	 * Global events
+	 *
+	 */
+
+	onOrientationChange: function (e) {
+		window.scrollTo(0, 0);
+		this.swWrapper.style.top = window.innerHeight + window.pageYOffset + 'px';
+		this.calculateSlotsWidth();
+	},
+	
+	onScroll: function (e) {
+		this.swWrapper.style.top = window.innerHeight + window.pageYOffset + 'px';
+	},
+
+	lockScreen: function (e) {
+		e.preventDefault();
+		e.stopPropagation();
+	},
+
+
+	/**
+	 *
+	 * Initialization
+	 *
+	 */
+
+	reset: function () {
+		this.slotEl = [];
+
+		this.activeSlot = null;
+		
+		this.swWrapper = undefined;
+		this.swSlotWrapper = undefined;
+		this.swSlots = undefined;
+		this.swFrame = undefined;
+	},
+
+	calculateSlotsWidth: function () {
+		var div = this.swSlots.getElementsByTagName('div');
+		for (var i = 0; i < div.length; i += 1) {
+			this.slotEl[i].slotWidth = div[i].offsetWidth;
+		}
+	},
+
+	create: function () {
+		var i, l, out, ul, div;
+
+		this.reset();	// Initialize object variables
+
+		// Create the Spinning Wheel main wrapper
+		div = document.createElement('div');
+		div.id = 'sw-wrapper';
+		div.style.top = window.innerHeight + window.pageYOffset + 'px';		// Place the SW down the actual viewing screen
+		div.style.webkitTransitionProperty = '-webkit-transform';
+		div.innerHTML = '<div id="sw-header"><div id="sw-cancel">Cancel</' + 'div><div id="sw-done">Done</' + 'div></' + 'div><div id="sw-slots-wrapper"><div id="sw-slots"></' + 'div></' + 'div><div id="sw-frame"></' + 'div>';
+
+		document.body.appendChild(div);
+
+		this.swWrapper = div;													// The SW wrapper
+		this.swSlotWrapper = document.getElementById('sw-slots-wrapper');		// Slots visible area
+		this.swSlots = document.getElementById('sw-slots');						// Pseudo table element (inner wrapper)
+		this.swFrame = document.getElementById('sw-frame');						// The scrolling controller
+
+		// Create HTML slot elements
+		for (l = 0; l < this.slotData.length; l += 1) {
+			// Create the slot
+			ul = document.createElement('ul');
+			out = '';
+			for (i in this.slotData[l].values) {
+				out += '<li>' + this.slotData[l].values[i] + '<' + '/li>';
+			}
+			ul.innerHTML = out;
+
+			div = document.createElement('div');		// Create slot container
+			div.className = this.slotData[l].style;		// Add styles to the container
+			div.appendChild(ul);
+	
+			// Append the slot to the wrapper
+			this.swSlots.appendChild(div);
+			
+			ul.slotPosition = l;			// Save the slot position inside the wrapper
+			ul.slotYPosition = 0;
+			ul.slotWidth = 0;
+			ul.slotMaxScroll = this.swSlotWrapper.clientHeight - ul.clientHeight - 86;
+			ul.style.webkitTransitionTimingFunction = 'cubic-bezier(0, 0, 0.2, 1)';		// Add default transition
+			
+			this.slotEl.push(ul);			// Save the slot for later use
+			
+			// Place the slot to its default position (if other than 0)
+			if (this.slotData[l].defaultValue) {
+				this.scrollToValue(l, this.slotData[l].defaultValue);	
+			}
+		}
+		
+		this.calculateSlotsWidth();
+		
+		// Global events
+		document.addEventListener('touchstart', this, false);			// Prevent page scrolling
+		document.addEventListener('touchmove', this, false);			// Prevent page scrolling
+		window.addEventListener('orientationchange', this, true);		// Optimize SW on orientation change
+		window.addEventListener('scroll', this, true);				// Reposition SW on page scroll
+
+		// Cancel/Done buttons events
+		document.getElementById('sw-cancel').addEventListener('touchstart', this, false);
+		document.getElementById('sw-done').addEventListener('touchstart', this, false);
+
+		// Add scrolling to the slots
+		this.swFrame.addEventListener('touchstart', this, false);
+	},
+
+	open: function () {
+		this.create();
+
+		this.swWrapper.style.webkitTransitionTimingFunction = 'ease-out';
+		this.swWrapper.style.webkitTransitionDuration = '400ms';
+		this.swWrapper.style.webkitTransform = 'translate3d(0, -260px, 0)';
+	},
+	
+	
+	/**
+	 *
+	 * Unload
+	 *
+	 */
+
+	destroy: function () {
+		this.swWrapper.removeEventListener('webkitTransitionEnd', this, false);
+
+		this.swFrame.removeEventListener('touchstart', this, false);
+
+		document.getElementById('sw-cancel').removeEventListener('touchstart', this, false);
+		document.getElementById('sw-done').removeEventListener('touchstart', this, false);
+
+		document.removeEventListener('touchstart', this, false);
+		document.removeEventListener('touchmove', this, false);
+		window.removeEventListener('orientationchange', this, true);
+		window.removeEventListener('scroll', this, true);
+		
+		this.slotData = [];
+		this.cancelAction = function () {
+			return false;
+		};
+		
+		this.cancelDone = function () {
+			return true;
+		};
+		
+		this.reset();
+		
+		document.body.removeChild(document.getElementById('sw-wrapper'));
+	},
+	
+	close: function () {
+		this.swWrapper.style.webkitTransitionTimingFunction = 'ease-in';
+		this.swWrapper.style.webkitTransitionDuration = '400ms';
+		this.swWrapper.style.webkitTransform = 'translate3d(0, 0, 0)';
+		
+		this.swWrapper.addEventListener('webkitTransitionEnd', this, false);
+	},
+
+
+	/**
+	 *
+	 * Generic methods
+	 *
+	 */
+
+	addSlot: function (values, style, defaultValue) {
+		if (!style) {
+			style = '';
+		}
+		
+		style = style.split(' ');
+
+		for (var i = 0; i < style.length; i += 1) {
+			style[i] = 'sw-' + style[i];
+		}
+		
+		style = style.join(' ');
+
+		var obj = { 'values': values, 'style': style, 'defaultValue': defaultValue };
+		this.slotData.push(obj);
+	},
+
+	getSelectedValues: function () {
+		var index, count,
+		    i, l,
+			keys = [], values = [];
+
+		for (i in this.slotEl) {
+			// Remove any residual animation
+			this.slotEl[i].removeEventListener('webkitTransitionEnd', this, false);
+			this.slotEl[i].style.webkitTransitionDuration = '0';
+
+			if (this.slotEl[i].slotYPosition > 0) {
+				this.setPosition(i, 0);
+			} else if (this.slotEl[i].slotYPosition < this.slotEl[i].slotMaxScroll) {
+				this.setPosition(i, this.slotEl[i].slotMaxScroll);
+			}
+
+			index = -Math.round(this.slotEl[i].slotYPosition / this.cellHeight);
+
+			count = 0;
+			for (l in this.slotData[i].values) {
+				if (count == index) {
+					keys.push(l);
+					values.push(this.slotData[i].values[l]);
+					break;
+				}
+				
+				count += 1;
+			}
+		}
+
+		return { 'keys': keys, 'values': values };
+	},
+
+
+	/**
+	 *
+	 * Rolling slots
+	 *
+	 */
+
+	setPosition: function (slot, pos) {
+		this.slotEl[slot].slotYPosition = pos;
+		this.slotEl[slot].style.webkitTransform = 'translate3d(0, ' + pos + 'px, 0)';
+	},
+	
+	scrollStart: function (e) {
+		// Find the clicked slot
+		var xPos = e.targetTouches[0].clientX - this.swSlots.offsetLeft;	// Clicked position minus left offset (should be 11px)
+
+		// Find tapped slot
+		var slot = 0;
+		for (var i = 0; i < this.slotEl.length; i += 1) {
+			slot += this.slotEl[i].slotWidth;
+			
+			if (xPos < slot) {
+				this.activeSlot = i;
+				break;
+			}
+		}
+
+		// If slot is readonly do nothing
+		if (this.slotData[this.activeSlot].style.match('readonly')) {
+			this.swFrame.removeEventListener('touchmove', this, false);
+			this.swFrame.removeEventListener('touchend', this, false);
+			return false;
+		}
+
+		this.slotEl[this.activeSlot].removeEventListener('webkitTransitionEnd', this, false);	// Remove transition event (if any)
+		this.slotEl[this.activeSlot].style.webkitTransitionDuration = '0';		// Remove any residual transition
+		
+		// Stop and hold slot position
+		var theTransform = window.getComputedStyle(this.slotEl[this.activeSlot]).webkitTransform;
+		theTransform = new WebKitCSSMatrix(theTransform).m42;
+		if (theTransform != this.slotEl[this.activeSlot].slotYPosition) {
+			this.setPosition(this.activeSlot, theTransform);
+		}
+		
+		this.startY = e.targetTouches[0].clientY;
+		this.scrollStartY = this.slotEl[this.activeSlot].slotYPosition;
+		this.scrollStartTime = e.timeStamp;
+
+		this.swFrame.addEventListener('touchmove', this, false);
+		this.swFrame.addEventListener('touchend', this, false);
+		
+		return true;
+	},
+
+	scrollMove: function (e) {
+		var topDelta = e.targetTouches[0].clientY - this.startY;
+
+		if (this.slotEl[this.activeSlot].slotYPosition > 0 || this.slotEl[this.activeSlot].slotYPosition < this.slotEl[this.activeSlot].slotMaxScroll) {
+			topDelta /= 2;
+		}
+		
+		this.setPosition(this.activeSlot, this.slotEl[this.activeSlot].slotYPosition + topDelta);
+		this.startY = e.targetTouches[0].clientY;
+
+		// Prevent slingshot effect
+		if (e.timeStamp - this.scrollStartTime > 80) {
+			this.scrollStartY = this.slotEl[this.activeSlot].slotYPosition;
+			this.scrollStartTime = e.timeStamp;
+		}
+	},
+	
+	scrollEnd: function (e) {
+		this.swFrame.removeEventListener('touchmove', this, false);
+		this.swFrame.removeEventListener('touchend', this, false);
+
+		// If we are outside of the boundaries, let's go back to the sheepfold
+		if (this.slotEl[this.activeSlot].slotYPosition > 0 || this.slotEl[this.activeSlot].slotYPosition < this.slotEl[this.activeSlot].slotMaxScroll) {
+			this.scrollTo(this.activeSlot, this.slotEl[this.activeSlot].slotYPosition > 0 ? 0 : this.slotEl[this.activeSlot].slotMaxScroll);
+			return false;
+		}
+
+		// Lame formula to calculate a fake deceleration
+		var scrollDistance = this.slotEl[this.activeSlot].slotYPosition - this.scrollStartY;
+
+		// The drag session was too short
+		if (scrollDistance < this.cellHeight / 1.5 && scrollDistance > -this.cellHeight / 1.5) {
+			if (this.slotEl[this.activeSlot].slotYPosition % this.cellHeight) {
+				this.scrollTo(this.activeSlot, Math.round(this.slotEl[this.activeSlot].slotYPosition / this.cellHeight) * this.cellHeight, '100ms');
+			}
+
+			return false;
+		}
+
+		var scrollDuration = e.timeStamp - this.scrollStartTime;
+
+		var newDuration = (2 * scrollDistance / scrollDuration) / this.friction;
+		var newScrollDistance = (this.friction / 2) * (newDuration * newDuration);
+		
+		if (newDuration < 0) {
+			newDuration = -newDuration;
+			newScrollDistance = -newScrollDistance;
+		}
+
+		var newPosition = this.slotEl[this.activeSlot].slotYPosition + newScrollDistance;
+
+		if (newPosition > 0) {
+			// Prevent the slot to be dragged outside the visible area (top margin)
+			newPosition /= 2;
+			newDuration /= 3;
+
+			if (newPosition > this.swSlotWrapper.clientHeight / 4) {
+				newPosition = this.swSlotWrapper.clientHeight / 4;
+			}
+		} else if (newPosition < this.slotEl[this.activeSlot].slotMaxScroll) {
+			// Prevent the slot to be dragged outside the visible area (bottom margin)
+			newPosition = (newPosition - this.slotEl[this.activeSlot].slotMaxScroll) / 2 + this.slotEl[this.activeSlot].slotMaxScroll;
+			newDuration /= 3;
+			
+			if (newPosition < this.slotEl[this.activeSlot].slotMaxScroll - this.swSlotWrapper.clientHeight / 4) {
+				newPosition = this.slotEl[this.activeSlot].slotMaxScroll - this.swSlotWrapper.clientHeight / 4;
+			}
+		} else {
+			newPosition = Math.round(newPosition / this.cellHeight) * this.cellHeight;
+		}
+
+		this.scrollTo(this.activeSlot, Math.round(newPosition), Math.round(newDuration) + 'ms');
+ 
+		return true;
+	},
+
+	scrollTo: function (slotNum, dest, runtime) {
+		this.slotEl[slotNum].style.webkitTransitionDuration = runtime ? runtime : '100ms';
+		this.setPosition(slotNum, dest ? dest : 0);
+
+		// If we are outside of the boundaries go back to the sheepfold
+		if (this.slotEl[slotNum].slotYPosition > 0 || this.slotEl[slotNum].slotYPosition < this.slotEl[slotNum].slotMaxScroll) {
+			this.slotEl[slotNum].addEventListener('webkitTransitionEnd', this, false);
+		}
+	},
+	
+	scrollToValue: function (slot, value) {
+		var yPos, count, i;
+
+		this.slotEl[slot].removeEventListener('webkitTransitionEnd', this, false);
+		this.slotEl[slot].style.webkitTransitionDuration = '0';
+		
+		count = 0;
+		for (i in this.slotData[slot].values) {
+			if (i == value) {
+				yPos = count * this.cellHeight;
+				this.setPosition(slot, yPos);
+				break;
+			}
+			
+			count -= 1;
+		}
+	},
+	
+	backWithinBoundaries: function (e) {
+		e.target.removeEventListener('webkitTransitionEnd', this, false);
+
+		this.scrollTo(e.target.slotPosition, e.target.slotYPosition > 0 ? 0 : e.target.slotMaxScroll, '150ms');
+		return false;
+	},
+
+
+	/**
+	 *
+	 * Buttons
+	 *
+	 */
+
+	tapDown: function (e) {
+		e.currentTarget.addEventListener('touchmove', this, false);
+		e.currentTarget.addEventListener('touchend', this, false);
+		e.currentTarget.className = 'sw-pressed';
+	},
+
+	tapCancel: function (e) {
+		e.currentTarget.removeEventListener('touchmove', this, false);
+		e.currentTarget.removeEventListener('touchend', this, false);
+		e.currentTarget.className = '';
+	},
+	
+	tapUp: function (e) {
+		this.tapCancel(e);
+
+		if (e.currentTarget.id == 'sw-cancel') {
+			this.cancelAction();
+		} else {
+			this.doneAction();
+		}
+		
+		this.close();
+	},
+
+	setCancelAction: function (action) {
+		this.cancelAction = action;
+	},
+
+	setDoneAction: function (action) {
+		this.doneAction = action;
+	},
+	
+	cancelAction: function () {
+		return false;
+	},
+
+	cancelDone: function () {
+		return true;
+	}
+};
\ No newline at end of file

=== added file 'includes/sw/spinningwheelprototype.js'
--- includes/sw/spinningwheelprototype.js	1970-01-01 00:00:00 +0000
+++ includes/sw/spinningwheelprototype.js	2011-01-26 02:48:39 +0000
@@ -0,0 +1,23 @@
+/**
+ * 
+ * Find more about the Spinning Wheel function at
+ * http://cubiq.org/spinning-wheel-on-webkit-for-iphone-ipod-touch/11
+ *
+ * Copyright (c) 2009 Matteo Spinelli, http://cubiq.org/
+ * Released under MIT license
+ * http://cubiq.org/dropbox/mit-license.txt
+ * 
+ * Version 1.4 - Last updated: 2009.07.09
+ * 
+ * This is a customized version for prototype.js framework
+ */
+ 
+ function SPINNINGWHEEL(){
+ 	this.cellheight = 44;
+ 	this.friction = 0.003;
+ 	this.slotData = new Array();
+ }
+ 
+
+ 
+ 
\ No newline at end of file

=== added file 'includes/sw/sw-alpha.png'
Binary files includes/sw/sw-alpha.png and includes/sw/sw-alpha.png differ
=== added file 'includes/sw/sw-button-cancel.png'
Binary files includes/sw/sw-button-cancel.png and includes/sw/sw-button-cancel.png differ
=== added file 'includes/sw/sw-button-done.png'
Binary files includes/sw/sw-button-done.png and includes/sw/sw-button-done.png differ
=== added file 'includes/sw/sw-header.png'
Binary files includes/sw/sw-header.png and includes/sw/sw-header.png differ
=== added file 'includes/sw/sw-slot-border.png'
Binary files includes/sw/sw-slot-border.png and includes/sw/sw-slot-border.png differ
=== modified file 'index.php'
--- index.php	2010-09-14 23:12:38 +0000
+++ index.php	2011-01-26 02:48:39 +0000
@@ -2,19 +2,28 @@
 
 require("config.php");
 require("tools.php");
-require("module.php");
 
 header("Content-Type: application/xhtml+xml; charset=UTF-8");
 header("Content-Type: text/html; charset=UTF-8");
 header("Cache-Control: no-cache, must-revalidate");
 header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
 
+if (!isset($_GET["minimal"])) {
+	if (strpos($_SERVER['HTTP_USER_AGENT'],"iPhone") || strpos($_SERVER['HTTP_USER_AGENT'],"iPod") || strpos($_SERVER['HTTP_USER_AGENT'],"iPad") || ereg('iPhone',$_SERVER['HTTP_USER_AGENT']) || ereg('iPod',$_SERVER['HTTP_USER_AGENT'])) {
+		$host  = $_SERVER['HTTP_HOST'];
+		$uri   = rtrim(dirname($_SERVER['PHP_SELF']), "/\\");
+		$extra = 'index.php?minimal=iAdei';
+		header("Location: http://$host$uri/$extra");	
+	} 	
+}
+
 if (isset($_GET["minimal"])) {
     if ($_GET["minimal"]) $minimal = $_GET["minimal"];
     else $minimal = true;
     unset($_GET["minimal"]);
 } else $minimal = false;
 
+$ADEI_MODE = $minimal;
 
 if ($minimal) {
     switch ($minimal) {
@@ -35,7 +44,6 @@
 	$no_search = true;
 	$no_menu = true;
      break;
-
      case "search":
 	$config_module = "graph";
 	$allowed_modules = array("graph");
@@ -55,6 +63,15 @@
 	$no_header = false;
 	$no_search = true;
      break;
+     case "iAdei":
+        if (!in_array("settings", $MODULES)) array_push($MODULES, "settings");
+        $config_module = "wiki";
+	$allowed_modules = array("slowcontrol", "alarms", "graph", "wiki", "settings");
+        $allowed_popups = array("source", "export");
+        $displayed_popups = array();        
+        $no_header = true;
+        $iHeader = true;
+     break;
      default:
 	$config_module = "graph";
 	$allowed_modules = array($config_module);
@@ -79,7 +96,6 @@
 
 }
 
-
 $config_options = &$_GET;
 if (sizeof($config_options)) $config_options["apply"] = 1;
 
@@ -92,15 +108,28 @@
 } else {
     $_SESSION['setup'] = $ADEI_SETUP;
 }
+
+
+require("module.php");
+
+
 ?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
 <html xmlns="http://www.w3.org/1999/xhtml" xmlns:xf="http://www.w3.org/2002/xforms" xmlns:ev="http://www.w3.org/2001/xml-events" xmlns:xsd="http://www.w3.org/2001/XMLSchema">
 <head>
     <title>ADEI (Advanced Data Extraction Infrastructure) </title>
-    <meta name = "viewport" content = "user-scalable=no, initial-scale = 1.0, maximum-scale = 1.0, minimum-scale = 1.0" />
-    <meta name = "apple-mobile-web-app-capable" content = "yes" />
-    <link rel="stylesheet" type="text/css" href="adei.css"/> <?/* Should be first, otherwise cssSetProperty would not work */?>
-<?  if (file_exists($SETUP_CSS)) {?>
-    <link rel="stylesheet" type="text/css" href="<?echo $SETUP_CSS;?>"/>
+<?  if($iHeader){?>
+	<meta name = "viewport" content = "user-scalable=no, initial-scale = 1.0, maximum-scale = 1.0, minimum-scale = 1.0" />
+	<meta name="apple-touch-fullscreen" content="YES" />
+	<meta name="apple-mobile-web-app-capable" content="yes" />
+	<meta names="apple-mobile-web-app-status-bar-style" content="black-translucent" />
+	<link rel="stylesheet" type="text/css" href="iadei.css"/> <?/* Should be first, otherwise cssSetProperty would not work */?>
+	<link rel="stylesheet" type="text/css" href="includes/sw/spinningwheel.css"/>
+<?  } else {?>    
+	<link rel="stylesheet" type="text/css" href="adei.css"/> <?/* Should be first, otherwise cssSetProperty would not work */?>
+<?  }  
+
+    if (file_exists($SETUP_CSS)) {?>
+	<link rel="stylesheet" type="text/css" href="<?echo $SETUP_CSS;?>"/>
 <?  }?>
     <link rel="stylesheet" type="text/css" href="includes/dhtmlx/skins/dhtmlxmenu_<?=$DHTMLX_SKIN;?>.css"/>
     <link rel="stylesheet" type="text/css" href="includes/dhtmlx/dhtmlxtree.css"/>
@@ -112,7 +141,7 @@
     <script type="text/javascript" src="includes/prototype.js"></script>
     <script type="text/javascript" src="includes/scriptaculous/scriptaculous.js?load=builder,effects,dragdrop"></script>
     <script type="text/javascript" src="includes/cropper/cropper.js"></script>
-
+	
 <?/*
     This causes Ajax.Request (prototype) to return on 'onSuccess' handler
     status=0 (should be 200) and undefined responseText. 
@@ -172,12 +201,14 @@
 	    }
 	}
     }
+
 ?>    
     <script type="text/javascript" ev:event="onload">
 //<![CDATA[
 	function Geometry() {
+	    /* DS: Do we need this? */
 	    if (typeof adei == "undefined") return;
-	    
+
 	    var new_width = windowGetWidth();
 	    var new_height = windowGetHeight();
 	    <?moduleAdjustGeometry("new_width", "new_height");?>
@@ -223,15 +254,26 @@
 
 	    adei.Start('<?echo $config_module;?>', <?echo $AJAX_UPDATE_RATE;?>);
 	}
+	
+	function Navigate(btn) {
+  	    if(btn != "settings") {
+		adei.OpenModule(btn);
+	    } else {
+    		adei.SetConfiguration("p_id=main");
+    		adei.OpenModule(btn);
+    		adei.updater.Update();
+  	    } 
+	}
 //]]>
     </script>
 </head>
 
-<body onload="javascript:Startup()" onresize="Geometry()">
+<body onload="javascript:Startup()" onresize="Geometry()" onorientationchange="Geometry()">
 <div class="all ales">
 <?if (!$no_menu) {?>
     <div class="menu_button"><div id="menu_zone"></div></div>
 <?}?>
+
 <?if (!$no_header) {?>
     <div id="header_div" class="header">
 	<table width="100%" cellspacing="0" cellpadding="0"><tr>
@@ -248,6 +290,26 @@
 	</tr></table>
     </div>
 <?}?>
+
+<?if ($iHeader){?>
+    <div id="header_div" class="iheader">
+	<table><tr><td><button class="settingsbtn" id="settingsbutton" onclick="javascript:Navigate('settings');"></button></td><td><h1 class="ADEIhead">ADEI</h1></td></tr></table>
+        <select class="moduleSelector" onChange='javascript:Navigate(this.options[this.selectedIndex].value);' name="modsel" id="modsel">
+<? 
+     if($allowed_modules){
+     	for($i = 0; $i<sizeof($allowed_modules);$i++){
+   			echo"<option value='$allowed_modules[$i]'>";
+     		if (isset($GLOBALS[$allowed_modules[$i] . "_title"])) echo  $GLOBALS[$allowed_modules[$i] . "_title"];
+			else echo"$allowed_modules[$i]";
+			echo"</option>";
+     		
+     	}
+     }
+ ?>
+	</select>     
+    </div>
+<?}?>
+
     <div><table align="center" cellspacing="0" cellpadding="0">
 	<?/*<tr><td colspan="2"></td></tr>*/?>
 	<tr><td id="main_sidebar"><div>
@@ -265,9 +327,11 @@
 		<?modulePlacePages($allowed_modules);?>
 	</div></td></tr>
     </table></div>
+
     <div id="main_statusbar" class="statusbar">
 	<div>I'm a status bar</div>
     </div>
+  </div>
 </div>
 </body>
 </html>

=== modified file 'js/adei.js'
--- js/adei.js	2010-08-13 14:18:27 +0000
+++ js/adei.js	2011-01-26 02:48:39 +0000
@@ -262,6 +262,22 @@
     this.module.Open(mod);
 }
 
+ADEI.prototype.Next = function() {
+  var mod = this.module.setNext();
+  if(mod) this.module.Open(mod);
+}
+ADEI.prototype.Previous = function() {
+  var mod = this.module.setPrevious();
+  if(mod) {
+    this.module.Open(mod);       
+  }
+}
+ADEI.prototype.UpdateButtons = function(){
+  var btns = this.module.getBtnValues();
+  if(btns) return btns;
+  else return 'null';
+}
+
 ADEI.prototype.SwitchPopup = function(mod) {
     if (this.popup) this.popup.Switch(mod);
 }

=== modified file 'js/client.js'
--- js/client.js	2010-09-01 23:41:23 +0000
+++ js/client.js	2011-01-26 02:48:39 +0000
@@ -18,6 +18,16 @@
     return (navigator.userAgent.toLowerCase().indexOf("konqueror") > -1) ? true : false;
 }
 
+function isiDevice() {
+  return (navigator.userAgent.indexOf('iPhone') > -1 || navigator.userAgent.indexOf('iPod') > -1 || navigator.userAgent.indexOf('iPad') > -1 || navigator.userAgent.indexOf('android') > -1) ? true : false;
+}
+function isiPhone() {
+  return (navigator.userAgent.indexOf('iPhone') > -1 || navigator.userAgent.indexOf('iPod')) ? true : false;
+}
+function isiPad(){
+  return (navigator.userAgent.indexOf('iPad') > -1) ? true : false;
+}
+
 function CLIENT() {
     this.browser = 0;
     this.version = 0;
@@ -38,5 +48,13 @@
 CLIENT.prototype.isKonqueror = function() {
     return isKonqueror();
 }
-
+CLIENT.prototype.isiDevice = function() {
+  return isiDevice();
+}
+CLIENT.prototype.isiPhone = function() {
+  return isiPhone();
+}
+CLIENT.prototype.isiPad = function() {
+  return isiPad();
+}
 client = new CLIENT();

=== modified file 'js/graph.js'
--- js/graph.js	2010-08-04 06:30:21 +0000
+++ js/graph.js	2011-01-26 02:48:39 +0000
@@ -15,7 +15,7 @@
     this.height = 0;
     this.width = 0;
     
-    this.device = this.getDevice();   
+    this.idevice = isiDevice();   
     this.startX = 0; 
     this.startY = 0;
     this.curX = 0;  
@@ -26,10 +26,10 @@
     this.throwLeft = 0;
     this.test = 0;
     this.onlyLegend = 0;
-    if (this.device == "iPhone" || this.device == "iPad"){
-              this.fader = new Animator().addSubject(new NumericalStyleSubject($('graph_image_div'), 'opacity', 1, 0.13));
+    
+    if (this.idevice) {
+        this.fader = new Animator().addSubject(new NumericalStyleSubject($('graph_image_div'), 'opacity', 1, 0.13));        
     }
-
     
     if (this.frame) {
 	this.img = this.frame.getElementsByTagName('img')[0];
@@ -70,32 +70,13 @@
 }
 
 
-/** Checks if user is running on iPhone/iPod or iPad
- * if running on safari with iPhone returns "iPhone" if with iPad returns "iPad"
- */
-GRAPH.prototype.getDevice = function() {
-  if ((navigator.userAgent.match(/iPhone/i)) || (navigator.userAgent.match(/iPod/i)))
-  {
-    return "iPhone";
-  }
-  else if (navigator.userAgent.match(/iPad/i))
-  {
-    return "iPad";
-  } 
-  else {
-    return "other than iPad iPod iPhone";
-  }
-  
-  
-}
-
 GRAPH.prototype.onImageLoad = function(self) {
     return function() {
 	adei.SetSuccessStatus(self.onload_message?self.onload_message:translate("Done"));  
-  if(self.fader!=0){
-    self.AnimatorEffects(self,2);   
-  } 
 
+	if(self.fader){
+	    self.AnimatorEffects(self,2);   
+	} 
     }
 }
 
@@ -342,8 +323,8 @@
 			this.window.ZoomIn(x);
 		}
 	    break;
-/*	    default:
-		alert(adei.key);*/
+//	    default:
+//		  if(this.fader) this.fader.reverse();
 	}
 }
 
@@ -588,13 +569,15 @@
             }
         }
         else if(self.onlyLegend === 1 && self.swiping === 0){
+            var iphone = isiPhone();
+            if(!iphone) {
                 var x = adeiMathPreciseAdd(self.xmin, self.xsize*(self.startX - self.margins.left) / self.real_width);
                 var y = new Array();
                 for (var i = 0; i < self.axis.length; i++) {
                     y[i] = self.ymax[i] - (self.ymax[i] - self.ymin[i])*(self.startY - self.margins.top) / self.real_height;
                 }
                    
-                        var params = {
+                    var params = {
                     xmin: self.xmin.toString(),
                     xmax: self.xmax.toString(),
                     ymin: self.ymin,
@@ -615,11 +598,10 @@
                   alert('GetLegend request is failed');
                     }
                 });
-          self.onlyLegend = 0;
+        	
+		self.onlyLegend = 0;
+          }
         }
-        
-        
-
      }
 }
 
@@ -653,50 +635,28 @@
       gestureValues.x = adeiMathPreciseAdd(self.xmin, self.xsize*(self.startX - self.margins.left) / self.real_width);
      // alert(self.margins.left);
       gestureValues.marginsLeft = self.margins.left;
-      gestureValues.device = self.device;
+      gestureValues.device = self.idevice;
       gestureValues.y = new Array();
       for (var i = 0; i < self.axis.length; i++) {
         gestureValues.y[i] = self.ymax[i] - (self.ymax[i] - self.ymin[i])*(self.startY - self.margins.top) / self.real_height;        
       }
       if(self.fader != 0){self.AnimatorEffects(self,1);}
+      gestureValues.scale = scale;
       gestureValues.startX = self.startX;
-      gestureValues.angle = angle;
-      gestureValues.scale = scale;
       self.window.PinchZoom(gestureValues);
       self.startValuesSet = 0;      
-      self.window.Apply();
-      
+      self.window.Apply();      
   } 
 }
-/*
+
 GRAPH.prototype.onOrientationChange = function(self){
   return function(e){
-    self.updateOrientation();
-  }
-}
-
-
-//test
-GRAPH.prototype.updateOrientation = function(self){
-  switch(window.orientation){
-    case 0: //normal portrait
-      alert("Normal");
-      break; 
-    case -90: //right landscape
-      alert("Right");
-      break;
-    case 90: //left landscape
-      alert("Left");
-      break;
-    case 180: //Upsidedown portrait
-      alert("UpsideDown");
-      break;
-    default:
-      break;
-    
-  }
-}
-*/
+  	if(self.fader != 0){self.AnimatorEffects(self,1);}
+  	self.window.Apply();
+  }
+}
+
+
 /**Gets direction of Swipe gesture
  * When user swipes the screen with 1 finger, calculates heading and return an integer.
  * Return values:
@@ -825,7 +785,7 @@
 		    else
 			tooltip = "";
 
-      if(this.device == "iPhone" || this.device == "iPad")
+      if(this.idevice)
       {
                 this.crop = new Cropper.Img("graph_image", {
     /*     onEndCrop:  this.onEndCrop(this),
@@ -836,7 +796,7 @@
       onMouseScroll: this.onMouseScroll(this),
       onMouseMove: this.onMouseMove(this),
       */
-      //onOrientationChange: this.onOrientationChange(this),
+      onOrientationChange: this.onOrientationChange(this),
       onTouchStart: this.onTouchStart(this),
       onTouchMove:this.onTouchMove(this),
       onTouchEnd:this.onTouchEnd(this),

=== added file 'js/graphcontrol.js'
--- js/graphcontrol.js	1970-01-01 00:00:00 +0000
+++ js/graphcontrol.js	2011-01-26 02:48:39 +0000
@@ -0,0 +1,149 @@
+function GRAPHCONTROL(showid,showcontrolsdiv,imgdiv,windowref,graphimg,emaildiv,sensordiv){
+    this.showhidebutton = document.getElementById(showcontrolsdiv);
+    this.controls = document.getElementById(showid);
+    this.imgdiv = document.getElementById(imgdiv);
+    this.graphimg = document.getElementById(graphimg);
+    this.emaildiv = document.getElementById(emaildiv);
+    this.sensordiv = document.getElementById(sensordiv);
+    var num = 0;
+    this.win = windowref;
+    this.path;
+    Event.observe(this.showhidebutton,'click', this.showhide.bindAsEventListener(this));
+    Event.observe(this.controls, 'click', this.showhide.bindAsEventListener(this));
+}
+GRAPHCONTROL.prototype.showhide = function(ev){
+    if (this.num == 1){
+        this.controls.style.visibility = 'visible';
+        this.num=0;
+    }else{
+        this.controls.style.visibility = 'hidden';
+        this.num=1;
+    }
+    this.StopPropagation(ev);
+}
+GRAPHCONTROL.prototype.StopPropagation = function(ev){
+    if (!ev) var ev = window.event;
+    if (ev)if (ev.cancelBubble)ev.cancelBubble = true;
+    if (ev)if (ev.stopPropagation) ev.stopPropagation();
+
+}
+GRAPHCONTROL.prototype.sendEmail = function(){
+    try{
+        var	props = "url="+ window.location;
+        props += "&from="+ document.getElementById('from').value;
+        props += "&to="+document.getElementById('tomail').value;
+        props += "&message="+document.getElementById('message').value;
+        props += "&attachement=" + this.path;
+        props += "&task=Send";
+        props = props.replace('#','&');
+        new Ajax.Request(
+            adei.GetServiceURL('email',props),
+    	    {
+		method: 'get',
+		onSuccess: this.MailSent(this),
+		onFailure: this.MailFail(this)
+    	    }
+        );
+    } catch (err) {
+        alert("FAILED : "+ err);
+    }
+}
+
+
+GRAPHCONTROL.prototype.MailSent = function(graphcontrol) {
+    return function(transport) {
+        if (!transport && !transport.responseText) alert("Unexpected content received");
+        else alert("Success : " + transport.responseText);
+    }
+}
+
+GRAPHCONTROL.prototype.MailFail = function(graphcontrol) {
+    return function(transport) {
+        alert("No data was returned by the service");
+    }
+}
+
+GRAPHCONTROL.prototype.openMailForm = function() {
+    var serviceurl = adei.GetService('email');
+    this.emaildiv.style.visibility = 'visible';
+    adei.UpdateDIV('emailform',serviceurl,'email');
+}
+
+GRAPHCONTROL.prototype.closediv = function(type) {
+    if (type=='imgdiv')this.imgdiv.style.visibility = 'hidden';
+    if (type=='emailform')this.emaildiv.style.visibility = 'hidden';
+    if (type=='sensordiv')this.sensordiv.style.visibility = 'hidden';
+    this.StopPropagation();
+}
+
+GRAPHCONTROL.prototype.getSensors = function(){
+    if (this.sensordiv) {
+        var serviceurl = adei.GetService('email');
+        serviceurl += "&"+adei.config.GetProps();
+        serviceurl += "&task=getSensorList";
+        this.sensordiv.style.visibility = 'visible';
+        adei.UpdateDIV('sensorlist',serviceurl,'sensorlist',true);
+    }
+}
+
+GRAPHCONTROL.prototype.loadImage = function(){
+    var props = adei.config.GetProps();
+    props += "&width=1024&height=640&task=genpic";
+    try{
+        new Ajax.Request(
+            adei.GetServiceURL('email',props),
+    	    {
+		method: 'get',
+		onSuccess: this.getFilePath(this),
+		onFailure: this.failed(this)
+    	    }
+        );
+        this.openMailForm();
+    } catch (err) {
+        alert("Request Failed : "+ err);
+    }
+}
+
+GRAPHCONTROL.prototype.failed = function(graphcontrol) {
+    return function(transport) {
+        alert("Request returned onFailure : " + transport.responseText);
+    }
+}
+GRAPHCONTROL.prototype.getFilePath = function(self) {
+    return function(transport) {
+        if (!transport && !transport.responseText) alert("Request returned no content");
+        else{
+            if (transport.responseText=='FAIL') alert("Creating temporary folder for image failed");
+            else self.path = transport.responseText;
+        }
+    }
+}
+
+GRAPHCONTROL.prototype.genIMG = function(ev) {
+    this.StopPropagation();
+    this.loadImage();
+}
+
+GRAPHCONTROL.prototype.UseWindow = function(prop) {
+    switch (prop){
+    case "centerzoomin":
+        this.win.window.CenterZoomIn();
+        break;
+    case "centerzoomout":
+        this.win.window.CenterZoomOut();
+        break;
+    case "moveright":
+        this.win.window.MoveRight();
+        break;
+    case "moveleft":
+        this.win.window.MoveLeft();
+        break;
+    case "moveup":
+        this.win.window.MoveUp();
+        break;
+    case "movedown":
+        this.win.window.MoveDown();
+        break;
+    }
+    this.StopPropagation();
+}

=== modified file 'js/module.js'
--- js/module.js	2010-08-13 14:01:17 +0000
+++ js/module.js	2011-01-26 02:48:39 +0000
@@ -54,17 +54,6 @@
     return null;
 }
 
-/*
-MODULE.prototype.SetCurrent = function(module) {
-    with (this) {
-	if (module.length > 0) {
-	    current_module = module;
-	    UpdateGeometry();	 
-	} else current_module = null;
-    }
-}
-*/
-
 MODULE.prototype.Open = function(mod) {
     var prefix;
     

=== added file 'js/settings.js'
--- js/settings.js	1970-01-01 00:00:00 +0000
+++ js/settings.js	2011-01-26 02:48:39 +0000
@@ -0,0 +1,378 @@
+function SETTINGS(w) {
+    this.db_server="";
+    this.db_name;
+    this.db_group;
+    this.control_group;
+    this.db_mask;
+    this.db_item;
+    this.settingprops = "&";
+    this.depth = 1;
+    this.interval;
+    this.aggrpages = new Object();
+    this.aggrprop="&";
+}
+
+SETTINGS.prototype.setValue = function(id,vlue) {
+ switch (id) {
+    case "server":
+        this.db_server=vlue;
+        this.settingprops = vlue;
+        break;
+    case "database":
+        this.db_name=vlue;
+        this.settingprops += vlue;
+        break;
+    case "loggroup":
+        this.db_group=vlue;
+        this.settingprops += vlue;
+        break;
+    case "itemmask":
+        this.item = vlue;
+        this.settingprops += vlue;
+    case "controlgroup":
+        this.control_group=vlue;
+        this.settingprops += vlue;
+        break;
+    case "aggr":
+        this.aggrprop += vlue;
+        break;
+    default:
+        alert("failed");
+        break;
+ }
+}
+
+
+SETTINGS.prototype.setconf = function() {
+    if (this.settingprops) {
+        this.goTo(this.settingprops);
+        this.settingprops = "&";
+        this.depth = 1;
+        this.db_server = this.db_name = this.db_group = this.db_mask = 'undefined';
+        this.goTo("p_id=main");
+        adei.OpenModule('graph');
+        adei.updater.Update();
+    }
+}
+
+SETTINGS.prototype.makeRequest = function(target) {
+    var listreq;
+    var head;
+    var hist;
+    var xslt = "settingsdyn";
+    var pid;
+    switch (target){
+     case 'target=servers':
+        listreq = adei.GetService('list',target+"&skip_uncached=true");
+        hist = "p_id=sourcefront";
+        head = 'Server';
+        pid="source";
+        break;
+     case 'target=databases':
+        if (this.db_server != 'undefined'){
+            listreq = adei.GetService('list',target+"&"+this.db_server);
+            hist = 'target=servers';
+            head = 'Database';
+            pid="source";
+        }else alert("Define server first");
+        break;
+     case 'target=groups':
+        if (this.db_server != 'undefined' && this.db_name != 'undefined'){
+            listreq = adei.GetService('list',target+"&"+this.db_server+"&"+this.db_name);
+            hist = 'target=databases';
+            head = 'LogGroup';
+            pid="source";
+        }else alert("Define server and database first");
+        break;
+     case 'target=masks':
+        if (this.db_server != 'undefined' && this.db_name != 'undefined' && this.db_group != 'undefined'){
+            listreq = adei.GetService('list',target+"&"+"menu=1"+"&"+this.db_server+"&"+this.db_name+"&"+this.db_group);
+            hist = 'target=groups';
+            head = 'ItemMask';
+            pid="source";
+        }else alert("Define server, database and loggroup first");
+        break;
+     case 'target=sourcetimecustom':
+        listreq = adei.GetService('settings',"p_id=sourcetimecustom");
+        xslt = "idatetimepicker";
+        break;
+     case 'target=sourcetimewindow':
+        listreq = adei.GetService('settings',"p_id=sourcetimewindow");
+        xslt = "idatetimepicker";
+        break;
+     case 'target=items':
+        if (this.db_server != 'undefined' && this.db_name != 'undefined' && this.db_group != 'undefined'){
+            listreq = adei.GetService('list',target+"&"+this.db_server+"&"+this.db_name+"&"+this.db_group);
+            hist = 'target=masks';
+            head = 'Standalone Item';
+            pid="source";
+        }else alert("Define server, database and loggroup first");
+        break;
+     case 'target=aggregation_modes':
+        listreq = adei.GetService('list',target);
+        hist="p_id=controls";
+        head="Aggregation Modes";
+        pid = "control";
+        break;
+     case 'target=interpolation_modes':
+        listreq = adei.GetService('list',target);
+        hist = "target=aggregation_modes";
+        head = "Interpolation Modes";
+        pid = "control";
+        break;
+     case 'target=marks_modes':
+        listreq = adei.GetService('list',target);
+        hist="target=interpolation_modes";
+        head="Show Marks";
+        pid = "control";
+        break;
+     case 'target=gaps_modes':
+        listreq = adei.GetService('list',target);
+        hist="target=mark_modes";
+        head="Show Gaps";
+        pid = "control";
+        break;
+     default:
+        alert("Unknown target");
+        break;
+    }
+    var xmlresult = getXML(listreq);
+    if (xslt == 'settingsdyn'){
+        xmlresult = this.addElement(xmlresult,"pageid",pid);
+        xmlresult = this.addElement(xmlresult,"history",hist);
+        xmlresult = this.addElement(xmlresult,"heading",head);
+    }
+    var jsonvar = new Object();
+    jsonvar.xml = xmlresult;
+    jsonvar.xslt=xslt;
+    settings.Update(jsonvar, 'false');
+}
+
+SETTINGS.prototype.goTo = function(page,tograph) {
+    adei.SetConfiguration(page);
+    if (tograph)adei.OpenModule('graph');
+}
+
+SETTINGS.prototype.updateTime = function(vlue) {
+    adei.SetConfiguration(vlue + "&p_id=main");
+    adei.OpenModule('graph');
+    adei.updater.Update();
+}
+
+SETTINGS.prototype.addElement = function(xmlobject,element,content) {
+    var root = xmlobject.documentElement;
+    var el = xmlobject.createElement(element);
+    var txt = xmlobject.createTextNode(content);
+    el.appendChild(txt);
+    root.appendChild(el);
+    return xmlobject;
+}
+
+
+SETTINGS.prototype.ProcessWindow = function() {
+    var start = document.getElementById('startdate').value;
+    var end = document.getElementById('enddate').value;
+    start += " " + document.getElementById('starttime').value;
+    end += " " + document.getElementById('endtime').value;
+    start = Date.parse(start);
+    end = Date.parse(end);
+    start = start/1000;
+    end = end/1000;
+    start += "";
+    end += "";
+    this.updateTime("window="+start+"-"+end);
+}
+
+SETTINGS.prototype.HandleBack = function(target) {
+    this.depth--;
+    if (target == 'p_id=sourcefront' || target == 'p_id=controls')this.goTo(target);
+    else this.makeRequest(target);
+}
+
+SETTINGS.prototype.Search = function() {
+    var searchvalue = document.getElementById('searchfield').value;
+    var searchreq =	adei.GetService("search", "search="+searchvalue);
+    var xmlresult = getXML(searchreq);
+
+    xmlresult = this.addElement(xmlresult,"history","p_id=sourcefront");
+    xmlresult = this.addElement(xmlresult,"heading","Search");
+    xmlresult = this.addElement(xmlresult,"page","searchresults");
+    var jsonvar = new Object();
+    jsonvar.xml = xmlresult;
+    jsonvar.xslt = "settings";
+    settings.Update(jsonvar,'false');
+}
+
+SETTINGS.prototype.CreateSpinningWheel = function(type) {
+    if (type == 'startdate' || type == 'enddate'){
+        var now = new Date();
+        var days = { };
+        var years = { };
+	var months = { 
+		 1: 'Jan'
+               , 2: 'Feb'
+               , 3: 'Mar'
+               , 4: 'Apr'
+               , 5: 'May'
+               , 6: 'Jun'
+               , 7: 'Jul'
+               , 8: 'Aug'
+               , 9: 'Sep'
+               , 10: 'Oct'
+               , 11: 'Nov'
+               , 12: 'Dec'
+        };
+
+        for ( var i = 1; i < 32; i += 1 ) {
+            days[i] = i;
+        }
+
+        for ( i = now.getFullYear()-100; i < now.getFullYear()+1; i += 1 ) {
+            years[i] = i;
+        }
+
+        SpinningWheel.addSlot(months, '', 1);
+        SpinningWheel.addSlot(days, 'right', 1);
+        SpinningWheel.addSlot(years, 'right', 1999);
+
+        SpinningWheel.setCancelAction(this.Cancel);
+        SpinningWheel.setDoneAction(this.getResults,type);
+        SpinningWheel.open();
+
+    } else if (type == 'starttime' || type == 'endtime') {
+        var hours = {};
+        var minutes = {};
+        var seconds = {};
+        var i = 1;
+
+        for (i = 0; i<24; i++){
+            if (i<10) hours["0"+i] = "0" + i;
+            else hours[i] = i;
+        }
+        for (i=0; i<60; i++){
+            if (i<10){
+                minutes["0"+i] = "0" + i;
+                seconds["0"+i] = "0" + i;
+            }
+            else{
+                minutes[i] = i;
+                seconds[i] = i;
+            }
+        }
+
+        SpinningWheel.addSlot(hours,'right', 5);
+	SpinningWheel.addSlot({':': 'h'},'readonly shrink');
+        SpinningWheel.addSlot(minutes,'', 5);
+	SpinningWheel.addSlot({':': 'm'},'readonly shrink');
+        SpinningWheel.addSlot(seconds,'right',5);
+	SpinningWheel.addSlot({'': 's'},'readonly shrink');
+
+        SpinningWheel.setCancelAction(this.Cancel);
+        SpinningWheel.setDoneAction(this.getResults,type);
+
+        SpinningWheel.open();
+    }
+}
+
+SETTINGS.prototype.getResults = function(id) {
+    var results = SpinningWheel.getSelectedValues();
+    switch (id) {
+      case 'startdate':
+        document.getElementById('startdate').value = results.keys.join('/');
+        break;
+      case 'starttime':
+        document.getElementById('starttime').value = results.keys.join('');
+        break;
+      case 'enddate':
+        document.getElementById('enddate').value = results.keys.join('/');
+        break;
+      case 'endtime':
+        document.getElementById('endtime').value = results.keys.join('');
+        break;
+    }
+}
+
+SETTINGS.prototype.Cancel = function() {
+    //alert("canceled");
+}
+
+SETTINGS.prototype.sendGetRequest = function(p_id,vlue) {
+    switch (p_id){
+      case "p_id=sourceselect":
+        switch (this.depth) {
+          case 1:
+            this.makeRequest("target=servers");
+            break;
+          case 2:
+            this.setValue("server","&db_server="+vlue);
+            this.makeRequest("target=databases");
+            break;
+          case 3:
+            this.setValue("database","&db_name="+vlue);
+            this.makeRequest("target=groups");
+            break;
+          case 4:
+            this.setValue("loggroup","&db_group="+vlue);
+            this.makeRequest("target=masks");
+            break;
+          case 5:
+            if (vlue != -1){
+                this.setValue("itemmask","&db_mask="+vlue);
+                this.goTo("p_id=main");
+                this.setconf();
+            }
+            else{
+                this.makeRequest("target=items");
+            }
+            break;
+          case 6:
+            this.setValue("itemmask","&db_mask="+vlue);
+            this.goTo("p_id=main");
+            this.setconf();
+            break;
+        }
+        this.depth +=1;
+        break;
+      case "p_id=controlsexp":
+        this.LoadControlsExp();
+        break;
+      case "p_id=sourcetimecustom":
+        this.makeRequest("target=sourcetimecustom");
+        break;
+      case "p_id=sourcetimewindow":
+        this.makeRequest("target=sourcetimewindow");
+        break;
+      case "p_id=controlsaggr":
+        switch (this.depth){
+          case 1:
+            this.makeRequest("target=aggregation_modes");
+            break;
+          case 2:
+            this.setValue("aggr","aggregation="+vlue);
+            this.makeRequest("target=interpolation_modes");
+            break;
+          case 3:
+            this.setValue("aggr","&interpolation="+vlue);
+            this.makeRequest("target=marks_modes");
+            break;
+          case 4:
+            this.setValue("aggr","&show_marks="+vlue);
+            this.makeRequest("target=gaps_modes");
+            break;
+          case 5:
+            this.setValue("aggr","&show_gaps="+vlue);
+            adei.SetConfiguration(this.aggrprop);
+            this.goTo("p_id=main");
+            adei.OpenModule('graph');
+            this.depth = 0;
+            break;
+        }
+        this.depth +=1;
+        break;
+      default:
+        this.depth=1;
+        this.goTo(p_id);
+        break;
+    }
+}
+

=== added file 'js/spinningwheel.js'
--- js/spinningwheel.js	1970-01-01 00:00:00 +0000
+++ js/spinningwheel.js	2011-01-26 02:48:39 +0000
@@ -0,0 +1,493 @@
+/**
+ * 
+ * Find more about the Spinning Wheel function at
+ * http://cubiq.org/spinning-wheel-on-webkit-for-iphone-ipod-touch/11
+ *
+ * Copyright (c) 2009 Matteo Spinelli, http://cubiq.org/
+ * Released under MIT license
+ * http://cubiq.org/dropbox/mit-license.txt
+ * 
+ * Version 1.4 - Last updated: 2009.07.09
+ * 
+ */
+
+var SpinningWheel = {
+	cellHeight: 44,
+	friction: 0.003,
+	slotData: [],
+
+
+	/**
+	 *
+	 * Event handler
+	 *
+	 */
+
+	handleEvent: function (e) {
+		if (e.type == 'touchstart') {
+			this.lockScreen(e);
+			if (e.currentTarget.id == 'sw-cancel' || e.currentTarget.id == 'sw-done') {
+				this.tapDown(e);
+			} else if (e.currentTarget.id == 'sw-frame') {
+				this.scrollStart(e);
+			}
+		} else if (e.type == 'touchmove') {
+			this.lockScreen(e);
+			
+			if (e.currentTarget.id == 'sw-cancel' || e.currentTarget.id == 'sw-done') {
+				this.tapCancel(e);
+			} else if (e.currentTarget.id == 'sw-frame') {
+				this.scrollMove(e);
+			}
+		} else if (e.type == 'touchend') {
+			if (e.currentTarget.id == 'sw-cancel' || e.currentTarget.id == 'sw-done') {
+				this.tapUp(e);
+			} else if (e.currentTarget.id == 'sw-frame') {
+				this.scrollEnd(e);
+			}
+		} else if (e.type == 'webkitTransitionEnd') {
+			if (e.target.id == 'sw-wrapper') {
+				this.destroy();
+			} else {
+				this.backWithinBoundaries(e);
+			}
+		} else if (e.type == 'orientationchange') {
+			this.onOrientationChange(e);
+		} else if (e.type == 'scroll') {
+			this.onScroll(e);
+		}
+	},
+
+
+	/**
+	 *
+	 * Global events
+	 *
+	 */
+
+	onOrientationChange: function (e) {
+		window.scrollTo(0, 0);
+		this.swWrapper.style.top = window.innerHeight + window.pageYOffset + 'px';
+		this.calculateSlotsWidth();
+	},
+	
+	onScroll: function (e) {
+		this.swWrapper.style.top = window.innerHeight + window.pageYOffset + 'px';
+	},
+
+	lockScreen: function (e) {
+		e.preventDefault();
+		e.stopPropagation();
+	},
+
+
+	/**
+	 *
+	 * Initialization
+	 *
+	 */
+
+	reset: function () {
+		this.slotEl = [];
+
+		this.activeSlot = null;
+		
+		this.swWrapper = undefined;
+		this.swSlotWrapper = undefined;
+		this.swSlots = undefined;
+		this.swFrame = undefined;
+	},
+
+	calculateSlotsWidth: function () {
+		var div = this.swSlots.getElementsByTagName('div');
+		for (var i = 0; i < div.length; i += 1) {
+			this.slotEl[i].slotWidth = div[i].offsetWidth;
+		}
+	},
+
+	create: function () {
+		var i, l, out, ul, div;
+
+		this.reset();	// Initialize object variables
+
+		// Create the Spinning Wheel main wrapper
+		div = document.createElement('div');
+		div.id = 'sw-wrapper';
+		div.style.top = window.innerHeight + window.pageYOffset + 'px';		// Place the SW down the actual viewing screen
+		div.style.webkitTransitionProperty = '-webkit-transform';
+		div.innerHTML = '<div id="sw-header"><div id="sw-cancel">Cancel</' + 'div><div id="sw-done">Done</' + 'div></' + 'div><div id="sw-slots-wrapper"><div id="sw-slots"></' + 'div></' + 'div><div id="sw-frame"></' + 'div>';
+
+		document.body.appendChild(div);
+
+		this.swWrapper = div;													// The SW wrapper
+		this.swSlotWrapper = document.getElementById('sw-slots-wrapper');		// Slots visible area
+		this.swSlots = document.getElementById('sw-slots');						// Pseudo table element (inner wrapper)
+		this.swFrame = document.getElementById('sw-frame');						// The scrolling controller
+
+		// Create HTML slot elements
+		for (l = 0; l < this.slotData.length; l += 1) {
+			// Create the slot
+			ul = document.createElement('ul');
+			out = '';
+			for (i in this.slotData[l].values) {
+				out += '<li>' + this.slotData[l].values[i] + '<' + '/li>';
+			}
+			ul.innerHTML = out;
+
+			div = document.createElement('div');		// Create slot container
+			div.className = this.slotData[l].style;		// Add styles to the container
+			div.appendChild(ul);
+	
+			// Append the slot to the wrapper
+			this.swSlots.appendChild(div);
+			
+			ul.slotPosition = l;			// Save the slot position inside the wrapper
+			ul.slotYPosition = 0;
+			ul.slotWidth = 0;
+			ul.slotMaxScroll = this.swSlotWrapper.clientHeight - ul.clientHeight - 86;
+			ul.style.webkitTransitionTimingFunction = 'cubic-bezier(0, 0, 0.2, 1)';		// Add default transition
+			
+			this.slotEl.push(ul);			// Save the slot for later use
+			
+			// Place the slot to its default position (if other than 0)
+			if (this.slotData[l].defaultValue) {
+				this.scrollToValue(l, this.slotData[l].defaultValue);	
+			}
+		}
+		
+		this.calculateSlotsWidth();
+		
+		// Global events
+		document.addEventListener('touchstart', this, false);			// Prevent page scrolling
+		document.addEventListener('touchmove', this, false);			// Prevent page scrolling
+		window.addEventListener('orientationchange', this, true);		// Optimize SW on orientation change
+		window.addEventListener('scroll', this, true);				// Reposition SW on page scroll
+
+		// Cancel/Done buttons events
+		document.getElementById('sw-cancel').addEventListener('touchstart', this, false);
+		document.getElementById('sw-done').addEventListener('touchstart', this, false);
+
+		// Add scrolling to the slots
+		this.swFrame.addEventListener('touchstart', this, false);
+	},
+
+	open: function () {
+		this.create();
+
+		this.swWrapper.style.webkitTransitionTimingFunction = 'ease-out';
+		this.swWrapper.style.webkitTransitionDuration = '400ms';
+		this.swWrapper.style.webkitTransform = 'translate3d(0, -260px, 0)';
+	},
+	
+	
+	/**
+	 *
+	 * Unload
+	 *
+	 */
+
+	destroy: function () {
+		this.swWrapper.removeEventListener('webkitTransitionEnd', this, false);
+
+		this.swFrame.removeEventListener('touchstart', this, false);
+
+		document.getElementById('sw-cancel').removeEventListener('touchstart', this, false);
+		document.getElementById('sw-done').removeEventListener('touchstart', this, false);
+
+		document.removeEventListener('touchstart', this, false);
+		document.removeEventListener('touchmove', this, false);
+		window.removeEventListener('orientationchange', this, true);
+		window.removeEventListener('scroll', this, true);
+		
+		this.slotData = [];
+		this.cancelAction = function () {
+			return false;
+		};
+		
+		this.cancelDone = function () {
+			return true;
+		};
+		
+		this.reset();
+		
+		document.body.removeChild(document.getElementById('sw-wrapper'));
+	},
+	
+	close: function () {
+		this.swWrapper.style.webkitTransitionTimingFunction = 'ease-in';
+		this.swWrapper.style.webkitTransitionDuration = '400ms';
+		this.swWrapper.style.webkitTransform = 'translate3d(0, 0, 0)';
+		
+		this.swWrapper.addEventListener('webkitTransitionEnd', this, false);
+	},
+
+
+	/**
+	 *
+	 * Generic methods
+	 *
+	 */
+
+	addSlot: function (values, style, defaultValue) {
+		if (!style) {
+			style = '';
+		}
+		
+		style = style.split(' ');
+
+		for (var i = 0; i < style.length; i += 1) {
+			style[i] = 'sw-' + style[i];
+		}
+		
+		style = style.join(' ');
+
+		var obj = { 'values': values, 'style': style, 'defaultValue': defaultValue };
+		this.slotData.push(obj);
+	},
+
+	getSelectedValues: function () {
+		var index, count,
+		    i, l,
+			keys = [], values = [];
+
+		for (i in this.slotEl) {
+			// Remove any residual animation
+			//this.slotEl[i].removeEventListener('webkitTransitionEnd', this, false);
+			//this.slotEl[i].style.webkitTransitionDuration = '0';
+
+			if (this.slotEl[i].slotYPosition > 0) {
+				this.setPosition(i, 0);
+			} else if (this.slotEl[i].slotYPosition < this.slotEl[i].slotMaxScroll) {
+				this.setPosition(i, this.slotEl[i].slotMaxScroll);
+			}
+
+			index = -Math.round(this.slotEl[i].slotYPosition / this.cellHeight);
+
+			count = 0;
+			for (l in this.slotData[i].values) {
+				if (count == index) {
+					keys.push(l);
+					values.push(this.slotData[i].values[l]);
+					break;
+				}
+				
+				count += 1;
+			}
+		}
+
+		return { 'keys': keys, 'values': values };
+	},
+
+
+	/**
+	 *
+	 * Rolling slots
+	 *
+	 */
+
+	setPosition: function (slot, pos) {
+		this.slotEl[slot].slotYPosition = pos;
+		this.slotEl[slot].style.webkitTransform = 'translate3d(0, ' + pos + 'px, 0)';
+	},
+	
+	scrollStart: function (e) {
+		// Find the clicked slot
+		var xPos = e.targetTouches[0].clientX - this.swSlots.offsetLeft;	// Clicked position minus left offset (should be 11px)
+
+		// Find tapped slot
+		var slot = 0;
+		for (var i = 0; i < this.slotEl.length; i += 1) {
+			slot += this.slotEl[i].slotWidth;
+			
+			if (xPos < slot) {
+				this.activeSlot = i;
+				break;
+			}
+		}
+
+		// If slot is readonly do nothing
+		if (this.slotData[this.activeSlot].style.match('readonly')) {
+			this.swFrame.removeEventListener('touchmove', this, false);
+			this.swFrame.removeEventListener('touchend', this, false);
+			return false;
+		}
+
+		this.slotEl[this.activeSlot].removeEventListener('webkitTransitionEnd', this, false);	// Remove transition event (if any)
+		this.slotEl[this.activeSlot].style.webkitTransitionDuration = '0';		// Remove any residual transition
+		
+		// Stop and hold slot position
+		var theTransform = window.getComputedStyle(this.slotEl[this.activeSlot]).webkitTransform;
+		theTransform = new WebKitCSSMatrix(theTransform).m42;
+		if (theTransform != this.slotEl[this.activeSlot].slotYPosition) {
+			this.setPosition(this.activeSlot, theTransform);
+		}
+		
+		this.startY = e.targetTouches[0].clientY;
+		this.scrollStartY = this.slotEl[this.activeSlot].slotYPosition;
+		this.scrollStartTime = e.timeStamp;
+
+		this.swFrame.addEventListener('touchmove', this, false);
+		this.swFrame.addEventListener('touchend', this, false);
+		
+		return true;
+	},
+
+	scrollMove: function (e) {
+		var topDelta = e.targetTouches[0].clientY - this.startY;
+
+		if (this.slotEl[this.activeSlot].slotYPosition > 0 || this.slotEl[this.activeSlot].slotYPosition < this.slotEl[this.activeSlot].slotMaxScroll) {
+			topDelta /= 2;
+		}
+		
+		this.setPosition(this.activeSlot, this.slotEl[this.activeSlot].slotYPosition + topDelta);
+		this.startY = e.targetTouches[0].clientY;
+
+		// Prevent slingshot effect
+		if (e.timeStamp - this.scrollStartTime > 80) {
+			this.scrollStartY = this.slotEl[this.activeSlot].slotYPosition;
+			this.scrollStartTime = e.timeStamp;
+		}
+	},
+	
+	scrollEnd: function (e) {
+		this.swFrame.removeEventListener('touchmove', this, false);
+		this.swFrame.removeEventListener('touchend', this, false);
+
+		// If we are outside of the boundaries, let's go back to the sheepfold
+		if (this.slotEl[this.activeSlot].slotYPosition > 0 || this.slotEl[this.activeSlot].slotYPosition < this.slotEl[this.activeSlot].slotMaxScroll) {
+			this.scrollTo(this.activeSlot, this.slotEl[this.activeSlot].slotYPosition > 0 ? 0 : this.slotEl[this.activeSlot].slotMaxScroll);
+			return false;
+		}
+
+		// Lame formula to calculate a fake deceleration
+		var scrollDistance = this.slotEl[this.activeSlot].slotYPosition - this.scrollStartY;
+
+		// The drag session was too short
+		if (scrollDistance < this.cellHeight / 1.5 && scrollDistance > -this.cellHeight / 1.5) {
+			if (this.slotEl[this.activeSlot].slotYPosition % this.cellHeight) {
+				this.scrollTo(this.activeSlot, Math.round(this.slotEl[this.activeSlot].slotYPosition / this.cellHeight) * this.cellHeight, '100ms');
+			}
+
+			return false;
+		}
+
+		var scrollDuration = e.timeStamp - this.scrollStartTime;
+
+		var newDuration = (2 * scrollDistance / scrollDuration) / this.friction;
+		var newScrollDistance = (this.friction / 2) * (newDuration * newDuration);
+		
+		if (newDuration < 0) {
+			newDuration = -newDuration;
+			newScrollDistance = -newScrollDistance;
+		}
+
+		var newPosition = this.slotEl[this.activeSlot].slotYPosition + newScrollDistance;
+
+		if (newPosition > 0) {
+			// Prevent the slot to be dragged outside the visible area (top margin)
+			newPosition /= 2;
+			newDuration /= 3;
+
+			if (newPosition > this.swSlotWrapper.clientHeight / 4) {
+				newPosition = this.swSlotWrapper.clientHeight / 4;
+			}
+		} else if (newPosition < this.slotEl[this.activeSlot].slotMaxScroll) {
+			// Prevent the slot to be dragged outside the visible area (bottom margin)
+			newPosition = (newPosition - this.slotEl[this.activeSlot].slotMaxScroll) / 2 + this.slotEl[this.activeSlot].slotMaxScroll;
+			newDuration /= 3;
+			
+			if (newPosition < this.slotEl[this.activeSlot].slotMaxScroll - this.swSlotWrapper.clientHeight / 4) {
+				newPosition = this.slotEl[this.activeSlot].slotMaxScroll - this.swSlotWrapper.clientHeight / 4;
+			}
+		} else {
+			newPosition = Math.round(newPosition / this.cellHeight) * this.cellHeight;
+		}
+
+		this.scrollTo(this.activeSlot, Math.round(newPosition), Math.round(newDuration) + 'ms');
+ 
+		return true;
+	},
+
+	scrollTo: function (slotNum, dest, runtime) {
+		this.slotEl[slotNum].style.webkitTransitionDuration = runtime ? runtime : '100ms';
+		this.setPosition(slotNum, dest ? dest : 0);
+
+		// If we are outside of the boundaries go back to the sheepfold
+		if (this.slotEl[slotNum].slotYPosition > 0 || this.slotEl[slotNum].slotYPosition < this.slotEl[slotNum].slotMaxScroll) {
+			this.slotEl[slotNum].addEventListener('webkitTransitionEnd', this, false);
+		}
+	},
+	
+	scrollToValue: function (slot, value) {
+		var yPos, count, i;
+
+		this.slotEl[slot].removeEventListener('webkitTransitionEnd', this, false);
+		this.slotEl[slot].style.webkitTransitionDuration = '0';
+		
+		count = 0;
+		for (i in this.slotData[slot].values) {
+			if (i == value) {
+				yPos = count * this.cellHeight;
+				this.setPosition(slot, yPos);
+				break;
+			}
+			
+			count -= 1;
+		}
+	},
+	
+	backWithinBoundaries: function (e) {
+		e.target.removeEventListener('webkitTransitionEnd', this, false);
+
+		this.scrollTo(e.target.slotPosition, e.target.slotYPosition > 0 ? 0 : e.target.slotMaxScroll, '150ms');
+		return false;
+	},
+
+
+	/**
+	 *
+	 * Buttons
+	 *
+	 */
+
+	tapDown: function (e) {
+		e.currentTarget.addEventListener('touchmove', this, false);
+		e.currentTarget.addEventListener('touchend', this, false);
+		e.currentTarget.className = 'sw-pressed';
+	},
+
+	tapCancel: function (e) {
+		e.currentTarget.removeEventListener('touchmove', this, false);
+		e.currentTarget.removeEventListener('touchend', this, false);
+		e.currentTarget.className = '';
+	},
+	
+	tapUp: function (e) {
+		this.tapCancel(e);
+
+		if (e.currentTarget.id == 'sw-cancel') {
+			this.cancelAction();
+		} else {
+			this.doneActionFunction(this.doneActionValues);
+		}
+		
+		this.close();
+	},
+
+	setCancelAction: function (action) {
+		this.cancelAction = action;
+	},
+
+	setDoneAction: function (action,values) {
+		this.doneActionFunction = action;
+		this.doneActionValues = values;
+	},
+	
+	cancelAction: function () {
+		return false;
+	},
+
+	cancelDone: function () {
+		return true;
+	}
+};

=== modified file 'js/window.js'
--- js/window.js	2010-08-04 06:30:21 +0000
+++ js/window.js	2011-01-26 02:48:39 +0000
@@ -391,30 +391,32 @@
     }
 }
 /**PinchZoom 
- * Zooming x and y -axis when using Safari webkit browser on a touchdevice.
+ * Zooming x and y -axis when using Safari webkit browser on a touchdevice. So far twofinger gestures are only possible with Apples iPhone, iPad, iPod. Android devices don´t support that feature yet.
  */
 WINDOW.prototype.PinchZoom = function(values) {
+  var iphone = isiPhone();
+  var ipad = isiPad();
 
-  if(values.device == "iPhone")
+  if(iphone)
   {
     var scale_min = 0.34;
     var scale_max = 3.5;
   }
-  if(values.device == "iPad"){
+  if(ipad){
      var scale_min = 0.26;
      var scale_max = 10;
   }
-  if(values.device != "undefined"){
+  
+  if(values.device) {
 
     if(values.scale > scale_max){ values.scale = scale_max;}
  
     if(values.startX > values.marginsLeft) {  
-         var xmin = this.graph.xmin;
-         var xmax = this.graph.xmax;
-         var xzoomedmin =  values.startX;
+
          if(values.scale > 1){
-            var xzoomedmax = adeiMathPreciseAdd(xzoomedmin,(xmax-xzoomedmin)/scale_max*(values.scale));
-            this.SetCustomWindow(xzoomedmin,xzoomedmax);
+            var xmin = values.x;
+            var xmax = adeiMathPreciseAdd(xmin,(this.graph.xmax-xmin)/scale_max*values.scale);
+            this.SetCustomWindow(xmin, xmax);
           }
           if(values.scale < 1){
             this.CenterZoomOut();

=== modified file 'module.php'
--- module.php	2009-09-25 16:49:05 +0000
+++ module.php	2011-01-26 02:48:39 +0000
@@ -12,13 +12,14 @@
     $separator_flag = 0;
 
     foreach (($list===false)?$MODULES:$list as $module) {
-        if ($separator_flag) echo " | ";
-        else $separator_flag = 1;
+	if ($separator_flag) echo " | ";
+	else $separator_flag = 1;
 
 	if (strcmp($config_module, $module)) $css = "module_link";
 	else $css = "module_link_current";
-	
-        echo "<a class=\"$css\" id=\"module_link_$module\" href=\"javascript:adei.OpenModule('$module')\">";
+		
+	echo "<a class=\"$css\" id=\"module_link_$module\" href=\"javascript:adei.OpenModule('$module')\">";
+		
 	if (isset($GLOBALS[$module . "_title"])) echo $GLOBALS[$module . "_title"];
 	else echo $module;
 	echo "</a>";

=== modified file 'modules/graph.php'
--- modules/graph.php	2008-04-20 05:22:25 +0000
+++ modules/graph.php	2011-01-26 02:48:39 +0000
@@ -3,20 +3,29 @@
 $graph_title = _("Graph");
 
 function graphJS() {
+    global $ADEI_MODE;
     global $GRAPH_MARGINS;
     global $GRAPH_SELECTION;
+	
 ?>
     zeus_graph = new GRAPH("graph_image_div", "graph_selector_div");
     zeus_graph.SetMargins(<?echo $GRAPH_MARGINS['left'] . "," . $GRAPH_MARGINS['top'] . "," . $GRAPH_MARGINS['right'] . "," .$GRAPH_MARGINS['bottom']?>);
     zeus_graph.SetAllSizes(<?echo $GRAPH_SELECTION['min_width'] . "," . $GRAPH_SELECTION['min_height']?>);
     adei.AttachGraphModule(zeus_graph);
-
-<?
+<?
+    if ($ADEI_MODE == "iAdei") {
+?>    
+    graph_control = new GRAPHCONTROL("shadow","show_controls_div","imgdiv",zeus_graph,"graphimg","emailform","sensorlist");
+		
+<?
+    }
     return "zeus_graph";
 }
 
 
 function graphPage() {
+    global $ADEI_MODE;
+    
 /*    <div id="graph_selector_div" class="selector">selector1</div>*/
 ?>
 <table width="100%" <?/*height="100%"*/?> cellspacing="0" cellpadding="0"><tr><td>
@@ -25,5 +34,36 @@
 	<img id="graph_image" alt="Loading..."/>
 	<?/* onMouseDown="zeus_graph.MouseStart(event)" onMouseUp="zeus_graph.MouseDone(event)" onMouseMove="zeus_graph.MouseVisualize(event)" onClick="zeus_graph.MouseStart()"/>*/?>
     </div>
+<?
+    if ($ADEI_MODE == "iAdei") {
+?>
+	<div class="show_controls_div" id="show_controls_div">
+	</div>
+	<div id="shadow">
+		<table>
+			<tr><td></td><td><button onclick="graph_control.UseWindow('moveup');">Move Up</button></td><td></td></tr>
+			<tr><td><button onclick="graph_control.UseWindow('moveleft');">Move Left</button></td><td><button onclick="graph_control.UseWindow('movedown');">Move Down</button></td><td><button onclick="graph_control.UseWindow('moveright');">Move Right</button></td></tr>
+		</table>
+		<table>
+		 	<tr><td><button onclick="graph_control.UseWindow('centerzoomin');">Zoom in</button></td></tr>
+		 	<tr><td><button onclick="graph_control.UseWindow('centerzoomout');">Zoom out</button></td></tr>
+			<tr><td><button onclick="graph_control.genIMG();">Send Graph as email </button></td></tr>
+			<tr><td><button onclick="graph_control.getSensors();">Show Legend </button></td></tr>
+		</table>
+		<button onclick="adei.updater.Update();">Reload graph </button>
+	</div>
+	<div id="imgdiv">
+		<button onclick="graph_control.openMailForm();">Send as email</button>
+		<button onclick="graph_control.closediv('imgdiv');">Close</button>
+		<img src="images/blank.png" id="graphimg"/>
+	</div>
+	<div id="emailform">
+	</div>
+	<div id="sensorlist">
+	</div>
+<?
+    }
+?>
 </td></tr></table>
+
 <?}?>
\ No newline at end of file

=== added file 'modules/settings.php'
--- modules/settings.php	1970-01-01 00:00:00 +0000
+++ modules/settings.php	2011-01-26 02:48:39 +0000
@@ -0,0 +1,21 @@
+<?php
+$settings_title = _("Settings");
+
+function settingsJS() {
+?> 
+    settings = new XMLMODULE("settings_div");
+    settings.EnableJS();
+    settings.SetModuleType(CONTROL_MODULE_TYPE);
+    adei.RegisterCustomProperty("p_id","main");
+    searcher = new SEARCH("settings","searchresults");
+<?    
+    return "settings";
+}
+
+
+function settingsPage() {
+?>
+    <div id="settings_div" class="xml_module">Loading...
+    <div id="searchresults"></div>
+    </div>
+<?}?>
\ No newline at end of file

=== modified file 'modules/source.php'
--- modules/source.php	2009-02-10 13:16:11 +0000
+++ modules/source.php	2011-01-26 02:48:39 +0000
@@ -2,6 +2,7 @@
 $source_title = _("Data Source");
 
 function sourceJS() {
+    global $ADEI_MODE;
     global $config_options;
     global $SOURCE_KEEP_WINDOW;
     
@@ -76,7 +77,7 @@
     source = new SOURCE(source_interval, "source_db_server_sel", "source_db_name_sel", "source_db_group_sel","source_c_group_sel",  "source_db_mask_sel", "source_db_item_sel", "source_apply_button", source_opts);
 
     adei.AttachSourceModule(source, source_interval, source_window);
-
+	
     if (adei.popup) {
         source.RegisterGeometryCallback(moduleUpdateGeometry, source_modules);
 	if (isIE()||client.isKonqueror()) {
@@ -87,6 +88,11 @@
 	}
     }
 <?
+    if ($ADEI_MODE == "iAdei") {
+?>
+    settingmodule = new SETTINGS(source_window);
+<?
+    }
 }
 
 function sourcePage() {
@@ -123,7 +129,7 @@
 	    <td id="source_timestart"><div class="hide_experiment_custom">
 		<input type="text" id="source_timestart_inp" maxlength="25" onchange="javascript:source_window.UpdateRange()"/>
 		<a href="javascript:NewCal('source_timestart_inp','mmmddyyyy',true,24,windowUpdateRangeFunction(source_window))">
-		    <img src="images/cal.gif"/>
+		    <img src="images/cal.png"/>
 		</a>
 	    </div></td>
 	</tr><tr>
@@ -131,7 +137,7 @@
 	    <td id="source_timeend"><div class="hide_experiment_custom">
 		<input type="text" id="source_timeend_inp" maxlength="25" onchange="javascript:source_window.UpdateRange()"/>
 		<a href="javascript:NewCal('source_timeend_inp','mmmddyyyy',true,24,windowUpdateRangeFunction(source_window))">
-		    <img src="images/cal.gif"/>
+		    <img src="images/cal.png"/>
 		</a>
 	    </div></td>
 	</tr><tr>
@@ -141,7 +147,7 @@
 	    <td id="source_winstart"><div class="hide_window_custom">
 		<input type="text" id="source_winstart_inp" maxlength="31" onchange="javascript:source_window.UpdateRange()"/>
 		<a href="javascript:NewCal('source_winstart_inp','mmmddyyyy',true,24,windowUpdateRangeFunction(source_window))">
-		    <img src="images/cal.gif"/>
+		    <img src="images/cal.png"/>
 		</a>
 	    </div></td>
 	</tr><tr>
@@ -149,7 +155,7 @@
 	    <td id="source_winend"><div class="hide_window_custom">
 		<input type="text" id="source_winend_inp" maxlength="31" onchange="javascript:source_window.UpdateRange()" />
 		<a href="javascript:NewCal('source_winend_inp','mmmddyyyy',true,24,windowUpdateRangeFunction(source_window));">
-		    <img src="images/cal.gif"/>
+		    <img src="images/cal.png"/>
 		</a>
 	    </div></td>
 	</tr></table>

=== added file 'services/email.php'
--- services/email.php	1970-01-01 00:00:00 +0000
+++ services/email.php	2011-01-26 02:48:39 +0000
@@ -0,0 +1,110 @@
+<?php
+header("Content-type: text/xml");
+header("Cache-Control: no-cache, must-revalidate");
+header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
+
+//require("../classes/email.php");
+
+global $ADEI;
+global $ADEI_ROOTDIR;
+$ADEI->RequireClass("email");
+$EMAIL = new EMAIL();
+
+function genEmailContent($props) {
+    $host = $_SERVER['HTTP_HOST'];
+    $location = $props['url'];
+    $query;
+    $i=1;
+    foreach($props as $key => $value)
+    {
+        if ($key != 'from' && $key != 'to' && $key != 'message' && $key != 'attachement' && $key != 'adei_session' && $key != 'task' && $key != 'service' && $key != 'url') {
+            $query .= "&". $key . "=" . $value;
+        }
+    }
+    $filearray = explode('/',$props['attachement']);
+    $file = $filearray[count($file)-1];
+    $url ="$location". "#" ."$query";
+    $message = "<html><head><title>Adei Graph</title></head><body><p>";
+    $message .= "<p>". $props['message'] ."</p>";
+    $message .= "<p><a href='". $url ."'>Link to Graph</a></p>";
+    $message .= "<p><img src='$file' /></p>";
+    $message .="</body></html>";
+    return $message;
+}
+
+if (isset($_GET['task'])) {
+    switch ($_GET['task']) {
+      case "Send":
+        if (isset($_GET['to']) && isset($_GET['message']) && isset($_GET['from']) && isset($_GET['attachement'])) {
+            $mail = $_GET['to'];
+            $path = $_GET['attachement'];
+            $from = $_GET['from'];
+            foreach($_GET as $key => $value)
+            {
+                $props[$key] = $value;
+            }
+            $msg = genEmailContent($props);
+            $vlues = array('email' => $mail, 'message'=>$msg, 'attachement'=>$path, 'from' => $from);
+            $result = $EMAIL->sendMail($vlues);
+            echo $result;
+            if ($result != 'phpmailerException' || $result != 'exception') unlink($path);
+        }
+        break;
+      case "genpic":
+        $pic .= $_GET['picname'];
+        foreach($_GET as $key => $value)
+        {
+            $props[$key] = $value;
+        }
+        $r = $EMAIL->createFolder();
+        if ($r!="Success") echo "FAIL";
+        else {
+            $result = $EMAIL->createPNG($props);
+            if ($result!="FAILED") echo $ADEI_ROOTDIR ."". $result;
+            else echo "FAIL";
+        }
+        break;
+      case "getSensorList":
+        foreach($_GET as $key => $value) {
+            $opts[$key]= $value;
+        }
+        $details = $EMAIL->listSensors($opts);
+        $return = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><result>";
+        if ($error = $details['error'])
+        {
+            $return .= "<value>". $details['error'] ."</value>";
+        }
+        else {
+//				$return .= "<value>Success</value></result>";
+            foreach($details['groups'] as $gid => $itemlist) {
+                $return .= "<value><groupname>". $gid ."</groupname>";
+                foreach($itemlist as $item => $info) {
+                    $return .= "<item><itemid>". $info['id'] ."</itemid><itemname>". $info['name'] ."</itemname></item>";
+                }
+                $return .= "</value>";
+            }
+        }
+        $return .="</result>";
+        echo $return;
+        break;
+      default:
+        $return = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><result>";
+        $return .= "<heading>Emaili</heading>";
+        $return .= "<value name='From' id='from'/>";
+        $return .= "<value name='Recipient' id='tomail'/>";
+        $return .= "<value name='Message' id='message'/>";
+        $return .= "<value name=\"$result\" id='ressu'/>";
+        $return .= "</result>";
+        echo $return;
+        break;
+    }
+} else {
+    $return = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><result>";
+    $return .= "<heading>Email</heading>";
+    $return .= "<value name='From' id='from'/>";
+    $return .= "<value name='Recipient' id='tomail'/>";
+    $return .= "<value name='Message' id='message'/>";
+    $return .= "</result>";
+    echo $return;
+}
+?>
\ No newline at end of file

=== added file 'services/settings.php'
--- services/settings.php	1970-01-01 00:00:00 +0000
+++ services/settings.php	2011-01-26 02:48:39 +0000
@@ -0,0 +1,80 @@
+<?php
+header("Content-type: text/xml");
+header("Cache-Control: no-cache, must-revalidate");
+header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
+
+	
+//Commented lines are missing properties still to be added.
+
+	$return = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><result>";
+
+	if(isset($_GET['p_id'])){
+		$page = $_GET['p_id'];
+	 	switch($page){
+			case "main":				
+				$return .= "<history></history>";
+				$return .= "<heading>Main</heading>";
+				$return .= "<page>p_id=main</page>";
+				$return .= "<value name='Data Source' page='p_id=sourcefront'/>";		
+				$return .= "<value name='Controls' page='p_id=controls'/>";		
+				//$return .= "<value name='Current' page='p_id=sourcefront'/>";		
+				break;
+			case "controls":
+				$return .= "<history>p_id=main</history>";
+				$return .= "<heading>Controls</heading>";
+				$return .= "<page>p_id=controls</page>";
+				//$return .= "<value name='Export' page='p_id=controlsexp'/>";
+				$return .= "<value name='Aggregator' page='p_id=controlsaggr'/>";
+				$return .= "<value name='Search' page='p_id=controlssearch'/>";
+				break;
+			case "controlssearch":
+				$return .= "<history>p_id=controls</history>";
+				$return .= "<heading>Search</heading>";
+				$return .= "<page>controlssearch</page>";
+				break;
+			case "sourcefront":
+				$return .= "<history>p_id=main</history>";
+				$return .= "<heading>Data Source</heading>";
+				$return .= "<page>p_id=sourcefront</page>";
+				$return .= "<value name='Source' page='p_id=sourceselect'/>";
+				$return .= "<value name='Time' page='p_id=sourcetime'/>";
+			//	$return .= "<value name='Axes' page='p_id=sourceaxes'/>";
+				break;
+			case "sourcetime":
+				$return .= "<history>p_id=sourcefront</history>";
+				$return .= "<heading>Time</heading>";
+				$return .= "<page>p_id=sourcetime</page>";
+				$return .= "<value name='Custom' page='p_id=sourcetimecustom'/>";
+				$return .= "<value name='Window' page='p_id=sourcetimewindow'/>";
+				break;
+			case "sourcetimecustom":
+				$return .= "<history>p_id=sourcetime</history>";
+				$return .= "<heading>CustomTime</heading>";
+				$return .= "<page>p_id=sourcetimecustom</page>";
+				break;
+			case "sourcetimewindow":
+				$return .= "<history>p_id=sourcetime</history>";
+				$return .="<heading>Window</heading>";
+				$return .= "<page>p_id=sourcetimewindow</page>";
+				$return .= "<value window='window=31536000' name='1 Year' />";
+				$return .= "<value window='window=2592000' name='1 Month' />";
+				$return .= "<value window='window=604800' name='1 Week' />";
+				$return .= "<value window='window=86400' name='1 Day' />";
+				$return .= "<value window='window=3600' name='1 Hour' />";
+				break;
+			default: 	
+				$return .= "<history>p_id=main</history>";
+				$return .= "<heading>ERROR</heading>";
+	  			$return .= "<value name='Invalid pageid' page = 'p_id=main'/>";						
+				break;
+		}
+	} else {
+		$return .= "<history></history>";
+		$return .= "<heading>Main</heading>";
+		$return .= "<value name='Data Source' page='p_id=sourcefront'/>";		
+		$return .= "<value name='Controls' page='p_id=controls'/>";		
+		$return .= "<value name='Current' page='p_id=sourcefront'/>";	
+	}
+	$return .= "</result>";
+	echo $return;
+?>
\ No newline at end of file

=== added file 'services/update/settings.php'
--- services/update/settings.php	1970-01-01 00:00:00 +0000
+++ services/update/settings.php	2011-01-26 02:48:39 +0000
@@ -0,0 +1,9 @@
+<?php
+function ADEIServiceGetUpdateInfo(REQUEST $req) {
+    $query = $req->GetQueryString(); 
+    return array(
+	"xml" => "services/" . $req->props['module'] . ".php?$query",
+	"xslt" => "settings"
+    );
+}
+?>
\ No newline at end of file

=== added file 'xslt/email.xsl'
--- xslt/email.xsl	1970-01-01 00:00:00 +0000
+++ xslt/email.xsl	2011-01-26 02:48:39 +0000
@@ -0,0 +1,24 @@
+<?xml version="1.0" encoding="utf-8"?>
+<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
+ <xsl:output method="html" encoding="utf-8"/>
+<xsl:template match="result">
+  <div class = "emailform">
+  <div class="emailheading"><table class="headingtable"><tr><td><h1><xsl:value-of select="heading"/></h1></td></tr></table>
+  </div>
+  <div class="emailcontent">
+  <table>
+  	<xsl:for-each select="value">
+  		<xsl:if test="string(@name)!='Message'">
+		  	<tr><td><xsl:value-of select='@name'/></td><td><input type='text' style="width:100%"><xsl:attribute name="id"><xsl:value-of select='@id'/></xsl:attribute></input></td></tr>
+  		</xsl:if>
+  		<xsl:if test="string(@name)='Message'">
+  		  	<tr><td><xsl:value-of select='@name'/></td><td><textarea rows='5' style="width:100%"><xsl:attribute name="id"><xsl:value-of select='@id'/></xsl:attribute></textarea></td></tr>
+  		</xsl:if>
+  	</xsl:for-each>
+  		<tr><td><button><xsl:attribute name="onclick">javascript:graph_control.sendEmail();</xsl:attribute>Send e-mail</button></td><td><button><xsl:attribute name="onclick">javascript:graph_control.closediv('emailform');</xsl:attribute>Cancel</button></td></tr>
+  </table>
+  </div>  
+  </div>
+</xsl:template>
+</xsl:stylesheet>
+	 
\ No newline at end of file

=== added file 'xslt/idatetimepicker.xsl'
--- xslt/idatetimepicker.xsl	1970-01-01 00:00:00 +0000
+++ xslt/idatetimepicker.xsl	2011-01-26 02:48:39 +0000
@@ -0,0 +1,57 @@
+<?xml version="1.0" encoding="utf-8"?>
+<xsl:stylesheet version="1.0"  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
+ <xsl:output method="html" encoding="utf-8"/>
+<xsl:template match="result">
+  <div class = "settingspage">
+  <div class="settingsheading"><table class="headingtable"><tr><td><div class="btn"><xsl:attribute name="onclick">javascript:settingmodule.goTo("<xsl:value-of select='history'/>");</xsl:attribute>Back</div></td><td><h1><xsl:value-of select="heading"/></h1></td></tr></table>
+  </div>
+  <div class = "settingscontent">
+ 	<xsl:if test="string(page)='p_id=sourcetimecustom'">
+  		<table>
+  		<tr>
+  		<td><button><xsl:attribute name="onclick">javascript:settingmodule.CreateSpinningWheel("startdate");</xsl:attribute>Start Date</button></td>
+  		<td><button><xsl:attribute name="onclick">javascript:settingmodule.CreateSpinningWheel("starttime");</xsl:attribute>Start Time</button></td>
+  		</tr>
+  		<tr>
+  		<td><input type="text" id="startdate" readonly='readonly'></input></td><td><input type="text" id="starttime" readonly='readonly'></input></td>
+  		</tr>
+  		<tr>
+  		<td><button><xsl:attribute name="onclick">javascript:settingmodule.CreateSpinningWheel("enddate");</xsl:attribute>End Date</button></td>
+  		<td><button><xsl:attribute name="onclick">javascript:settingmodule.CreateSpinningWheel("endtime");</xsl:attribute>End Time</button></td>
+  		</tr>
+  		<tr>
+  		<td><input type="text" id="enddate" readonly='readonly'></input></td><td><input type="text" id="endtime" readonly='readonly'></input></td>
+  		</tr>
+  		<tr><td><button><xsl:attribute name="onclick">javascript:settingmodule.ProcessWindow();</xsl:attribute>Update Window</button></td></tr>
+  		</table>
+	</xsl:if>
+	<xsl:if test="string(page)='p_id=sourcetimewindow'">
+		<ul class='ilist'>
+		<xsl:for-each select="value">
+			<li><xsl:attribute name="onclick">javascript:settingmodule.updateTime("<xsl:value-of select='@window'/>");</xsl:attribute><xsl:value-of select="@name"/></li>
+		</xsl:for-each>
+		</ul>
+	</xsl:if>
+	<xsl:if test="string(page)='controlssearch'">
+		<table>
+		<tr>
+		<td><input type="text" id="searchfield"></input></td><td><button><xsl:attribute name="onclick">javascript:settingmodule.Search();</xsl:attribute>Search</button></td>
+		</tr>
+		</table>
+		<div id="searchresults">
+		</div>
+	</xsl:if>
+	<xsl:if test="string(page)='controlsaggr'">
+		<ul class='ilist'>
+		<xsl:for-each select="Value">
+			<li><xsl:attribute name="onclick">javascript:settingmodule.sendGetRequest("p_id=controlsaggr","<xsl:value-of select='@value'/>");</xsl:attribute><xsl:value-of select='@name' />
+			</li>	
+		</xsl:for-each>
+		</ul>
+	</xsl:if>
+  </div>
+  </div>
+</xsl:template>
+</xsl:stylesheet>
+
+

=== added file 'xslt/sensorlist.xsl'
--- xslt/sensorlist.xsl	1970-01-01 00:00:00 +0000
+++ xslt/sensorlist.xsl	2011-01-26 02:48:39 +0000
@@ -0,0 +1,20 @@
+<?xml version="1.0" encoding="utf-8"?>
+<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
+ <xsl:output method="html" encoding="utf-8"/>
+<xsl:template match="result">
+  <div class = "emailform">
+  	<div class="emailheading"><table class="headingtable"><tr><td><h1>List of Sensors</h1></td></tr></table>
+  </div>
+  	<div class="emailcontent">
+	  <table>
+	  <tr><td>ID</td><td>Name</td></tr>
+		<xsl:for-each select="value/item">
+	  		<tr><td><xsl:value-of select="itemid"/></td><td><xsl:value-of select="itemname"/></td></tr>
+		</xsl:for-each>
+	  		<tr><td><button><xsl:attribute name="onclick">javascript:graph_control.closediv('sensordiv');</xsl:attribute>Close</button></td></tr>
+	  </table>
+	 </div>  
+  </div>
+</xsl:template>
+</xsl:stylesheet>
+	 
\ No newline at end of file

=== added file 'xslt/settings.xsl'
--- xslt/settings.xsl	1970-01-01 00:00:00 +0000
+++ xslt/settings.xsl	2011-01-26 02:48:39 +0000
@@ -0,0 +1,42 @@
+<?xml version="1.0" encoding="utf-8"?>
+<xsl:stylesheet version="1.0"  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
+ <xsl:output method="html" encoding="utf-8"/>
+<xsl:template match="result">
+  <div class = "settingspage">
+  <div class="settingsheading"><table class="headingtable"><tr><td><div class="btn"><xsl:attribute name="onclick">javascript:settingmodule.goTo("<xsl:value-of select='history'/>");</xsl:attribute>Back</div></td><td><h1><xsl:value-of select="heading"/></h1></td></tr></table>
+  </div>
+  <div class = "settingscontent">
+  <xsl:if test="string(page)='controlssearch'">
+		<table>
+		<tr>
+		<td><input type="text" id="searchfield"></input></td><td><button><xsl:attribute name="onclick">javascript:settingmodule.Search();</xsl:attribute>Search</button></td>
+		</tr>
+		</table>
+  </xsl:if>
+  <xsl:if test="string(page) = 'searchresults'">
+  	<xsl:if test="count(//Value)=1">
+	<xsl:if test="//Value[@certain]">
+	    <script type="text/javascript">
+	        adei.SetConfiguration(htmlEntityDecode('<xsl:value-of select="//Value/@props"/>'));
+	    	adei.OpenModule('graph');
+	    </script>
+	</xsl:if>
+      </xsl:if>
+  	<ul class='ilist'>
+  	<xsl:for-each select='module/results/Value'>
+  		<li><xsl:attribute name='onclick'>javascript:settingmodule.goTo('<xsl:value-of select="@props"/>',true);</xsl:attribute><xsl:value-of select='@title'/></li>
+  	</xsl:for-each>
+  	</ul>
+  </xsl:if>
+  <xsl:if test="string(page)!='controlssearch'">
+  	<ul class='ilist'>
+	<xsl:for-each select="value">
+		<li><xsl:attribute name="onclick">javascript:settingmodule.sendGetRequest("<xsl:value-of select='@page'/>","<xsl:value-of select='@value'/>");</xsl:attribute><xsl:value-of select='@name' /></li>
+	</xsl:for-each>
+	</ul>
+  </xsl:if>
+  </div>
+  </div>
+</xsl:template>
+</xsl:stylesheet>
+	 
\ No newline at end of file

=== added file 'xslt/settingsdyn.xsl'
--- xslt/settingsdyn.xsl	1970-01-01 00:00:00 +0000
+++ xslt/settingsdyn.xsl	2011-01-26 02:48:39 +0000
@@ -0,0 +1,26 @@
+<?xml version="1.0" encoding="utf-8"?>
+<xsl:stylesheet version="1.0"  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
+ <xsl:output method="html" encoding="utf-8"/>
+<xsl:template match="result">
+  <div class = "settingspage">
+	<div class = 'settingsheading'>
+		<table class="headingtable"><tr><td><div class="btn"><xsl:attribute name="onclick">javascript:settingmodule.HandleBack("<xsl:value-of select='history'/>");</xsl:attribute>Back</div></td><td><h1><xsl:value-of select="heading"/></h1></td></tr></table>
+	</div>
+	<div class = 'settingscontent'>
+		<ul class='ilist'>
+			<xsl:if test="string(pageid) = 'source'">
+				<xsl:for-each select="Value">
+					<li><xsl:attribute name="onclick">javascript:settingmodule.sendGetRequest("p_id=sourceselect","<xsl:value-of select='@value'/>");</xsl:attribute><xsl:value-of select='@name' /></li>	
+				</xsl:for-each>
+			</xsl:if>
+			<xsl:if test="string(pageid) = 'control'">
+				<xsl:for-each select="Value">
+					<li><xsl:attribute name="onclick">javascript:settingmodule.sendGetRequest("p_id=controlsaggr","<xsl:value-of select='@value'/>");</xsl:attribute><xsl:value-of select='@name' /></li>	
+				</xsl:for-each>
+			</xsl:if>
+		</ul>
+	</div>
+  </div>
+</xsl:template>
+</xsl:stylesheet>
+	
\ No newline at end of file

